/** 
Data class: This class manages the data. 
*/

/**
 * Constructor
 */
Data = function (data)
{
	this.data 		= data;	
}

/**
 * Attributes
 */
Data.prototype.originDestinationYear = null;
Data.prototype.dataDestinitionYear = null;
Data.prototype.dataDifferenceDestinitionYear = null;
Data.prototype.dataOriginYear = null;
Data.prototype.dataDifferenceOriginYear = null;
Data.prototype.dataYear = null;
Data.prototype.dataDifferenceYear= null;
Data.prototype.difference = null; //Used for heatmap

Data.prototype.calcDataStructures = function(colLabel, right_countries, left_countries, col_number)
{
		var obj = this;
		
		//Init Origin => Destinations => Year
		obj.originDestinationYear = new Array(left_countries.length);
		for(var i = 0; i < left_countries.length; i++)
		{
			obj.originDestinationYear[i] = new Array(right_countries.length);
			for(var j = 0; j < right_countries.length; j++)
				obj.originDestinationYear[i][j] = new Array(col_number);
		}	
		
		var helpercs = [];
		colLabel.forEach(function(d, i) {	helpercs[d] = i;	});			
		obj.data.forEach(function(i)
		{							
			var c = helpercs[i.Year];
			if(i.ToKey < obj.originDestinationYear.length && i.FromKey < obj.originDestinationYear[i.ToKey].length)
				obj.originDestinationYear[i.ToKey][i.FromKey][c] = (isNaN(i.Value)) ? 0.0 : i.Value;
		});
}

Data.prototype.calcGrouping = function(colLabel)
{
		var obj = this;
		
		////////////////////
		////////////////////
		// Create Grouping
		////////////////////
		////////////////////		
		obj.dataDestinitionYear = new Array(obj.originDestinationYear[0].length);	
		for(var i = 0; i < obj.dataDestinitionYear.length; i++)
		{
			obj.dataDestinitionYear[i] = new Array(obj.originDestinationYear.length);
			
			for(var k = 0; k < obj.dataDestinitionYear[i].length; k++)
				obj.dataDestinitionYear[i][k] = 0.0;
				
			if(states.auto_calcsum === false)
			{
				data.forEach(function(d)
				{
					if(d.From === "ALL" && d.To !== "ALL")
					{
						i = d.ToKey;
						k = colLabel.indexOf(d.Year);
						obj.dataDestinitionYear[i][k] = d.Value;
					}
				});
			}
			else
			{
				for(var j = 0; j < obj.originDestinationYear.length; j++)
					for(var k = 0; k < obj.originDestinationYear[j][i].length; k++)
						if(isNaN(obj.originDestinationYear[j][i][k]) === false)
							obj.dataDestinitionYear[i][k] = obj.dataDestinitionYear[i][k] + obj.originDestinationYear[j][i][k];		
			}
		}
		
		obj.dataDifferenceDestinitionYear = new Array(obj.dataDestinitionYear.length);
		for(var i = 0; i < obj.dataDestinitionYear.length; i++)
		{
			obj.dataDifferenceDestinitionYear[i] = new Array(obj.dataDestinitionYear[i].length);
			obj.dataDifferenceDestinitionYear[i][0] = 0.0;
			
			for(var j = 1; j < obj.dataDestinitionYear[i].length; j++)
				obj.dataDifferenceDestinitionYear[i][j] = obj.dataDestinitionYear[i][j] - obj.dataDestinitionYear[i][j-1];  
		}
		
		obj.dataYear = new Array(obj.dataDestinitionYear[0].length);
		for(var i = 0; i < obj.dataDestinitionYear[0].length; i++)
			obj.dataYear[i] = 0.0;
		
		obj.dataOriginYear = new Array(obj.originDestinationYear.length);
		for(var i = 0; i < obj.originDestinationYear.length; i++)
		{
			obj.dataOriginYear[i] = new Array(obj.originDestinationYear[i][0].length);
			
			for(var k = 0; k < obj.originDestinationYear[i][0].length; k++)
				obj.dataOriginYear[i][k] = 0.0;
			
			if(states.auto_calcsum === false)
			{
				data.forEach(function(d)
				{
					if(d.To === "ALL")
					{
						if(d.From === "ALL")
						{
							k = colLabel.indexOf(d.Year);
							obj.dataYear[k] = d.Value;							
						}
						else						
						{
							i = d.FromKey;
							k = colLabel.indexOf(d.Year);
							obj.dataOriginYear[i][k] = d.Value;
						}
					}
				});
			}
			else
			{			
				for(var j = 0; j < obj.originDestinationYear[i].length; j++)
					for(var k = 0; k < obj.originDestinationYear[i][j].length; k++)
						if(isNaN(obj.originDestinationYear[i][j][k]) === false)
						{						
							obj.dataOriginYear[i][k] = obj.dataOriginYear[i][k] + obj.originDestinationYear[i][j][k];					
							obj.dataYear[k] = obj.dataYear[k] + obj.originDestinationYear[i][j][k];
						}
			}
		}
		
		//Create Difference: Year 
		obj.dataDifferenceOriginYear = new Array(obj.dataOriginYear.length);
		for(var i = 0; i < obj.dataOriginYear.length; i++)
		{
			obj.dataDifferenceOriginYear[i] = new Array(obj.dataOriginYear[i].length);
			obj.dataDifferenceOriginYear[i][0] = 0.0;
			
			for(var j = 1; j < obj.dataOriginYear[i].length; j++)
				obj.dataDifferenceOriginYear[i][j] = obj.dataOriginYear[i][j] - obj.dataOriginYear[i][j-1];  
		}
		obj.dataDifferenceYear = new Array(obj.dataYear.length);
		obj.dataDifferenceYear[0] = 0.0;
		for(var k = 1; k < obj.dataYear.length; k++)
			obj.dataDifferenceYear[k] = obj.dataYear[k] - obj.dataYear[k-1];
}

Data.prototype.calcDifference = function(right_countries, left_countries, col_number)
{
		var obj = this;
		
		var absolut2 = new Array(right_countries.length * left_countries.length);
		for(var i = 0; i < (right_countries.length * left_countries.length); i++)		
			absolut2[i] = new Array(col_number);
	
		obj.data.forEach(function(d, i)
		{	
			if(d.FromKey < right_countries.length && d.ToKey < left_countries.length)
			{
				if((d.row-1) < absolut2.length 			&& typeof(absolut2[d.row-1]) !== "undefined" 
				&& (d.col-1) < absolut2[d.row-1].length)
					absolut2[d.row-1][d.col-1] = d.Value;	
			}
		});
		
		obj.difference = new Array(right_countries.length * left_countries.length);
		for(var i = 0; i < right_countries.length * left_countries.length; i++)
		{
			if(typeof(absolut2[i]) !== "undefined")
			{	
				obj.difference[i] = new Array(col_number);
				obj.difference[i][0] = 0;
				for(var j = 1; j < col_number; j++)			
					if(typeof(absolut2[i][j]) !== "undefined" && typeof(absolut2[i][j-1]) !== "undefined")			
						obj.difference[i][j] = absolut2[i][j] - absolut2[i][j-1];			
			}
		}
	}
	
Data.prototype.GetMinMax = function(minmax, right_countries, left_countries)
{
		var obj = this;
		
		var min = 0;
		var max = 100;
		if(states.absolut === true)
		{
			if(states.displaystate === 'normal')
			{
				if(obj.data)
				{				
					max = 0;
					obj.data.forEach(function(d){						
						if(isNaN(d.Value) === false && d.FromKey < right_countries.length && d.ToKey < left_countries.length)	
							max = Math.max(max, d.Value);		
					});
				}
			}
			else if(states.displaystate === 'origin')
			{
				if(obj.dataDestinitionYear)
				{				
					max = 0;		
					obj.dataDestinitionYear.forEach(function(d, n){					
						d.forEach(function(e){
							if(isNaN(e) === false)					
								max  = Math.max(max, e);					
						});						
					});
				}
			}
			else if(states.displaystate === 'destinition')
			{
				if(obj.dataOriginYear)
				{
					max = 0;		
					obj.dataOriginYear.forEach(function(d, m){
						d.forEach(function(e, n){								
							if(isNaN(e) === false)					
								max  = Math.max(max, e);					
						});						
					});
				}
			}
			else
			{
				if(obj.dataYear)
				{
					max = 0;		
					obj.dataYear.forEach(function(e){
						if(isNaN(e) === false)					
							max  = Math.max(max, e);					
					});
				}
			}
		}
		else
		{
			if(states.displaystate === 'normal')
			{
				if(obj.difference)
				{	
					max = -500;		
					min = 500;	
					obj.difference.forEach(function(d){
						d.forEach(function(e)
						{
							if(isNaN(e) === false)
							{
								max = Math.max(max, e); 
								min = Math.min(min, e);  		
							}
						});
					});
				}
			}
			else if(states.displaystate === 'origin')
			{
				if(obj.dataDifferenceDestinitionYear)
				{
					max = -500;		
					min = 500;	
					obj.dataDifferenceDestinitionYear.forEach(function(d){
						d.forEach(function(e)
						{
							if(isNaN(e) === false)
							{
								max  = Math.max(max, e);
								min = Math.min(min, e);  		
							}
						});
					});
				}
			}
			else if(states.displaystate === 'destinition')
			{
				if(obj.dataDifferenceOriginYear)
				{
					max = -500;		
					min = 500;	
					obj.dataDifferenceOriginYear.forEach(function(d){
						d.forEach(function(e)
						{
							if(isNaN(e) === false)
							{
								max  = Math.max(max, e);
								min = Math.min(min, e);  		
							}
						});
					});
				}
			}
			else
			{
				if(obj.dataDifferenceYear)
				{
					max = -500;		
					min = 500;	
					obj.dataDifferenceYear.forEach(function(e){
							if(isNaN(e) === false)
							{
								max  = Math.max(max, e);
								min = Math.min(min, e);  		
							}
					});
				}
			}
		}
		minmax[0] = min;
		minmax[1] = max;
	}
