Drawing = function() 
{
	
}	
Drawing.prototype.label = null;
Drawing.prototype.Initialize = function(dots_size_default, dots_size_highlight, text_size_default, text_size_highlight)
{	
	var obj = this;
	
	obj.active_country = obj.GetCountries();	
	
	obj.CalcZoomLevel();		
	obj.zoom.scale(		obj.scale	);
	obj.zoom.translate(	obj.translate);		
	obj.zoom.size([obj.width,states.height]);
	obj.translate_default[0] 	= obj.translate[0];
	obj.translate_default[1] 	= obj.translate[1];
	obj.scale_default		= obj.scale;
	obj.zoom.center([obj.width/2, states.height/2])
	
	obj.ZoomMap(0);			
	
	obj.label = new Label(obj,  dots_size_default, dots_size_highlight, text_size_default, text_size_highlight);
	obj.label.Create();
}		

Drawing.prototype.UpdateActiveCountryArray = function(idname)
{
	var obj = this;
	if(obj.selected_country === false)
	{
		obj.selected_country = true;
		obj.active_country.splice(0);
		obj.active_country.push(idname);
		
		obj.label.UpdateLabelDot(idname, true);					
	}		
	else
	{
		obj.groupingNames.forEach(function(d,i)
		{
			var index = $.inArray(d, obj.active_country);
			if(index !== -1)
			{
				obj.active_country.splice(index, 1);
				obj.groupingGroupStates[i].forEach(function(e) { obj.active_country.push(e);});
			}
		});
		
		var remove_id = $.inArray(idname, obj.active_country);
		if(remove_id === -1)
		{						
			obj.label.UpdateLabelDot(idname, true);
			obj.active_country.push(idname);
			
			obj.groupingGroupStates.forEach(function(d, i)
			{
				if(d.length <= obj.active_country.length)
				{
					var found = 0;
					obj.active_country.forEach(function(e){	found = found + (($.inArray(e, d) !== -1) ? 1 : 0);	});						
					if(found === d.length)
					{
						obj.active_country.splice(0);
						obj.active_country.push(obj.groupingNames[i]);
					}
				}
			});
		}
		else
		{				
			obj.label.UpdateLabelDot(idname, false);			
			obj.active_country.splice(remove_id, 1); 				
			
			if(obj.zoomed === true || obj.active_country.length <= 0)
			{
				obj.reset();
				return;
			}
		}
	}
}
	  
Drawing.prototype.clicked_heatmap = function(idname)
{
	var obj = this;
	if(idname < 0) return;
	
	obj.UpdateActiveCountryArray(idname);
	callOrdering(states.animation_duration);		
			
}

Drawing.prototype.clicked = function(obj, d,i)
{
	if(d && d.properties)
	{
		if(!obj.dictionaryFiles[d.properties.name]) return;
	
		var idname = obj.dictionaryFiles[d.properties.name][obj.map_file];
		if(idname < 0) return;

		obj.UpdateActiveCountryArray(idname);
		
		callOrdering(states.animation_duration);		
	}		
}

Drawing.prototype.doubleClicked = function(obj, dname)
{
	if(!obj.dictionaryFiles[dname])
	{
		obj.reset();
		return;
	};
	
	var idname = obj.dictionaryFiles[dname][0];
	if(idname < 0) return;			
	
	if(obj.selected_country === true) 	
	{
		obj.groupingNames.forEach(function(d,i)
		{
			var index = $.inArray(d, obj.active_country);
			if(index !== -1)
			{
				obj.active_country.splice(index, 1);
				obj.groupingGroupStates[i].forEach(function(e) { obj.active_country.push(e);});
			}
		});	
	
		var delIndex = $.inArray(idname, obj.active_country);
		if(delIndex !== -1)
		{
			obj.reset();
			return;
		}
	}
	else	obj.active_country.splice(0);		
			
	obj.selected_country = true;	
	obj.active_country.push(idname);
	
	obj.CalcZoomLevel();
	obj.zoomed = true;			
	obj.zoom.scale(		obj.scale	);
	obj.zoom.translate(	obj.translate);		
	obj.ZoomMap(states.animation_duration);		

	obj.groupingGroupStates.forEach(function(d, i)
	{
		if(d.length === obj.active_country.length)
		{
			var found = 0;
			obj.active_country.forEach(function(e){	found = found + (($.inArray(e, d) !== -1) ? 1 : 0);	});						
			if(found === d.length)
			{
				obj.active_country.splice(0);
				obj.active_country.push(obj.groupingNames[i]);
			}
		}
	});
	
	callOrdering(states.animation_duration);
	return;
}

Drawing.prototype.doubleClickedHeatmap = function(d, t, rowLabelFrom)
{
	var obj = this;
	
	if(obj.selected_country === false)	obj.active_country.splice(0);
	obj.selected_country = true;
	
	obj.active_country.push(rowLabelFrom[d.row-1]);			
	obj.zoomed=true;
	obj.ZoomInOut(d, t, rowLabelFrom);
}

Drawing.prototype.fit = function()
{	
	var obj = this;
	if(obj.active_country.length <= 0 || (obj.active_country.length === (obj.countries.length-obj.groupingNames.length))) return;
	
	var active_country_cpy = obj.active_country.slice();
	obj.groupingNames.forEach(function(d,i)
	{
		var index = $.inArray(d, obj.active_country);
		if(index !== -1)
		{
			obj.active_country.splice(index, 1);
			obj.groupingGroupStates[i].forEach(function(e) { obj.active_country.push(e);});
		}
	});
	
	obj.CalcZoomLevel();	
	obj.zoomed = true;		
	obj.zoom.scale(obj.scale);
	obj.zoom.translate(obj.translate);		
	obj.ZoomMap(states.animation_duration);		
	
	obj.active_country = active_country_cpy;
	
	if(obj.side === 'L') 	callOrdering(states.animation_duration, false, false, true, false);
	else					callOrdering(states.animation_duration, false, false, false, true);
	return;
}

Drawing.prototype.reset = function() 
{				
	var obj = this;
	
	obj.selected_country = false;
	obj.active_country.forEach(function(d,i){
		obj.g.selectAll(".country"+obj.side+ + d).classed("subunit-boundary-highlight", false);
	});
	
	obj.active_country.splice(0); 
	obj.countries.forEach(function(d){	if($.inArray(obj.dictionaryFiles[d][0], obj.groupingNames) === -1)	obj.active_country.push(obj.dictionaryFiles[d][0]);		});
	
	obj.zoomed = false;
	obj.translate[0] = obj.translate_default[0];
	obj.translate[1] = obj.translate_default[1];
	obj.scale= obj.scale_default;
	obj.zoom.scale(obj.scale);
	obj.zoom.translate(obj.translate);
	
	if(states.animation_duration > 0)	
		obj.g.transition()
			.duration(states.animation_duration)
			.style("opacity", "1.0")
			.attr("transform", "translate(" + obj.translate + ")scale(" + obj.scale + ")");
	else 
		obj.g.style("opacity", "1.0")
			.attr("transform", "translate(" + obj.translate + ")scale(" + obj.scale + ")");

	var t = svg_overall;
	if(states.animation_duration > 0)	t = svg_overall.transition().duration(states.animation_duration);
	t.selectAll(".rowLabel2").style("opacity", "1.0");		
	t.selectAll(".rowLabel").style("opacity", "1.0");												
	t.selectAll(".cell").style("opacity", "1.0");	
		
	if(obj.label) obj.label.UpdateLabelDefault(t);	
	
	callOrdering(states.animation_duration);
}

Drawing.prototype.ZoomMap = function(duration)
{	
	var obj = this;
	
	var t = obj.g.transition().duration(duration);
	t.attr("transform", "translate(" + obj.translate + ")scale(" + obj.scale + ")");					
	
	var s = obj.svg.transition().duration(duration);
	if(obj.label) obj.label.UpdateLabelSelection(s);
}

Drawing.prototype.move = function() 
{		
	var obj = this;
	if(d3.event && d3.event.translate && d3.event.translate !== null) 	obj.translate = d3.event.translate;	
	if(d3.event && d3.event.scale && d3.event.scale !== null) 			obj.scale = d3.event.scale;
	
	obj.zoom.scale(obj.scale);	
	obj.zoom.translate(obj.translate);
		
	obj.g.attr("transform", "translate(" + obj.translate + ")scale(" + obj.scale + ")");
	if(obj.label) obj.label.UpdateLabelSelection(obj.svg);
}

Drawing.prototype.HighlightCountry = function(countryname, color)
{
	var obj = this;
	obj.svg.selectAll(".country"+obj.side+""+(countryname)).style("fill", color);
}

Drawing.prototype.HighlightLabel = function(id1, other)
{
	var obj = this;
	
	if(typeof(other) !== 'undefined' && other === true)
	{		
		obj.countries.forEach(function(d,i)
		{
			d3.select(".label"+obj.side+""+ i).classed("label-highlight", true);
			d3.select(".dot"+obj.side+""+ i).attr("r", obj.label.dots_size_highlight*20.0);
		});
	}
	else
	{
		obj.selectedMap = id1;
		
		d3.select(".label"+obj.side+""+ id1).classed("label-highlight", true);
		d3.select(".dot"+obj.side+""+ id1).attr("r", obj.label.dots_size_highlight*20.0);
		
		var g1 = obj.GetActiveGroups();
		g1.forEach(function(f, j)
		{
			obj.groupingGroupStates[f[1]].forEach(function(e) { 
				d3.select(".label"+obj.side+""+ e).classed("label-highlight", true);
				d3.select(".dot"+obj.side+""+ e).attr("r", obj.label.dots_size_highlight*20.0);
			});
		});
	}
}

Drawing.prototype.DisableHighlightLabel = function(id1, other)
{
	var obj = this;
	
	if(typeof(other) !== 'undefined' && other === true)
	{		
		obj.countries.forEach(function(d,i)
		{
			d3.select(".label"+obj.side+""+ i).classed("label-highlight", false);
			
			if($.inArray(i, obj.active_country) === -1 || obj.selected_country === false)
				d3.select(".dot"+obj.side+""+ i).attr("r", obj.label.dots_size_default*20.0);
		});
	}
	else
	{
		d3.select(".label"+obj.side+""+ id1).classed("label-highlight", false);
		
		if($.inArray(id1, obj.active_country) === -1 || obj.selected_country === false)
			d3.select(".dot"+obj.side+""+ id1).attr("r", obj.label.dots_size_default*20.0);
		
		var g1 = obj.GetActiveGroups();
		g1.forEach(function(f, j)
		{
			obj.groupingGroupStates[f[1]].forEach(function(e) { 
				d3.select(".label"+obj.side+""+ e).classed("label-highlight", false);
				if($.inArray(e, obj.active_country) === -1 || obj.selected_country === false)
					d3.select(".dot"+obj.side+""+ e).attr("r", obj.label.dots_size_default*20.0);
			});
		});
	}
}

Drawing.prototype.DisableHighlightAllCountry = function()
{
	var obj = this;
	obj.countries.forEach(function(e,id){	obj.svg.selectAll(".country"+obj.side+""+id).style("fill", obj.fill_default);	});	
}

Drawing.prototype.GetCountries = function()
{
	var obj = this;
	
	var arr = new Array();
	
	obj.countries.forEach(function(d,i){
		if($.inArray(i, obj.groupingNames) === -1)
			arr.push(i);		
	});
	return  arr;
}

Drawing.prototype.GetAllGroups = function()
{
	return this.groupingNames;
}

Drawing.prototype.GetActiveGroups = function()
{
	var obj = this;
	
	var group = [];
	obj.groupingNames.forEach(function(d,i)
	{
		if($.inArray(d, obj.active_country) !== -1)		
			group.push([d,i]);		
	});
	
	return group;
}

Drawing.prototype.SetToolTip = function(obj, id, name)
{
	if(states.enable_tooltip_map === true)
	{
		var tooltipArray 		= obj.tooltip.GetToolTip(obj.side);
		var tooltipTop3Array 	= obj.tooltip.GetToolTipTop3(obj.side);
	
		if(id < tooltipTop3Array.length)
		{
			d3.select("#tooltip")
				.style("left", (d3.event.pageX+10) + "px")
				.style("top", (d3.event.pageY-10) + "px")
				.select("#value")
				.html(name + ": -  All: " + 
					tooltipArray[id] + "<br/>" +
					tooltipTop3Array[id][0].Country + ": " + tooltipTop3Array[id][0].Result + "<br/>" +
					tooltipTop3Array[id][1].Country + ": " + tooltipTop3Array[id][1].Result + "<br/>" +
					tooltipTop3Array[id][2].Country + ": " + tooltipTop3Array[id][2].Result + " " 
				); 
		}					
		//Show the tooltip
		d3.select("#tooltip").classed("hidden", false);				
	}
}

Drawing.HighlightCountryAllColumn = function(i, year, mapRight, mapLeft)
{	
	if((mapRight && mapRight.active_country.length > 0) || (mapLeft && mapLeft.active_country.length > 0))
	{		
		//TODO DIFFERENCE, ORIGIN, DESTINITION, ALL NOCH KORREKT IMPLEMENTIEREN
		var selR_country = [];
		for(var j = 0; j < mapRight.countries.length; j++)		selR_country[j] = j;
		if(mapRight.active_country.length > 0)					selR_country = mapRight.active_country.slice();				
		
		var selL_country = [];
		for(var j = 0; j < mapLeft.countries.length; j++)		selL_country[j] = j;										
		if(mapLeft.active_country.length > 0)					selL_country = mapLeft.active_country.slice();
		
		var resR = Enumerable.From(dataObj.data).Where(function(x)
				{
					if(selR_country.indexOf(x.FromKey) > -1 && selL_country.indexOf(x.ToKey) > -1 && x.Year === year) 	return true;
					else																				 				return false;							
				}).GroupBy(
					"{ F: $.FromKey}",			//Keys
					(states.absolut === true) ?	"{ V: $.Value }" : "{ V: $.Difference }", 		//Collect
					function (key, group) { return { From: key.F, Result: (isNaN(group.Sum("$.V") === true)) ? 0.0 : group.Sum("$.V")};},
					"$.F"						//Keys Comparefunction
				).ToArray();
		
		var resL = Enumerable.From(dataObj.data).Where(function(x)
				{
					if(selR_country.indexOf(x.FromKey) > -1 && selL_country.indexOf(x.ToKey) > -1 && x.Year === year) 	return true;
					else																		 						return false;							
				}).GroupBy(
					"{ T: $.ToKey}",			//Keys
					(states.absolut === true) ?	"{ V: $.Value }" : "{ V: $.Difference }", 		//Collect
					function (key, group) { return { To: key.T, Result: (isNaN(group.Sum("$.V") === true)) ? 0.0 : group.Sum("$.V")};},
					"$.T"						//Keys Comparefunction
				).ToArray();
				
		if(states.absolut === true) 
		{
			var maxV = 0;
			resL.forEach(function(d){maxV = Math.max(maxV, d.Result)});
			resR.forEach(function(d){maxV = Math.max(maxV, d.Result)});		
			_legend.Update(0, maxV);
			
			resR.forEach(function(c){	
				mapRight.svg.selectAll(".country"+mapRight.side+""+c.From).style("fill", (!colormapSequential) ? "#fff" : colormapSequential.colorScale(c.Result));	
			
				var g1 = mapRight.GetActiveGroups();
				g1.forEach(function(f, j)
				{
					mapRight.groupingGroupStates[f[1]].forEach(function(e) { 
						mapRight.svg.selectAll(".country"+mapRight.side+""+e).style("fill", (!colormapSequential) ? "#fff" : colormapSequential.colorScale(c.Result));	
					});				
				});
			});				
			resL.forEach(function(c){	
				mapLeft.svg.selectAll( ".country"+mapLeft.side+ ""+c.To).style("fill",   (!colormapSequential) ? "#fff" : colormapSequential.colorScale(c.Result));
				
				var g2 = mapLeft.GetActiveGroups();
				g2.forEach(function(f, j)
				{
					mapLeft.groupingGroupStates[f[1]].forEach(function(e) { 
						mapLeft.svg.selectAll(".country"+mapLeft.side+""+e).style("fill", (!colormapSequential) ? "#fff" : colormapSequential.colorScale(c.Result));	
					});				
				});
			});
		}
		else
		{
			var maxV = 0, minV = 9999;
			resL.forEach(function(d){if(isNaN(d.Result) === false){maxV = Math.max(maxV, d.Result); minV = Math.min(minV, d.Result);}});
			resR.forEach(function(d){if(isNaN(d.Result) === false){maxV = Math.max(maxV, d.Result); minV = Math.min(minV, d.Result);}});		
			_legend.Update(minV, maxV);
			
			resR.forEach(function(c){	
				mapRight.svg.selectAll(".country"+mapRight.side+""+c.From).style("fill", (!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(c.Result));	

				var g1 = mapRight.GetActiveGroups();
				g1.forEach(function(f, j)
				{
					mapRight.groupingGroupStates[f[1]].forEach(function(e) { 
						mapRight.svg.selectAll(".country"+mapRight.side+""+e).style("fill", (!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(c.Result));	
					});								
				});
			});				
						
			resL.forEach(function(c){	
				mapLeft.svg.selectAll( ".country"+mapLeft.side+ ""+c.To).style("fill",   (!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(c.Result));	
			
				var g2 = mapLeft.GetActiveGroups();
				g2.forEach(function(f, j)
				{
					mapLeft.groupingGroupStates[f[1]].forEach(function(e) { 
						mapRight.svg.selectAll(".country"+mapRight.side+""+e).style("fill", (!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(c.Result));				
					});				
				});
			});
		}
	}			
	else
	{
		if(states.absolut === true) 
		{
			var maxV = 0;
			resL.forEach(function(d){maxV = Math.max(maxV, d.Result)});
			resR.forEach(function(d){maxV = Math.max(maxV, d.Result)});		
			_legend.Update(0, maxV);
			
			mapRight.countries.forEach(function(country_name,country_id){	mapRight.svg.selectAll(".countryR"+country_id).style("fill", (!colormapSequential) ? "#fff" : colormapSequential.colorScale(dataObj.dataDestinitionYear[country_id][i]));	});					
			mapLeft.countries.forEach(function(country_name,country_id){	mapLeft.svg.selectAll(".countryL"+country_id).style("fill", (!colormapSequential) ? "#fff" : colormapSequential.colorScale(dataObj.dataOriginYear[country_id][i]));	});
		}
		else
		{
			var maxV = 0, minV = 9999;
			resL.forEach(function(d){if(isNaN(d.Result) === false){ maxV = Math.max(maxV, d.Result); minV = Math.min(minV, d.Result);}});
			resR.forEach(function(d){if(isNaN(d.Result) === false){ maxV = Math.max(maxV, d.Result); minV = Math.min(minV, d.Result);}});		
			_legend.Update(minV, maxV);
			
			mapRight.countries.forEach(function(country_name,country_id){	mapRight.svg.selectAll(".countryR"+country_id).style("fill", (!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(dataObj.dataDifferenceDestinitionYear[country_id][i]));	});					
			mapLeft.countries.forEach(function(country_name,country_id){	mapLeft.svg.selectAll(".countryL"+country_id).style("fill", (!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(dataObj.dataDifferenceOriginYear[country_id][i]));		});
		}
	}
}

Drawing.HighlightCountryC = function(d, mapLeft, mapRight)
{
	var g1 = mapRight.GetActiveGroups();
	if(g1.length > 0)
	{
		g1.forEach(function(f, j)
		{
			mapRight.groupingGroupStates[f[1]].forEach(function(e) { 
				if(states.absolut  === true)	mapRight.HighlightCountry(e,  (!colormapSequential) ? "#fff" : colormapSequential.colorScale(d.Value));
				else							mapRight.HighlightCountry(e,  (!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(dataObj.difference[d.row-1][d.col-1]));	
			});
		});
	}
	else
	{
		if(states.absolut  === true)	mapRight.HighlightCountry(d.FromKey,  (!colormapSequential) ? "#fff" : colormapSequential.colorScale(d.Value));
		else							mapRight.HighlightCountry(d.FromKey,  (!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(dataObj.difference[d.row-1][d.col-1]));	
	}
	
	var g2 = mapLeft.GetActiveGroups();
	if(g2.length > 0)
	{
		g2.forEach(function(f, j)
		{
			mapLeft.groupingGroupStates[f[1]].forEach(function(e) { 
				if(states.absolut  === true)	mapLeft.HighlightCountry(e,  (!colormapSequential) ? "#fff" : colormapSequential.colorScale(d.Value));
				else							mapLeft.HighlightCountry(e,  (!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(dataObj.difference[d.row-1][d.col-1]));	
			});
		});
	}
	else
	{
		if(states.absolut  === true)	mapLeft.HighlightCountry(d.ToKey, (!colormapSequential) ? "#fff" : colormapSequential.colorScale(d.Value));
		else							mapLeft.HighlightCountry(d.ToKey, (!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(dataObj.difference[d.row-1][d.col-1]));												
	}
}

Drawing.HighlightCountryCClear = function(d, mapLeft, mapRight)
{
	//Highlight country
	var g1 = mapRight.GetActiveGroups();
	if(g1.length > 0)
	{
		g1.forEach(function(f, j)
		{
			mapRight.groupingGroupStates[f[1]].forEach(function(e) { 
				mapRight.HighlightCountry(e, mapRight.fill_default);
			});
		});
	}
	else
	{
		mapRight.HighlightCountry(d.FromKey,  mapRight.fill_default); 	
	}
	
	var g2 = mapLeft.GetActiveGroups();
	if(g2.length > 0)
	{					
		g2.forEach(function(f, j)
		{
			mapLeft.HighlightCountry(e, mapLeft.fill_default);
		});	
	}
	else
	{
		mapLeft.HighlightCountry(d.ToKey, mapLeft.fill_default);
	}
}

Drawing.HighlightCountryOrigin = function(d, mapLeft, mapRight)
{
	//Highlight country
	if(states.absolut === true)
	{
		for(var j = 0; j < mapLeft.countries.length; j++)
			mapLeft.svg.selectAll(".country"+mapLeft.side+""+j).style("fill",	  		(!colormapSequential) ? "#fff" : colormapSequential.colorScale(dataObj.originDestinationYear[j][d.row-1][d.col-1]));
		mapRight.svg.selectAll(".country"+mapRight.side+""+(d.row-1)).style("fill",	(!colormapSequential) ? "#fff" : colormapSequential.colorScale(d.Value));
		
		var g1 = mapRight.GetActiveGroups();
		g1.forEach(function(f, j)
		{
			mapRight.groupingGroupStates[f[1]].forEach(function(e) { 
				mapRight.svg.selectAll(".country"+mapRight.side+""+e).style("fill",	(!colormapSequential) ? "#fff" : colormapSequential.colorScale(d.Value));
			});
		});
	}
	else
	{
		var id2 = d.row-1;
		var y = d.col-1;
	
		for(var j = 0; j < mapLeft.countries.length; j++)
			mapLeft.svg.selectAll(".country"+mapLeft.side+""+j).style("fill",		(!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(dataObj.difference[j+mapLeft.countries.length+id2][y]));
			//mapLeft.g.selectAll(".country"+mapLeft.side+""+j).style("fill",		(!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(dataObj.dataDifferenceOriginDestinationYear[j][d.row-1][d.col-1]));
		mapRight.svg.selectAll(".country"+mapRight.side+""+(d.row-1)).style("fill",	(!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(dataObj.dataDifferenceDestinitionYear[d.row-1][d.col-1]));
	
		var g1 = mapRight.GetActiveGroups();
		g1.forEach(function(f, j)
		{
			mapRight.groupingGroupStates[f[1]].forEach(function(e) { 
				mapRight.svg.selectAll(".country"+mapRight.side+""+e).style("fill",	(!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(dataObj.dataDifferenceDestinitionYear[d.row-1][d.col-1]));
			});
		});
	}
}

Drawing.HighlightCountryOriginClear = function(d, mapLeft, mapRight)
{
	//Highlight country
	mapRight.svg.selectAll(".country"+mapRight.side+""+(d.row-1)).style("fill", mapRight.fill_default);
	var g1 = mapRight.GetActiveGroups();
	g1.forEach(function(f, j)
	{
		mapRight.groupingGroupStates[f[1]].forEach(function(e) { 
			mapRight.svg.selectAll(".country"+mapRight.side+""+e).style("fill", mapRight.fill_default);
		});
	});
	
	var res = mapLeft.GetCountries();
	res.forEach(function(j){	
			mapLeft.svg.selectAll(".country"+mapLeft.side+""+j).style("fill", mapLeft.fill_default);
	});
}

Drawing.HighlightCountryDestinition = function(d, mapLeft, mapRight)
{
	var id2 = d.row-1;
	var y = d.col-1;
	
	//console.log("ID: " + id2 + " " + y);
			
	//Highlight country
	for(var j = 0; j < mapRight.countries.length; j++)
		mapRight.svg.selectAll(".country"+mapRight.side+""+(j)).style("fill", function(d2, i2){
			var id1 = j;			
			if(states.absolut) 	return (!colormapSequential) ? "#fff" : colormapSequential.colorScale(dataObj.originDestinationYear[d.row-1][j][d.col-1]);
			else				return (!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(dataObj.difference[id1 * mapLeft.countries.length + id2][y]);			
		});
	if(states.absolut) 	mapLeft.svg.selectAll(".country"+mapLeft.side+""+(d.row-1)).style("fill", (!colormapSequential) ? "#fff" : colormapSequential.colorScale(d.Value));
	else 				mapLeft.svg.selectAll(".country"+mapLeft.side+""+(d.row-1)).style("fill", (!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(dataObj.dataDifferenceOriginYear[d.row-1][d.col-1]));

	var g2 = mapLeft.GetActiveGroups();
	g2.forEach(function(f, j)
	{
		mapLeft.groupingGroupStates[f[1]].forEach(function(e) { 
			if(states.absolut) 	mapLeft.svg.selectAll(".country"+mapLeft.side+""+e).style("fill", (!colormapSequential) ? "#fff" : colormapSequential.colorScale(d.Value));
			else 				mapLeft.svg.selectAll(".country"+mapLeft.side+""+e).style("fill", (!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(dataObj.dataDifferenceOriginYear[d.row-1][d.col-1]));
		});
	});
}

Drawing.HighlightCountryDestinitionClear = function(d, mapLeft, mapRight)
{
	//Highlight country
	var res = mapRight.GetCountries();
	res.forEach(function(j){
		mapRight.svg.selectAll(".country"+mapRight.side+""+j).style("fill", mapRight.fill_default);
	});
	mapLeft.svg.selectAll(".country"+mapLeft.side+""+(d.row-1)).style("fill", mapLeft.fill_default);

	var g2 = mapLeft.GetActiveGroups();
	g2.forEach(function(f, j)
	{
		mapLeft.groupingGroupStates[f[1]].forEach(function(e) { 
				mapLeft.svg.selectAll(".country"+mapLeft.side+""+e).style("fill", mapLeft.fill_default);
		});
	});
}

Drawing.HighlightCountryAll = function(d, mapLeft, mapRight)
{
	//Highlight country
	for(var j = 0; j < mapRight.countries.length; j++)
		mapRight.svg.selectAll(".country"+mapRight.side+""+j).style("fill", function(d2,i2){ 
			if(states.absolut === false) 	return (!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(dataObj.dataDifferenceDestinitionYear[j][d.col-1]);
											return (!colormapSequential) ? "#fff" : colormapSequential.colorScale(dataObj.dataDestinitionYear[j][d.col-1]);  
		});
	for(var j = 0; j < mapLeft.countries.length; j++)
		mapLeft.svg.selectAll(".country"+mapLeft.side+""+j).style("fill", function(d2,i2){ 
			if(states.absolut === false) 	return (!colormapDiverging) ? "#fff" : colormapDiverging.colorScale(dataObj.dataDifferenceOriginYear[j][d.col-1]); 
											return (!colormapSequential) ? "#fff" : colormapSequential.colorScale(dataObj.dataOriginYear[j][d.col-1]);
		});
}

Drawing.HighlightCountryAllClear = function(mapLeft, mapRight)
{
	//Highlight country
	for(var j = 0; j < mapRight.countries.length; j++)
		mapRight.svg.selectAll(".country"+mapRight.side+""+j).style("fill", mapRight.fill_default);
	for(var j = 0; j < mapLeft.countries.length; j++)
		mapLeft.svg.selectAll(".country"+mapLeft.side+""+j).style("fill", mapLeft.fill_default);
}
