HeatMap = function (zoom, rowLabelFrom2, rowLabelTo2, colLabel, mapLeft, mapRight, tooltip, dataObj, svgMLabelsL, svgMLabelsR, svgM)
{
	this.zoom				= zoom;		
	
	this.rowLabelFrom 		= rowLabelFrom2.slice();
	this.rowLabelTo 		= rowLabelTo2.slice();
	
	this.colLabel			= colLabel;
	
	this.mapLeft			= mapLeft;
	this.mapRight			= mapRight;
	
	this.tooltip			= tooltip;
	this.dataObj			= dataObj;	
	
	this.svgMLabelsL		= svgMLabelsL;
	this.svgMLabelsR 		= svgMLabelsR;
	this.svgM				= svgM;
}

HeatMap.prototype.hccol 			= [];
HeatMap.prototype.cellSize			= 24.0;
HeatMap.prototype.scaleMiddle		= 1.0;
HeatMap.prototype.translateMiddle	= [0,0];
HeatMap.prototype.num_visible		= 200000;	
HeatMap.prototype.rowLabels 		= null;
HeatMap.prototype.rowLabels2 		= null;
HeatMap.prototype.heatMap 			= null;
HeatMap.prototype.actualOrdering 	= [];
	
HeatMap.prototype.Create = function(create)
{
	var obj = this;
	
	obj.hccol.splice(0);
	obj.colLabel.forEach(function(d,i){
		obj.hccol.push(i+1);
	});

	
	if(states.displaystate === 'normal' && create === true)
	{
		svgMColumnT.append("g")
			.selectAll(".colLabelg")
			.data(obj.colLabel)
		.enter()
			.append("text")
			.text(function (d) { return d; })
			.attr("x", -50)
			.attr("y", function (d, i) { return states.widthML+obj.hccol.indexOf(i+1) * obj.cellSize; })
			.style("text-anchor", "start")
			.attr("transform", "translate("+obj.cellSize/2 + ",-6) rotate (-90)")
			.attr("class",  function (d,i) { return "colLabel mono c"+i;} )					
			.on("mouseover", function(d,i) {
				d3.select(this).classed("text-hover",true);
				var year = obj.colLabel[i];			
					
				Drawing.HighlightCountryAllColumn(i, year, mapRight, mapLeft);
			})
			.on("mouseout" , function(d) {
				d3.select(this).classed("text-hover",false);
				mapLeft.DisableHighlightAllCountry();
				mapRight.DisableHighlightAllCountry();
				
				var minmax = [0,0];
				dataObj.GetMinMax(minmax, obj.mapRight.countries, obj.mapLeft.countries);
				_legend.Update(minmax[0], minmax[1]);
			});		
	}
	else
	{
		svgMColumnT.selectAll("g").attr("transform", "translate(0,0)scale(1.0)");
		svgMColumnT.selectAll(".colLabel")			
				.attr("x", -50)
				.attr("y", function (d, i) { return states.widthML+obj.hccol.indexOf(i+1) * obj.cellSize; })
				.style("font-size", function(d,i){ return 11.0+"px";})
		svgMColumnT.selectAll("rect").attr("transform", "translate(0,0)scale(1)");	
	}
	
	var helper = new Array();
	var label_left = [];
	var label_right = [];		
	var label = ["All"];		
	
	var rowLabelFrom2 = [];
	var rowLabelTo2 = [];
	
	if(states.displaystate === 'origin')
	{
		for(var i = 0; i < obj.mapRight.countries.length; i++)
		{
			for(var j = 0; j < obj.dataObj.dataDestinitionYear[i].length; j++)	
				helper.push({Value: obj.dataObj.dataDestinitionYear[i][j], 
							 row: (i+1), 
							 col: (j+1)});		
			label_right.push(obj.mapRight.countries[i]);
			label_left.push("All");
			rowLabelTo2[i] = i;
		}
	}
	else if(states.displaystate === 'destinition')
	{
		for(var i = 0; i < obj.dataObj.dataOriginYear.length; i++)
		{
			for(var j = 0; j < obj.dataObj.dataOriginYear[i].length; j++)
				helper.push({Value: obj.dataObj.dataOriginYear[i][j],
							 row: (i+1),
							 col: (j+1)});
		
			label_left.push(obj.mapLeft.countries[i]);
			label_right.push("All");			
			rowLabelFrom2[i] = i;
		}
	}
	else if(states.displaystate === 'all')
	{
		for(var i = 0; i < obj.dataObj.dataYear.length; i++)
			helper.push({Value: obj.dataObj.dataYear[i],
							row: (1),
							col: (i+1)});	
	}
	else
	{
		helper = dataObj.data.slice();
		for(var i = helper.length-1; i >= 0; i--)
		{
			if(helper[i].FromKey 	>= mapRight.countries.length 
			|| helper[i].ToKey 	>= mapLeft.countries.length)
				helper.splice(i, 1);
		}
	}
	
	
	if(create === true)
	{	
		var heatMapGroup = svgMHeatmap
						.append("g")
						.attr("class","cellg")
						.attr("transform", "translate("+ obj.translateMiddle +")scale("+ obj.scaleMiddle +")");

		obj.heatMap = heatMapGroup.selectAll(".cell")
			.data(helper,function(d){return  d.row+":"+d.col + " - " + d.Value;})
	}
	else
	{	
		obj.heatMap = obj.heatMap
			.data(helper, function(d) { return d.row+":"+d.col + " - " + d.Value;});
	}
	
	obj.heatMap.enter()
			.append("svg:rect")
			.attr("x", function(d, i) { 
				if(states.displaystate === 'normal')	return (obj.hccol.indexOf(d.col) * 	obj.cellSize);
				else									return ((d.col-1) * obj.cellSize);
			})
			.attr("y", function(d, i) { 
				if(states.displaystate === 'normal')	return ((d.row-2) * obj.cellSize+50);
				if(states.displaystate === 'all')		return 50;
				else									return ((d.row-1) * obj.cellSize+50);
			})
			.attr("class", function(d, i){
				if(states.displaystate === 'normal')	return "cell cell-border cr"+(d.row-1)+" cc"+(d.col-1);
				else 									return "cell cell-border cr"+ d.row +" cc"+d.col;
				})
			.attr("width", obj.cellSize)
			.attr("height", obj.cellSize)
			.style("fill", function(d) { 
				if(isNaN(d.Value) === true) return "#fff";
				else return (states.absolut) ? (!colormapSequential) ? "#fff" : colormapSequential.colorScale(d.Value) : (colormapDiverging) ? "#fff" :  colormapDiverging.colorScale(obj.dataObj.difference[d.row-1][d.col-1]);
				//return (!colormapSequential) ? "#fff" : colormapSequential.colorScale(d.Value); 
			})
			.style("opacity", function(d,i) { 		
				if((d.row-1) < states.num_objs )	return "1.0";
				else								return "0.0";	
			})
			.on("mouseover", function(d, t){
				//highlight text
				d3.select(this).classed("cell-hover",true);
				d3.selectAll(".rowLabel").classed("text-highlight",function(r,ri){ return ri==(d.row-1);});
				d3.selectAll(".rowLabel2").classed("text-highlight",function(r,ri){ return ri==(d.row-1);});
				d3.selectAll(".colLabel").classed("text-highlight",function(c,ci){ return ci==(d.col-1);});
			  
				var id1 = d.row-1;
				var id2 = d.row-1;		   
				var id = d.row-1; 
				
				if(states.displaystate === 'normal' && mapLeft !== null)
				{
					id = d.FromKey * mapLeft.countries.length + d.ToKey;
					id1 = d.FromKey;
					id2 = d.ToKey;
				}
				
				if(obj.actualOrdering.indexOf(id) < states.num_objs && obj.actualOrdering.indexOf(id) < obj.num_visible)
				{
					obj.SetToolTipMap(d);
					VisualLink.HighlightLinkMap(id,      obj.actualOrdering, obj.num_visible, d);
					
					if(states.displaystate === 'origin')
					{
						Drawing.HighlightCountryOrigin(d, mapLeft, mapRight);
						mapLeft.HighlightLabel(id2, true);
						mapRight.HighlightLabel(id1);
					}
					else if(states.displaystate === 'destinition')					
					{
						Drawing.HighlightCountryDestinition(d, mapLeft, mapRight);
						mapRight.HighlightLabel(id1, true);
						mapLeft.HighlightLabel(id2);
					}
					else if(states.displaystate === 'all')					
					{
						Drawing.HighlightCountryAll(d, mapLeft, mapRight);
						mapRight.HighlightLabel(id1, true);
						mapLeft.HighlightLabel(id2, true);						
					}
					else
					{
						Drawing.HighlightCountryC(d, obj.mapLeft, obj.mapRight);
						mapRight.HighlightLabel(id1);
						mapLeft.HighlightLabel(id2);
					}
				}
			})
			.on("mouseout", function(d, t)
			{	
				if(states.enable_visuallinks === true && !states.showlines)
				{
					visLinkLeft.HideAll();
					visLinkRight.HideAll();
				}
				d3.select(this).classed("cell-hover",false);
				d3.selectAll(".rowLabel").classed("text-highlight",false);
				d3.selectAll(".rowLabel2").classed("text-highlight",false);
				d3.selectAll(".colLabel").classed("text-highlight",false);
				d3.select("#tooltip").classed("hidden", true);
				
				
				var id1 = d.row-1;
				var id2 = d.row-1;		   
				var id = d.row-1; 
				
				if(states.displaystate === 'normal')
				{
					id = d.FromKey * mapLeft.countries.length + d.ToKey;
					id1 = d.FromKey;
					id2 = d.ToKey;
				}
				
				if(obj.actualOrdering.indexOf(id) < states.num_objs && obj.actualOrdering.indexOf(id) < obj.num_visible)
				{
					mapRight.DisableHighlightLabel(id1);
					mapLeft.DisableHighlightLabel(id2);
				
					if(states.displaystate === 'origin')			Drawing.HighlightCountryOriginClear(d, mapLeft, mapRight);
					else if(states.displaystate === 'destinition')	Drawing.HighlightCountryDestinitionClear(d, mapLeft, mapRight);
					else if(states.displaystate === 'all')			Drawing.HighlightCountryAllClear(mapLeft, mapRight);
					else											Drawing.HighlightCountryCClear(d, mapLeft, mapRight);					
				}
			})
			.on("dblclick", function(d,t)
			{	
				if((mapLeft.zoomed === false) || (mapRight.zoomed === false))
				{
					if(states.displaystate === 'origin')			mapRight.doubleClickedHeatmap(d,t, rowLabelTo2);
					else if(states.displaystate === 'destinition')	mapLeft.doubleClickedHeatmap(d,t, rowLabelFrom2);
					else if(states.displaystate === 'normal')
					{
						mapLeft.doubleClickedHeatmap( d,t, obj.rowLabelFrom)
						mapRight.doubleClickedHeatmap(d,t, obj.rowLabelTo)
					}
				}
				else
				{
					if(states.displaystate === 'origin')			mapRight.reset();
					else if(states.displaystate === 'destinition')	mapLeft.reset();
					else if(states.displaystate === 'normal')
					{
						mapLeft.reset();
						mapRight.reset();
					}
				}
				
				callOrdering(states.animation_duration);
			});
	obj.heatMap.exit().remove();

	if(create === true)	
	{
		obj.rowLabels = obj.svgMLabelsL.selectAll(".rowLabelg").data(obj.rowLabelFrom);
	}
	else
	{
		if(states.displaystate === 'origin')			obj.rowLabels = obj.rowLabels.data(label_left, 			function(d, i) {return d + " " + i;});
		else if(states.displaystate === 'destinition')	obj.rowLabels = obj.rowLabels.data(rowLabelFrom2, 		function(d, i) {return d + " " + i;});		
		else if(states.displaystate === 'all')			obj.rowLabels = obj.rowLabels.data(label, 				function(d, i) {return d + " " + i;});		
		else											obj.rowLabels = obj.rowLabels.data(obj.rowLabelFrom, 	function(d, i) {return d + " " + i;});
	}
	
	obj.rowLabels.enter()
		.append("text")
		.text(function (d, i) { 
			if(states.displaystate === 'origin')			return d; 
			else if(states.displaystate === 'destinition')	return label_left[i];
			else if(states.displaystate === 'all')			return d; 
			else											return obj.mapLeft.countries[d];
			})
		.attr("x", states.widthML)
		.classed("hidden", false)
		.attr("y", function (d, i) { 
			if(states.displaystate === 'all')	return 65;
			else 								return i * obj.cellSize+50; 
		})
		.style("text-anchor", "end")
		.attr("class", function (d,i) { return "rowLabel mono r"+i;} )
		.style("opacity", function(d,i) {  
			if(i < states.num_objs) return "1.0";
			else					return "0.0";
		})
		.on("mouseover", function(d, i) {
			d3.select(this).classed("text-hover",true);
			d3.selectAll(".rowLabel2" ).classed("text-highlight",function(r,ri){ return ri==i;});			
			
			var id1 = obj.rowLabelTo[i];
			var id2 = obj.rowLabelFrom[i];			
			var id = i;
			if(states.displaystate === 'normal') 
				id = id1*obj.mapLeft.countries.length+id2;
		
			if(obj.actualOrdering.indexOf(id) < states.num_objs && obj.actualOrdering.indexOf(id) < obj.num_visible)
			{
				if(states.displaystate === 'origin')
				{
					obj.SetToolTipLabel(i);
				
					if(typeof(mapLeft) !== 'undefined' && mapLeft !== null)		mapLeft.HighlightLabel(i, true);
					if(typeof(mapRight) !== 'undefined' && mapRight !== null)	mapRight.HighlightLabel(i);
					VisualLink.HighlightLinkLabel(i, obj.actualOrdering, obj.num_visible);
				}
				else if(states.displaystate === 'destinition')
				{
					obj.SetToolTipLabel(i);
				
					if(typeof(mapLeft) !== 'undefined' && mapLeft !== null)		mapLeft.HighlightLabel(i);
					if(typeof(mapRight) !== 'undefined' && mapRight !== null)	mapRight.HighlightLabel(i, true);
					VisualLink.HighlightLinkLabel(i, obj.actualOrdering, obj.num_visible);
				}
				else if(states.displaystate === 'all')
				{
					if(typeof(mapLeft) !== 'undefined' && mapLeft !== null)		mapLeft.HighlightLabel(i, true);
					if(typeof(mapRight) !== 'undefined' && mapRight !== null)	mapRight.HighlightLabel(i, true);
				}
				else
				{
					obj.SetToolTipLabel(id1, id2);
			
					if(typeof(mapRight) !== 'undefined' && mapRight !== null)	mapRight.HighlightLabel(id1);
					if(typeof(mapLeft) !== 'undefined' && mapLeft !== null)		mapLeft.HighlightLabel(id2);
					VisualLink.HighlightLinkLabel(id, obj.actualOrdering, obj.num_visible, id1, id2);
				}
			}
		})
		.on("mouseout" , function(d, i) { 
			d3.select("#tooltip").classed("hidden", true);
			d3.select(this).classed("text-hover",false);
			
			if(!states.showlines && states.enable_visuallinks === true)
			{
				if(typeof(visLinkLeft) !== 'undefined' && visLinkLeft !== null)		visLinkLeft.HideAll();
				if(typeof(visLinkRight) !== 'undefined' && visLinkRight !== null)	visLinkRight.HideAll();
			}
			
			if(states.displaystate === 'origin')
			{
				if(typeof(mapRight) !== 'undefined' && mapRight !== null)	mapRight.DisableHighlightLabel(i);
				if(typeof(mapLeft) !== 'undefined' && mapLeft !== null)		mapLeft.DisableHighlightLabel(i, true);
			}
			else if(states.displaystate === 'destinition')
			{
				if(typeof(mapLeft) !== 'undefined' && mapLeft !== null)		mapLeft.DisableHighlightLabel(i);
				if(typeof(mapRight) !== 'undefined' && mapRight !== null)	mapRight.DisableHighlightLabel(i, true);
			}
			else if(states.displaystate === 'all')
			{
				if(typeof(mapLeft) !== 'undefined' && mapLeft !== null)		mapLeft.DisableHighlightLabel(i, true);
				if(typeof(mapRight) !== 'undefined' && mapRight !== null)	mapRight.DisableHighlightLabel(i, true);
			}
			else
			{
				var id1 = obj.rowLabelTo[i];
				var id2 = obj.rowLabelFrom[i];
				if(typeof(mapRight) !== 'undefined' && mapRight !== null)	mapRight.DisableHighlightLabel(id1);
				if(typeof(mapLeft) !== 'undefined' && mapLeft !== null)		mapLeft.DisableHighlightLabel(id2);
			}
		});		
	obj.rowLabels.exit().remove();
	
	if(create === true)	
	{
		obj.rowLabels2 = obj.svgMLabelsR.selectAll(".rowLabelg2").data(obj.rowLabelTo);
	}
	else
	{
		if(states.displaystate === 'origin')			obj.rowLabels2 = obj.rowLabels2.data(rowLabelTo2, 		function(d, i) {return d + " " + i;});
		else if(states.displaystate === 'destinition')	obj.rowLabels2 = obj.rowLabels2.data(label_right, 		function(d, i) {return d + " " + i;});
		else if(states.displaystate === 'all')			obj.rowLabels2 = obj.rowLabels2.data(label, 			function(d, i) {return d + " " + i;});
		else											obj.rowLabels2 = obj.rowLabels2.data(obj.rowLabelTo, 	function(d, i) {return d + " " + i;});
	}																				
	obj.rowLabels2.enter()
			.append("text")
			.text(function (d, i) { 
				if(states.displaystate === 'origin') 			return label_right[i]; 
				else if(states.displaystate === 'destinition')	return d;
				else if(states.displaystate === 'all')			return d;
				else											return obj.mapRight.countries[d];
			})
			.attr("x", 10)
			.attr("y", function (d, i) { 
				if(states.displaystate === 'all')	return 65;
				else								return i * obj.cellSize+50; })
			.style("text-anchor", "start")				
			.attr("class", function (d,i) { return "rowLabel2 mono r"+i;} )
			.style("opacity", function(d,i) {  
				if(i < states.num_objs)  return "1.0";
				else					 return "0.0";
			})
			.on("mouseover", function(d, i)
			{
				var id1 = obj.rowLabelTo[i];
				var id2 = obj.rowLabelFrom[i];
				var id = d;
				if(states.displaystate === 'normal')
					id  = id1*obj.mapLeft.countries.length+id2;
				
				if(obj.actualOrdering.indexOf(id) < states.num_objs && obj.actualOrdering.indexOf(id) < obj.num_visible)
				{
					d3.select(this).classed("text-hover",true);
					d3.selectAll(".rowLabel" ).classed("text-highlight",function(r,ri){ return ri==i;});
					
					if(states.displaystate === 'origin')
					{
						obj.SetToolTipLabel(i);
						mapRight.HighlightLabel(i);
						mapLeft.HighlightLabel(i, true);
						VisualLink.HighlightLinkLabel(i, obj.actualOrdering, obj.num_visible);
					}
					else if(states.displaystate === 'destinition')
					{
						obj.SetToolTipLabel(i);
						mapLeft.HighlightLabel(i);
						mapRight.HighlightLabel(i, true);
						VisualLink.HighlightLinkLabel(i, obj.actualOrdering, obj.num_visible);
					}
					else if(states.displaystate === 'all')
					{
						//obj.SetToolTipLabel(i);
						mapLeft.HighlightLabel(i, true);
						mapRight.HighlightLabel(i, true);
						VisualLink.HighlightLinkLabel(i, obj.actualOrdering, obj.num_visible);
					}
					else
					{
						obj.SetToolTipLabel(id1, id2);
						mapRight.HighlightLabel(id1);
						mapLeft.HighlightLabel(id2);
						VisualLink.HighlightLinkLabel(id, obj.actualOrdering, obj.num_visible, id1, id2);
					}
				}
			})
			.on("mouseout" , function(d, i) { 
			
				if(!states.showlines && states.enable_visuallinks === true)
				{
					visLinkLeft.HideAll();
					visLinkRight.HideAll();
				}
				
				if(states.displaystate === 'origin')
				{
					mapRight.DisableHighlightLabel(i);
					mapLeft.DisableHighlightLabel(i, true);
				}
				else if(states.displaystate === 'destinition')
				{
					mapLeft.DisableHighlightLabel(i);
					mapRight.DisableHighlightLabel(i, true);
				}
				else if(states.displaystate === 'all')
				{
					mapLeft.DisableHighlightLabel(i, true);
					mapRight.DisableHighlightLabel(i, true);
				}
				else
				{
					var id1 = obj.rowLabelTo[i];
					var id2 = obj.rowLabelFrom[i];
					mapRight.DisableHighlightLabel(id1);
					mapLeft.DisableHighlightLabel(id2);
				}
				d3.select("#tooltip").classed("hidden", true); 
				d3.select(this).classed("text-hover",false);				
			});
	obj.rowLabels2.exit().remove();	
	

	obj.scaleMiddle = 1.0;
	obj.translateMiddle = [0,0];
	obj.zoom.scale(obj.scaleMiddle);
	obj.zoom.translate(obj.translateMiddle);
	obj.svgMLabelsL.selectAll("g").attr("transform", "translate("+obj.translateMiddle+")scale("+obj.scaleMiddle+")");
	obj.svgMLabelsR.selectAll("g").attr("transform", "translate("+obj.translateMiddle+")scale("+obj.scaleMiddle+")");
	svgMHeatmap.selectAll("g").attr("transform", "translate("+obj.translateMiddle+")scale("+obj.scaleMiddle+")");
	obj.svgM.attr("transform", "translate(" + obj.translateMiddle + ")scale(" + obj.scaleMiddle + ")");

	
	obj.Fit();
}		

HeatMap.prototype.Fit = function()
{
	var obj = this;
	
	states.widthMM = states.widthM - 200;	
	obj.scaleMiddle = states.widthMM/(obj.colLabel.length * obj.cellSize); 
	obj.translateMiddle[1] = 0.0;
	obj.zoom.scale(obj.scaleMiddle);
	obj.zoom.translate(obj.translateMiddle);
	obj.Move();
}

HeatMap.prototype.ShowAll = function()
{
	var obj = this;
	
	if(mapRight.active_country.length > 0 || mapLeft.active_country.length > 0)	
	{	
		obj.scaleMiddle = Math.min(	states.widthMM/(obj.colLabel.length*obj.cellSize), 
									states.height/(Math.min(states.num_objs,obj.num_visible)*obj.cellSize)); 			
	}
	else	
	{	
		if( displaystate === 'normal')
			obj.scaleMiddle = Math.min(states.widthMM/(obj.colLabel.length*obj.cellSize), 	states.height/(Math.min(states.num_objs,rowLabelTo.length)*obj.cellSize)); 		
		else if( displaystate === 'origin')
			obj.scaleMiddle = Math.min(states.widthMM/(obj.colLabel.length*obj.cellSize), 	states.height/(Math.min(states.num_objs,obj.mapRight.countries.length)*obj.cellSize)); 		
		else if( displaystate === 'destinition')		
			obj.scaleMiddle = Math.min(states.widthMM/(obj.colLabel.length*obj.cellSize), 	states.height/(Math.min(states.num_objs,obj.mapLeft.countries.length)*obj.cellSize)); 		
		else obj.scaleMiddle = Math.min(states.widthMM/(obj.colLabel.length*obj.cellSize), states.height/(1*obj.cellSize)); 		
	}

	obj.translateMiddle[1] = 0.0;
	obj.zoom.scale(obj.scaleMiddle);
	obj.zoom.translate(obj.translateMiddle);
	obj.Move(); //scaleHeatmap();
}

HeatMap.prototype.Move = function()
{
	var obj = this;
	
	
	var tmp = obj.colLabel.length * obj.cellSize * obj.scaleMiddle;
	var w = Math.min(states.widthM-200, tmp);
	var wl = (states.widthM-w)/2.0;
		
	states.widthML = wl;	
	states.widthMM = w;	
	states.widthMR = wl;			
		
	var xw = Math.max(200-tmp, Math.min(0.0, obj.translateMiddle[0]));
	var t = [ xw, 			   Math.max(0.0, obj.translateMiddle[1])];
	
	svgMColumnT.selectAll(".colLabel")			
			.attr("y", function (d, i) { return (wl > 100)  ? states.widthML	  +obj.scaleMiddle*(obj.cellSize*i) 
															: states.widthML+t[0]+obj.scaleMiddle*(obj.cellSize*i); })
			.attr("x", function (d, i) { return -t[1]-50.0*Math.min(obj.scaleMiddle,1.0); })
			.style("font-size", function(d,i){ return Math.min(15.0, 11.0*obj.scaleMiddle)+"px";})
					
	obj.zoom.translate([t[0], obj.translateMiddle[1]]);		
	
	svgMColumnT.selectAll("rect").attr("transform", "translate(" + [obj.translateMiddle[0], Math.max(0, obj.translateMiddle[1])] + ")scale(" + Math.min(1.0, obj.scaleMiddle) + ")");	
}

HeatMap.prototype.UpdateSorting = function(newsortedindexindexOf, duration)
{
	var obj = this;
	
	var t = svg_overall;
	if(duration > 0) t = svg_overall.transition().duration(duration);

	t.selectAll(".cell").attr("y", function(d) 
	{ 
		var id = 0;		
		if( states.displaystate === 'normal')	id = d.FromKey * obj.mapLeft.countries.length + d.ToKey;
		else if( states.displaystate === 'origin')		id = d.row-1;
		else if( states.displaystate === 'destinition')	id = d.row-1;
		else id = 0;
				
		return (newsortedindexindexOf[id] * obj.cellSize + 50); 
	})			
}

HeatMap.prototype.SetDefaultZoom = function()
{
	var obj = this;
	obj.scaleMiddle = 1.0;
	obj.translateMiddle = [0,0];
	obj.zoom.scale(		obj.scaleMiddle);
	obj.zoom.translate(	obj.translateMiddle);
}

HeatMap.prototype.Update = function(newsortedindexindexOf, duration, selected)
{
	var obj = this;
	
	var t = svg_overall;
	if(duration > 0) t = svg_overall.transition().duration(duration);							
	
	var tmp = obj.colLabel.length*obj.cellSize*obj.scaleMiddle;
	var w = Math.max(0, Math.min(200, tmp));
	var wl = (400-w)/2.0;
	
	states.widthML = wl;	states.widthMM = w;	states.widthMR = wl;			
	
	var xw = Math.max(200-tmp, Math.min(0.0, obj.translateMiddle[0]));
							
	obj.svgMLabelsL.attr("x", 0).attr("width", wl);
	svgMHeatmap.attr("x", wl).attr("width", w);									
	obj.svgMLabelsR.attr("x", wl+w).attr("width", wl);
				
	t.selectAll(".cellg").attr("transform", "translate(" + [ (wl > 100) ? 0.0 : xw, obj.translateMiddle[1]] + ")scale(" + obj.scaleMiddle + ")");					
	t.selectAll(".cell").attr("y", function(d, i) { 			
			var id = 0;
			if( states.displaystate === 'normal')	id = d.FromKey * (obj.mapLeft.countries.length) + d.ToKey;
			else if( states.displaystate === 'origin')		id = d.row-1;
			else if( states.displaystate === 'destinition')	id = d.row-1;
			else id = 0;
			return (newsortedindexindexOf[id] * obj.cellSize + 50); 		
		})
		.style("opacity", function(d,i) { 	
			var id = 0;
			if( states.displaystate === 'normal')			id = d.FromKey * (obj.mapLeft.countries.length) + d.ToKey;
			else if( states.displaystate === 'origin')		id = d.row-1;
			else if( states.displaystate === 'destinition')	id = d.row-1;
			else id = 0;
			return ((newsortedindexindexOf[id] < states.num_objs && (newsortedindexindexOf[id] < obj.num_visible || selected === false)) === true ? 1.0 : 0.0) + "";	
		});	
	
	t.selectAll(".rowLabel")			
		.attr("x", wl)
		.attr("y", function (d, i) { 		
				var id = 0;
				if( states.displaystate === 'normal')
				{					
					var id1 = obj.rowLabelTo[i];
					var id2 = obj.rowLabelFrom[i];					
					id  = id1*(obj.mapLeft.countries.length) + id2;
					
				}
				else if( states.displaystate === 'destinition') id = i;
				else if( states.displaystate === 'all') 		id = i;
				else id = i;
				
				return obj.translateMiddle[1] + obj.scaleMiddle*(newsortedindexindexOf[id] * obj.cellSize + 50 + 15); 
			})
		.style("font-size", function(d,i){ 	return Math.min(15.0, 11.0*obj.scaleMiddle)+"px";})
		.style("opacity", function(d,i) { 	
				var id = 0;
				if( states.displaystate === 'normal')
				{
					var id1 = obj.rowLabelTo[i];
					var id2 = obj.rowLabelFrom[i];
					id  = id1*(obj.mapLeft.countries.length) + id2;
				}
				else if( states.displaystate === 'destinition') id = i;
				else if( states.displaystate === 'all') 		id = i;
				else id = i;
				
				return ((newsortedindexindexOf[id] < states.num_objs && (newsortedindexindexOf[id] < obj.num_visible || selected === false)) ? 1.0 : 0.0) + "";
			});	
			
	t.selectAll(".rowLabel2")							
		.attr("y", function (d, i) { 
				var id = 0;
				if( states.displaystate === 'normal')
				{
					var id1 = obj.rowLabelTo[i];
					var id2 = obj.rowLabelFrom[i];
					id  = id1*(obj.mapLeft.countries.length) + id2;
				}
				else if( states.displaystate === 'destinition') id = i;
				else if( states.displaystate === 'all') 		id = i;
				else id = d;
				
				return obj.translateMiddle[1] + obj.scaleMiddle*(newsortedindexindexOf[id] * obj.cellSize + 50 + 15); 
			})
		.style("font-size", function(d,i){ 	return Math.min(15.0, 11.0*obj.scaleMiddle)+"px";})
		.style("opacity", function(d,i) { 	
				var id = 0;
				if( states.displaystate === 'normal')
				{
					var id1 = obj.rowLabelTo[i];
					var id2 = obj.rowLabelFrom[i];
					id  = id1*(obj.mapLeft.countries.length) + id2;
				}
				else if( states.displaystate === 'destinition') id = i;
				else if( states.displaystate === 'all') 		id = i;
				else id = d;
				
				return (( newsortedindexindexOf[id] < states.num_objs && (newsortedindexindexOf[id] < obj.num_visible || selected === false)) === true ? 1.0 : 0.0) + "";
			});				
	
}

HeatMap.prototype.UpdateColorScaleHeatmap = function(dur)
{	
	var obj = this;
	var d = 0;
	if(dur) d = dur;
	else d = states.animation_duration;
	
	var helper = svg_overall;
	if(d > 0) 	helper = svg_overall.transition().duration(d);
	
	if(states.absolut === false)	
	{
		if(states.displaystate === 'normal')
			helper.selectAll(".cell").style("fill", function(d) { 	if(isNaN(obj.dataObj.difference[d.row-1][d.col-1])) 					return "#ffffff"; else return colormapDiverging.colorScale(obj.dataObj.difference[d.row-1][d.col-1]); });				
		else if(states.displaystate === 'origin')
			helper.selectAll(".cell").style("fill", function(d) {  	if(isNaN(obj.dataObj.dataDifferenceDestinitionYear[d.row-1][d.col-1])) 	return "#ffffff"; else return colormapDiverging.colorScale(obj.dataObj.dataDifferenceDestinitionYear[d.row-1][d.col-1]); });	
		else if(states.displaystate === 'destinition')
			helper.selectAll(".cell").style("fill", function(d) { 	if(isNaN(obj.dataObj.dataDifferenceOriginYear[d.row-1][d.col-1])) 		return "#ffffff"; else return colormapDiverging.colorScale(obj.dataObj.dataDifferenceOriginYear[d.row-1][d.col-1]); });				
		else 
			helper.selectAll(".cell").style("fill", function(d) { 	if(isNaN(obj.dataObj.dataDifferenceYear[d.col-1])) 						return "#ffffff"; else return colormapDiverging.colorScale(obj.dataObj.dataDifferenceYear[d.col-1]); });	
	}
	else
	{
		if(states.displaystate === 'normal')
			helper.selectAll(".cell").style("fill", function(d) { 	if(isNaN(d.Value)) 												return "#ffffff"; else return colormapSequential.colorScale(d.Value); });	
		else if(states.displaystate === 'origin')
			helper.selectAll(".cell").style("fill", function(d) { 	if(isNaN(obj.dataObj.dataDestinitionYear[d.row-1][d.col-1])) 	return "#ffffff"; else return colormapSequential.colorScale(obj.dataObj.dataDestinitionYear[d.row-1][d.col-1]); });				
		else if(states.displaystate === 'destinition')
			helper.selectAll(".cell").style("fill", function(d) { 	if(isNaN(obj.dataObj.dataOriginYear[d.row-1][d.col-1])) 		return "#ffffff"; else return colormapSequential.colorScale(obj.dataObj.dataOriginYear[d.row-1][d.col-1]); });	
		else 
			helper.selectAll(".cell").style("fill", function(d) { 	if(isNaN(obj.dataObj.dataYear[d.col-1])) 						return "#ffffff"; else return colormapSequential.colorScale(obj.dataObj.dataYear[d.col-1]); });	
	}
}

HeatMap.prototype.HighlightLabels = function(side, id)
{
	var obj = this;
	if(side === 'R')
	{
		d3.selectAll(".rowLabel2").classed("text-highlight",function(r,ri){ return r === id;});
		d3.selectAll(".rowLabel" ).classed("text-highlight",function(r,ri){ return obj.rowLabelTo[ri] === id;});
	}
	else
	{
		d3.selectAll(".rowLabel" ).classed("text-highlight",function(r,ri){ return r === id;});
		d3.selectAll(".rowLabel2").classed("text-highlight",function(r,ri){ return obj.rowLabelFrom[ri] === id;});
	}
}

HeatMap.prototype.SetToolTipLabel = function(id1, id2)
{
	var obj = this;
	
	if(states.enable_tooltip_visuallinks === true)
	{
		if(states.displaystate === 'origin')
		{
			var res = obj.tooltip.tooltipsTop3Right[id1];
						
			//Update the tooltip position and value
			d3.select("#tooltip")
				.style("left", (d3.event.pageX+10) + "px")
				.style("top", (d3.event.pageY-10) + "px")
				.select("#value")
				.html(obj.mapRight.countries[id1] + " <br/>"
						+ res[0].Country + ": " + res[0].Result + "<br/>"
						+ res[1].Country + ": " + res[1].Result + "<br/>"
						+ res[2].Country + ": " + res[2].Result + "<br/>"				
					);  
			
			//Show the tooltip
			d3.select("#tooltip").classed("hidden", false);
				
		}
		else if(states.displaystate === 'destinition')
		{
			var res = obj.tooltip.tooltipsTop3Left[id1];
						
			//Update the tooltip position and value
			d3.select("#tooltip")
				.style("left", (d3.event.pageX+10) + "px")
				.style("top", (d3.event.pageY-10) + "px")
				.select("#value")
				.html(obj.mapLeft.countries[id1] + " <br/>"
						+ res[0].Country + ": " + res[0].Result + "<br/>"
						+ res[1].Country + ": " + res[1].Result + "<br/>"
						+ res[2].Country + ": " + res[2].Result	);
						
			//Show the tooltip
			d3.select("#tooltip").classed("hidden", false);
		}
		else if(states.displaystate === 'all')
		{
		}
		else
		{
			var res = obj.tooltip.tooltipsTop3LeftRight[id1][id2];
					
			//Update the tooltip position and value
			d3.select("#tooltip")
				.style("left", (d3.event.pageX+10) + "px")
				.style("top", (d3.event.pageY-10) + "px")
				.select("#value")
				.html(obj.mapLeft.countries[id2] + " " + obj.mapRight.countries[id1] + "<br/>"
					+ res[0].Name + ": " + res[0].Result + "<br/>"
					+ res[1].Name + ": " + res[1].Result + "<br/>"
					+ res[2].Name + ": " + res[2].Result + "<br/>"
			);  
			//Show the tooltip
			d3.select("#tooltip").classed("hidden", false);
		}
	}
}

HeatMap.prototype.SetToolTipMap = function(d)
{
	var obj = this;

	if(states.enable_tooltip_heatmap === true)
	{
		if(states.displaystate === 'origin')
		{
			//Update the tooltip position and value
			d3.select("#tooltip")
				.style("left", (d3.event.pageX+10) + "px")
				.style("top", (d3.event.pageY-10) + "px")
				.select("#value")
				.html(obj.mapRight.countries[d.row-1]+" All, "+obj.colLabel[d.col-1] + 
					"<br/>value:" + d.Value+
					"<br/>difference:"+obj.dataObj.dataDifferenceDestinitionYear[d.row-1][d.col-1]);
					
			//Show the tooltip
			d3.select("#tooltip").classed("hidden", false);
		}
		else if(states.displaystate === 'destinition')
		{
			//Update the tooltip position and value
			d3.select("#tooltip")
				.style("left", (d3.event.pageX+10) + "px")
				.style("top", (d3.event.pageY-10) + "px")
				.select("#value")
				.html(obj.mapLeft.countries[d.row-1]+" All, "+obj.colLabel[d.col-1] + 
					"<br/>value:" + d.Value+
					"<br/>difference:"+obj.dataObj.dataDifferenceOriginYear[d.row-1][d.col-1]);
					
			//Show the tooltip
			d3.select("#tooltip").classed("hidden", false);
		}
		else if(states.displaystate === 'all')
		{
			//Update the tooltip position and value
			d3.select("#tooltip")
				.style("left", (d3.event.pageX+10) + "px")
				.style("top", (d3.event.pageY-10) + "px")
				.select("#value")
				.html("All All, "+obj.colLabel[d.col-1] + 
							"<br/>value:" + d.Value+
							"<br/>difference:"+obj.dataObj.dataYear[d.col-1]);
							
			//Show the tooltip
			d3.select("#tooltip").classed("hidden", false);						   
		}
		else
		{
			//Update the tooltip position and value
			d3.select("#tooltip")
				.style("left", (d3.event.pageX+10) + "px")
				.style("top", (d3.event.pageY-10) + "px")
				.select("#value")							
				.html(d.To + " " + d.From +", "+obj.colLabel[d.col-1]+"<br/>value:"+d.Value+"<br/>difference:"+obj.dataObj.difference[d.row-1][d.col-1]);  
			
			//Show the tooltip
			d3.select("#tooltip").classed("hidden", false);
		}
	}
}
