Label = function (map, dots_size_default, dots_size_highlight, text_size_default, text_size_highlight)
{			
	this.dots_size_default 		= dots_size_default;
	this.dots_size_highlight 	= dots_size_highlight;
	this.text_size_default 		= text_size_default;
	this.text_size_highlight 	= text_size_highlight;
		
	this.map = map;
}

Label.prototype.quadtree=null;
Label.prototype.nodes_labels=[];
Label.prototype.labelstext=null;

Label.prototype.Create = function()
{
	var obj = this;
	
	var countries2 = new Array(0);
	for(var i = obj.map.countries.length-1; i >= 0 ; i--)
	{
		var _id = i;		
		if($.inArray(_id, obj.map.groupingNames) === -1) 		
			countries2.push({ 	name: obj.map.countries[_id], id: _id});		
	}
		
	obj.map.svg.selectAll(".dot")
			.data(countries2)		
		.enter().append("circle")
			.attr("id",function(d,i) {return "dot" + i;}) 
			.attr("class", function(d,i){ return "dot dot"+obj.map.side+" dot"+obj.map.side+""+d.id +" dot" + d.name
												+ " country"+obj.map.side + "" + d.id;})			
			.attr("cx", function(d, i) { 	
				return obj.map.translate[0] + obj.map.scale * obj.map.nodex[d.id];	
			})
			.attr("cy", function(d, i) { 	
				return obj.map.translate[1] + obj.map.scale * obj.map.nodey[d.id];	
			})
			.attr("r", obj.dots_size_default*20.0)
			.on("click", function(d) { 		obj.map.clicked_heatmap(d.id);			})
			.on("dblclick", function(d) {	obj.map.doubleClicked(obj.map, d.name);	})
			.on("mousemove", function(d, i)
			{	
				d3.select(".label"+obj.map.side+""+ d.id).classed("label-highlight", true);
				_heatmap.HighlightLabels(obj.side, d.id);
				obj.map.SetToolTip(obj.map, d.id, d.name);
				
				if(states.enable_visuallinks === true && !states.showlines)
				{	
					if(obj.side === 'L')	visLinkLeft.ShowLinksForCounry(d.id,  _heatmap.rowLabelFrom, "L", _heatmap.rowLabelTo);
					else					visLinkRight.ShowLinksForCounry(d.id, _heatmap.rowLabelTo,   "R", _heatmap.rowLabelFrom);
				}
			})
			.on("mouseout", function(d, i)
			{
				var res = obj.map.GetCountries();
				res.forEach(function(d)
				{
					if(obj.map.active_country.length === res.length || $.inArray(d, obj.map.active_country) === -1)
					{						
						d3.selectAll(".label"+obj.map.side+""+d).classed("label-highlight", false);
					}
				});
				d3.select("#tooltip").classed("hidden", true);
			});
		
	obj.labelstext = obj.map.svg.selectAll(".rowLabelTextg")
			.data(countries2)		
		.enter()
			.append("text")
			.attr("x", function(d, i) { 
				return obj.map.translate[0] + obj.map.scale *  obj.map.nodex[d.id];} )
			.attr("y", function(d, i) { 
				return obj.map.translate[1] + obj.map.scale * (obj.map.nodey[d.id]-0.3);} )
			.attr("class", function(d) { return "text label"+obj.map.side + " label"+ obj.map.side+""+d.id; })		  
			.style("text-anchor", "middle")
			.style("font-size", obj.text_size_default * 20.0 +"pt")
			.text(function(d) { return d.name;})
			.on("click", function(d) { 		obj.map.clicked_heatmap(d.id);				})
			.on("dblclick", function(d) {	obj.map.doubleClicked(obj.map, d.name);		})
			.on("mousemove", function(d) {  
				_heatmap.HighlightLabels(obj.map.side, d.id);	
				obj.map.SetToolTip(obj.map, d.id, d.name);
				
				if(states.enable_visuallinks === true && !states.showlines)
				{	
					if(obj.map.side === 'L')	visLinkLeft.ShowLinksForCounry(d.id,  _heatmap.rowLabelFrom, "L", _heatmap.rowLabelTo);
					else						visLinkRight.ShowLinksForCounry(d.id, _heatmap.rowLabelTo,   "R", _heatmap.rowLabelFrom);
				}
			})
			.on("mouseout", function(d, i)
			{
				d3.select("#tooltip").classed("hidden", true);
			});
								
	obj.nodes_labels =[];
	obj.CreateQuadtree();
	obj.CollisionQuadtree();	
	obj.map.svg.selectAll(".label"+obj.map.side).style("opacity", function(d,i){ return (obj.nodes_labels[i].selected === false) ? 1.0 : 0.0;});
}
	
Label.prototype.Update = function()
{
	var obj = this;
	try
	{
		obj.CreateQuadtree();
		obj.CollisionQuadtree();	
		obj.map.svg.selectAll(".label"+obj.map.side).style("opacity", function(d,i){ return (obj.nodes_labels[i].selected === false) ? 1.0 : 0.0;});
	}
	catch(e){}
}
	
Label.prototype.CreateQuadtree = function()
{	
	var obj = this;
	
	//console.log("CreateQuadtree");
	obj.nodes_labels.splice(0);
	if(obj.labelstext)
	{
		obj.labelstext.each(function(d) {		
			var tmp = this.getBBox();						
			obj.nodes_labels.push(
			{	
				x: obj.map.translate[0] + obj.map.scale *  obj.map.nodex[d.id]		- tmp.width/2.0,
				y: obj.map.translate[1] + obj.map.scale * (obj.map.nodey[d.id]-0.3)	- tmp.height,
				width: tmp.width,
				height: tmp.height,		
				selected: false,
				id: d.id,
				name: this.textContent
			});
		});			
	}
	
	obj.quadtree = d3.geom.quadtree(obj.nodes_labels);	
}

Label.prototype.CollisionQuadtree = function()
{
	var obj = this;
	
	for (var i = 0; i < obj.nodes_labels.length; i++) 
		if(obj.nodes_labels[i].selected === false)
			obj.search(	obj.nodes_labels[i].x, 
						obj.nodes_labels[i].y, 
						obj.nodes_labels[i].x +obj.nodes_labels[i].width, 
						obj.nodes_labels[i].y +obj.nodes_labels[i].height, 
						obj.nodes_labels);	
}

Label.prototype.nodesD = function() {
	var obj = this;
	
	var nodes = [];
	obj.quadtree.visit(function(node, x1, y1, x2, y2) {
		nodes.push({x: x1, y: y1, width: x2 - x1, height: y2 - y1});
	});
	return nodes;
}

Label.prototype.DebugQuadtree = function()
{
	var obj = this;
	
	obj.map.svg.selectAll(".qt")
		.data(obj.nodesD())
	.enter().append("svg:rect")
		.attr("class", "node")
		.attr("x", function(d) { return d.x; })
		.attr("y", function(d) { return d.y; })
		.attr("width", function(d) { return d.width; })
		.attr("height", function(d) { return d.height; })
		.style("fill", "none")
		.style("stroke", "#ccc");
		
	obj.map.svg.selectAll("debugBoxes")
		.data(obj.nodes_labels)
		.enter()
		.append("svg:rect")
			.attr("x", function(d) { return d.x;})
			.attr("y", function(d) { return d.y;})
			.attr("width", function(d) { return d.width;})
			.attr("height", function(d) { return d.height;})
			.style("opacity", function(d,i) { return (d.selected === false) * 1.0 + ""});
}

Label.prototype.search = function(x0, y0, x3, y3, test, me) 
{
	var obj = this;
	var num_vistited = 0;
	
	obj.quadtree.visit(function(node, x1, y1, x2, y2) 
	{
		var p = node.point;
		if (p && p.selected === false) 
		{					
			p.scanned = true;
			p.selected =(p.x < x3 && (p.x + p.width) > x0 	&& p.y < y3 &&	(p.height + p.y) > y0) 
						&& Math.abs(p.x-x0) > 0.001 		&& Math.max(p.y-y0) > 0.001
						&& Math.abs(p.x+p.width-x3) > 0.001 && Math.max(p.y+p.height-y3) > 0.001;			
		}
		
		if((x1 <  x3 && y1 < y3  && x2 > x0 && y2 > y0) === false)	return (p && p.selected === true);
		else 														return false;		
	});	
}


Label.prototype.UpdateLabelDefault = function(t)
{
	var obj = this;
	t.selectAll(".dot"+obj.map.side)
		.attr("cx", function(d) { var x = 0; if(d.id < obj.map.nodex.length) x = obj.map.nodex[d.id]; return x*obj.map.scale + obj.map.translate[0];})
		.attr("cy", function(d) { var y = 0; if(d.id < obj.map.nodey.length) y = obj.map.nodey[d.id]; return y*obj.map.scale + obj.map.translate[1];})
		.attr("r", obj.dots_size_default*20.0);

	t.selectAll(".label"+obj.map.side)
		.attr("x", function(d) { var x = 0; if(d.id < obj.map.nodex.length) x = obj.map.nodex[d.id];	return x*obj.map.scale + obj.map.translate[0];})
		.attr("y", function(d) { var y = 0; if(d.id < obj.map.nodey.length) y = obj.map.nodey[d.id];	return y*obj.map.scale + obj.map.translate[1]-8.0;});
}

Label.prototype.UpdateLabelSelection = function(s1)
{
	var obj = this;
	
	var h  = s1.selectAll(".dot"+obj.map.side);
		h.attr("cx", function(d, i) { var x = 0; if(d.id < obj.map.nodex.length) x = obj.map.nodex[d.id];	return x*obj.map.scale + obj.map.translate[0];})
		h.attr("cy", function(d, i) { var y = 0; if(d.id < obj.map.nodey.length) y = obj.map.nodey[d.id];	return y*obj.map.scale + obj.map.translate[1];});

	if(obj.map.selected_country === true)
	{		
		obj.map.active_country.forEach(function(idn){
			s1.selectAll(".dot"+obj.map.side+""+idn)
				.attr("r", obj.dots_size_highlight*20.0);
			});
	}	
	s1.selectAll(".label"+obj.map.side)
		.attr("x", function(d) { var x = 0; if(d.id < obj.map.nodex.length) x = obj.map.nodex[d.id];	return x*obj.map.scale + obj.map.translate[0];})
		.attr("y", function(d) { var y = 0; if(d.id < obj.map.nodey.length) y = obj.map.nodey[d.id];	return y*obj.map.scale + obj.map.translate[1]-8.0;});
}

Label.prototype.UpdateLabelDot = function(idname, highlight)
{	
	var obj = this;
	if(highlight === true) 	obj.map.svg.selectAll(".dot"+obj.map.side+""+idname).attr("r", obj.dots_size_highlight*20.0);
	else					obj.map.svg.selectAll(".dot"+obj.map.side+""+idname).attr("r", obj.dots_size_default*20.0);
}