Lasso = function (map)
{
	this.map 			 = map;
}

Lasso.prototype.lasso_rectangle = null;	
Lasso.prototype.lasso			= null;
	
Lasso.prototype.Create = function()
{
	var obj = this;
	
	obj.lasso_rectangle = obj.map.svg.append("rect")
								.attr("width", 	obj.map.width)
								.attr("height", states.height)
								.style("opacity",0.0);

	// Define the lasso
	obj.lasso = d3.lasso()
			.closePathDistance(75) 		// max distance for the lasso loop to be closed
			.closePathSelect(true) 		// can items be selected by closing the path?
			.hoverSelect(true) 			// can items by selected by hovering over them?
			.area(obj.lasso_rectangle) 	// area where the lasso can be started
			.on("start",	function() {
				obj.lasso.items()
				.attr("r",obj.map.label.dots_size_default*obj.map.scale) // resetR size
				.classed({"not_possible":true,"selected":false}); // style as not possible
			}) 
			.on("draw",function() 
			{
				// Style the possible dots
				obj.lasso
					.items().filter(function(d) {return d.possible===true})
					.classed({"not_possible":false,"possible":true});

				// Style the not possible dot
				obj.lasso.items().filter(function(d) {return d.possible===false})
					.classed({"not_possible":true,"possible":false});
			})
			.on("end",function() {					
				var lassoNum = 0;
				obj.lasso.items().filter(function(d, i){ 
					if(d.selected===true)
						lassoNum = lassoNum + 1;
					});
					
				if(lassoNum <= 0)  return;
				
				obj.map.active_country.splice(0);
			
				// Style the selected dots
				obj.lasso.items()
					.filter(function(d) {
						if(d.selected===true)
						{							
							obj.map.selected_country = true;
							obj.map.active_country.push(d.id);						
							obj.map.g.selectAll(".country"+obj.map.side+"" + d.id)
									.classed("subunit-boundary-highlight", true);
							}
							return d.selected===true;
						})
					.classed({"not_possible":false,"possible":false})
					.attr("r",obj.map.label.dots_size_highlight*20.0);

				// reset the style of the not selected dots
				obj.lasso.items()
					.filter(function(d) 
					{	
						return d.selected===false
					})
					.classed({"not_possible":false, "possible":false})
					.attr("r", obj.map.label.dots_size_default*20.0);
										
					
				obj.map.groupingGroupStates.forEach(function(d, i)
				{
					if(d.length === obj.map.active_country.length)
					{
						var found = 0;
						obj.map.active_country.forEach(function(e){	found = found + (($.inArray(e, d) !== -1) ? 1 : 0);	});						
						if(found === d.length)
						{
							obj.map.active_country.splice(0);
							obj.map.active_country.push(obj.map.groupingNames[i]);
						}
					}
				});
				

				callOrdering(states.animation_duration);		
			}); // lasso end function

	// Init the lasso on the svg:g that contains the dots
	obj.map.svg.call(obj.lasso);

	obj.lasso.items(obj.map.svg.selectAll(".dot"));	
	obj.lasso_rectangle.attr("width", 0.0)
					   .attr("height", 0.0);
}

Lasso.prototype.Enable = function()
{
	var obj = this;
	obj.lasso_rectangle
		.attr("width", function(){ return obj.map.width;})
		.attr("height",function(){ return states.height; })
		.style("opacity",0.0);
}
	
Lasso.prototype.Disable = function()
{
	var obj = this;
	obj.lasso_rectangle
		.attr("width", function(){ return 0;})
		.attr("height",function(){ return 0; })
		.style("opacity",0.0);
}


