/**
 * Class to load the Configurations
 */

 /**
  * Constructor
  */
LoadConfigurationManager = function()
{
	var _dotsL_size_default = 0.1; 			var _dotsL_size_highlight = 0.1;
	var _dotsR_size_default = 0.1; 			var _dotsR_size_highlight = 0.1;
	var _textL_size_default = 0.1; 			var _textL_size_highlight = 0.1;
	var _textR_size_default = 0.1; 			var _textR_size_highlight = 0.1;
	var _mapL_fill_default = "#ff0000"; 	var _mapR_fill_default = "#ff0000";
	
	var _inputcountries = [];
	var _outputcountries = [];
		
	var _dictionaryFilesLeft = {};
	var _dictionaryFilesRight = {};	//Saves File->CountryName -> ID
	
	var sequential = [];	
	var diverging = new Array();	
	
	var _filename2index = {};
	_filename2index['user_defined'] = 0;
	_filename2index.n = 1;
	
	var groupsLeft	= null;
	var groupsRight =  null;
	var groupingGroupStatesLeft	= null;
	var groupingGroupStatesRight = null;
	
	var typeLeft	= "Tree";
	var typeRight 	= "Map";
	
	var _left_map_file = -1;
	var _right_map_file = -1;
	
	var pathDrawingLeft="";		
	var pathDrawingLeftKey="";		
	var pathLabelLeft="";		
	var pathLabelLeftKey="";
	
	var pathDrawingRight="";	
	var pathDrawingRightKey="";		
	var pathLabelRight="";		
	var pathLabelRightKey="";

	var _keyRight = 'Region1',		_keyLeft = 'Region2';
	var _data_map_file ="";

	var _columnKey=[];
	var _valueKey=[];

	LoadConfigurationManager.prototype.SetToDefault  = function()
	{
		_dotsL_size_default = 0.1; 		_dotsL_size_highlight = 0.1;
		_dotsR_size_default = 0.1; 		_dotsR_size_highlight = 0.1;
		_textL_size_default = 0.1; 		_textL_size_highlight = 0.1;
		_textR_size_default = 0.1; 		_textR_size_highlight = 0.1;
		_mapL_fill_default = "#ff0000"; _mapR_fill_default = "#ff0000";
		
		sequential = [];	
		diverging = new Array();	
		
		_inputcountries = [];
		_outputcountries = [];
		
		_dictionaryFilesLeft = {};
		_dictionaryFilesRight = {};	//Saves File->CountryName -> ID	
		
		_filename2index = {};	
		_filename2index['user_defined'] 	= 0;	
		_filename2index.n = 1;
		
		groupsLeft	= null;
		groupsRight =  null;
		
		groupingGroupStatesLeft	= null;
		groupingGroupStatesRight = null;
		
		typeLeft	= "Tree";
		typeRight 	= "Map";
		
		_left_map_file = -1;
		_right_map_file = -1;
		
		pathDrawingLeft="";		pathDrawingLeftKey="";	pathLabelLeft="";	pathLabelLeftKey="";
		pathDrawingRight="";	pathDrawingRightKey="";	pathLabelRight="";	pathLabelRightKey="";
		
		_data_map_file ="";
		_keyRight = 'Region1';
		_keyLeft = 'Region2';
		
		_columnKey=[];
		_valueKey=[];
	}
	
	LoadConfigurationManager.prototype.GetDataPath = function()
	{
		return _data_map_file;
	}
	
	LoadConfigurationManager.prototype.GetDataKey = function(side)
	{
		if(side === 'R') 	return _keyRight;
		else				return _keyLeft;
	}
	
	LoadConfigurationManager.prototype.GetDrawingType = function(side)
	{
		if(side === 'R') 	return typeRight;
		else				return typeLeft;
	}
	
	LoadConfigurationManager.prototype.GetDrawingFile = function(side)
	{
		if(side === 'R') 	return _right_map_file;
		else				return _left_map_file;
	}
	
	LoadConfigurationManager.prototype.GetDrawingPath = function(side)
	{
		if(side === 'R') 	return pathDrawingRight;
		else				return pathDrawingLeft;
	}
	
	LoadConfigurationManager.prototype.GetDrawingKey = function(side)
	{
		if(side === 'R') 	return pathDrawingRightKey;
		else				return pathDrawingLeftKey;
	}
	
	LoadConfigurationManager.prototype.GetLabelPath = function(side)
	{
		if(side === 'R') 	return pathLabelRight;
		else				return pathLabelLeft;
	}
	
	LoadConfigurationManager.prototype.GetLabelKey = function(side)
	{
		if(side === 'R') 	return pathLabelRightKey;
		else				return pathLabelLeftKey;
	}
	
	LoadConfigurationManager.prototype.GetColumnKeys = function()
	{
		return _columnKey;
	}
	
	LoadConfigurationManager.prototype.GetValueKeys = function()
	{
		return _valueKey;
	}
	
	LoadConfigurationManager.prototype.GetDiverging = function ()
	{
		return diverging;
	}
	
	LoadConfigurationManager.prototype.GetSequential = function ()
	{
		return sequential;
	}

	LoadConfigurationManager.prototype.SetMapFillColor = function (side, _map_fill_default)
	{
		if(side === 'L')	_mapL_fill_default = _map_fill_default;
		else				_mapR_fill_default = _map_fill_default;
	}

	LoadConfigurationManager.prototype.GetMapFillColor = function(side)
	{
		if(side === 'L')	return _mapL_fill_default;
		else				return _mapR_fill_default;
	}


	LoadConfigurationManager.prototype.SetDotsSizeDefault = function(side, _dots_size_default)
	{
		if(side === 'L')	_dotsL_size_default = _dots_size_default;
		else				_dotsR_size_default = _dots_size_default;
	}

	LoadConfigurationManager.prototype.GetDotsSizeDefault = function (side)
	{
		if(side === 'L')	return _dotsL_size_default;
		else				return _dotsR_size_default;
	}


	LoadConfigurationManager.prototype.SetDotsSizeHighlight = function (side, _dots_size_highlight)
	{
		if(side === 'L')	_dotsL_size_highlight = _dots_size_highlight;
		else				_dotsR_size_highlight = _dots_size_highlight;
	}

	LoadConfigurationManager.prototype.GetDotsSizeHighlight = function(side)
	{
		if(side === 'L')	return _dotsL_size_highlight;
		else				return _dotsR_size_highlight;
	}


	LoadConfigurationManager.prototype.SetTextSizeDefault = function(side, _text_size_default)
	{
		if(side === 'L')	_textL_size_default = _text_size_default;
		else				_textR_size_default = _text_size_default;
	}

	LoadConfigurationManager.prototype.GetTextSizeDefault = function(side)
	{
		if(side === 'L')	return _textL_size_default;
		else				return _textR_size_default;
	}


	LoadConfigurationManager.prototype.SetTextSizeHighlight = function(side, _text_size_highlight)
	{
		if(side === 'L')	_textL_size_highlight = _text_size_highlight;
		else				_textR_size_highlight = _text_size_highlight;
	}

	LoadConfigurationManager.prototype.GetTextSizeHighlight = function (side)
	{
		if(side === 'L')	return _textL_size_highlight;
		else				return _textR_size_highlight;
	}

	
	LoadConfigurationManager.prototype.GetCountries = function(side)
	{
		if(side === 'R') 	return _inputcountries;
		else				return _outputcountries;
	}
	
	LoadConfigurationManager.prototype.GetDictionary = function(side)
	{
		if(side === 'R') 	return _dictionaryFilesRight;
		else				return _dictionaryFilesLeft;
	}
	
	LoadConfigurationManager.prototype.GetFilename2Index = function()
	{
		return _filename2index;
	}
	
	LoadConfigurationManager.prototype.GetGroup = function(side)
	{
		if(side === 'R') 	return groupsRight;
		else				return groupsLeft;
	}
	
	LoadConfigurationManager.prototype.GetGroupCountries = function(side)
	{
		if(side === 'R') 	return groupingGroupStatesRight;
		else				return groupingGroupStatesLeft;
	}
	
	
	LoadConfigurationManager.prototype.Load = function(xml)
	{
		var obj = this;
		var r = [], c	;
		var first = false;
		
		if (typeof fid === 'undefined') 
		{
			$("#dataset option").each(function() { $(this).remove(); });	
			var mySelectDataset = $('#dataset');
			$(xml).find('application data files').each(function(){ 				
				var id = $(this).attr('id');		
				var name = $(this).attr('name');			
				mySelectDataset.append($('<option></option>').val(id).html(name));							
			});	
			
			fid = 1;
			first = true;
		}
		
		var origin = 		$(xml).find('files[id='+ fid +'] map_left name').each(function(){ return $(this).text(); });
		var destinition = 	$(xml).find('files[id='+ fid +'] map_right name').each(function(){ return $(this).text(); });	
		var columns = 		$(xml).find('files[id='+ fid +'] heatmap columns column').each(function(){ return $(this).text(); });
		
		typeLeft = 			$(xml).find('files[id='+ fid +'] map_left').attr("type"); 		
		typeRight = 		$(xml).find('files[id='+ fid +'] map_right').attr("type"); 		
			
		states.widthL = 	+$(xml).find('visualization elements map left size').attr("width"); 		
		states.widthM = 	+$(xml).find('visualization elements heatmap size').attr("width"); 		
		states.widthML = 	+$(xml).find('visualization elements heatmap label_left').attr("width"); 		
		states.widthMR = 	+$(xml).find('visualization elements heatmap label_right').attr("width"); 		
		states.widthMM = 	states.widthM - states.widthML - states.widthMR;
		states.widthR = 	+$(xml).find('visualization elements map right size').attr("width"); 		
		states.width = 		states.widthL + states.widthM + states.widthR;
		states.height = 	+$(xml).find('visualization').attr("height"); 	
		
		/////////////////////////////////
		//SETUP ZOOM VALUES: 
		var minScaleL =  +$(xml).find('files[id='+ fid +'] map_left zoom').attr("minScale"),	maxScaleL =  +$(xml).find('files[id='+fid+'] map_left zoom').attr("maxScale"); 		
		var minScaleR =  +$(xml).find('files[id='+ fid +'] map_right zoom').attr("minScale"),	maxScaleR =  +$(xml).find('files[id='+fid+'] map_right zoom').attr("maxScale"); 			
				
		zoomL.translate([0,0])
			 .scale(maxScaleL)
			 .scaleExtent([minScaleL, maxScaleL]);
		zoomR.translate([0,0])
			 .scale(maxScaleR)
			 .scaleExtent([minScaleR, maxScaleR]);	
		
		/////////////////////////////////

		pathDrawingLeft =  		$(xml).find('files[id='+ fid +'] map_left paths path_drawing').text();		pathDrawingLeftKey =  	$(xml).find('files[id='+fid+'] map_left paths path_drawing').attr("key");
		pathDrawingRight =  	$(xml).find('files[id='+ fid +'] map_right paths path_drawing').text();		pathDrawingRightKey =   $(xml).find('files[id='+fid+'] map_right paths path_drawing').attr("key");

		pathLabelLeft =  		$(xml).find('files[id='+ fid +'] map_left paths path_label').text();		pathLabelLeftKey =  	$(xml).find('files[id='+fid+'] map_left paths path_label').attr("key");
		pathLabelRight =  		$(xml).find('files[id='+ fid +'] map_right paths path_label').text();		pathLabelRightKey =  	$(xml).find('files[id='+fid+'] map_right paths path_label').attr("key");
		
		 /////////////////////////////////
		 $(xml).find('files[id='+ fid +'] heatmap paths data').each(function(index){
			var filepath ="";
			var inputKey ="";
			var outputKey="";
			_columnKey=[];
			_valueKey=[];
			
			if($(this).attr("calculation_sum_automatic") === 'false')  	states.auto_calcsum = false;
			else														states.auto_calcsum = true;
			
			$(this).find('file').each(function(){	filepath = $(this).text();			});		
			$(this).find('input').each(function(){	inputKey = $(this).attr("key");		});		
			$(this).find('output').each(function(){	outputKey = $(this).attr("key");	});	

			$(this).find('column').each(function(){			
				var cs = $(this).attr("key");
				
				if(typeof(cs) === 'undefined' || cs === "")
				{
					$(this).find('c').each(function(){			
						var cs2 = $(this).attr("key");
						_columnKey.push(cs2);
					});
				}
				else _columnKey.push(cs);
			});		
			$(this).find('values').each(function(){			
							
				$(this).find('values value').each(function(){			
					var cs = $(this).attr("key");
					
					if(typeof(cs) === 'undefined' || cs === "")
					{
						$(this).find('values value v').each(function(){							
							var cs2 = $(this).attr("key");
							_valueKey.push(cs2);
						});				
					}
					else _valueKey.push(cs);
				});
			});				
			
			_filename2index[filepath] = _filename2index.n;
			_filename2index.n++;
			_data_map_file = filepath;
			_keyRight = inputKey;	
			_keyLeft = outputKey;
		});
		
		$(xml).find('files[id='+ fid +'] map_left paths').each(function(index){
			
			var filepath ="";
			$(this).find('path_drawing').each(function(){			
				filepath = $(this).text();
				$(this).attr("key");
			});
			
			if (typeof(_filename2index[filepath]) === 'undefined')	
			{
				_filename2index[filepath] = _filename2index.n;
				_left_map_file = _filename2index.n;
				_filename2index.n++;
			}
			else	_left_map_file = _filename2index[filepath];
			

			filepath ="";		
			$(this).find('path_label').each(function(){			
				filepath = $(this).text();
				$(this).attr("key");
			});	
			
			if (typeof(_filename2index[filepath]) === 'undefined')	
			{		
				_filename2index[filepath] = _filename2index.n;		
				_filename2index.n++;
			}		
			
		});
		
		$(xml).find('files[id='+ fid +'] map_right paths').each(function(index){
			var filepath="";
			$(this).find('path_drawing').each(function(){			
				filepath = $(this).text();
				$(this).attr("key");
			});		
			
			if (typeof(_filename2index[filepath]) === 'undefined')	
			{
				_filename2index[filepath] = _filename2index.n;
				_right_map_file = _filename2index.n;
				_filename2index.n++;
			}
			else	_right_map_file = _filename2index[filepath];		
			
			filepath="";
			$(this).find('path_label').each(function(){			
				filepath = $(this).text();
				$(this).attr("key");
			});	
			
			if (typeof(_filename2index[filepath]) === 'undefined')	
			{		
				_filename2index[filepath] = _filename2index.n;		
				_filename2index.n++;
			}	
		});
		
		//UPDATE KEYS & COLUMN
		_dictionaryFilesLeft = {};
		_dictionaryFilesRight = {};
		
		_inputcountries = [];	groupsRight = [];
		_outputcountries = [];	groupsLeft = [];
		_colLabel=[];
		$(xml).find('files[id='+ fid +'] heatmap keys input').each(function(index){ 
			var key_name = $(this).attr("name");
			_inputcountries.push(key_name);
			if(!_dictionaryFilesRight[key_name]) _dictionaryFilesRight[key_name]=[];
			_dictionaryFilesRight[key_name][0] = _inputcountries.length-1;	
			
			if($(this).attr("group") === "true")	
				groupsRight.push(_inputcountries.length-1)
			
			$(this).find('file').each(function(){				
				var tmpfile = $(this).text();	
				var tmpname = $(this).attr("name");
				
				if(!_dictionaryFilesRight[tmpname]) _dictionaryFilesRight[tmpname]=[];
				_dictionaryFilesRight[tmpname][_filename2index[tmpfile]] = _inputcountries.length-1;			
			});
		});
		$(xml).find('files[id='+ fid +'] heatmap keys output').each(function(){ 
			var key_name = $(this).attr("name");
			_outputcountries.push($(this).attr("name")); 
			if(!_dictionaryFilesLeft[key_name]) _dictionaryFilesLeft[key_name]=[];
			_dictionaryFilesLeft[key_name][0] = _outputcountries.length-1;			
			
			if($(this).attr("group") === "true")	
				groupsLeft.push(_outputcountries.length-1)
			
			$(this).find('file').each(function(){				
				var tmpfile = $(this).text();	
				var tmpname = $(this).attr("name");
				
				if(!_dictionaryFilesLeft[tmpname]) _dictionaryFilesLeft[tmpname]=[];
				_dictionaryFilesLeft[tmpname][_filename2index[tmpfile]] = _outputcountries.length-1;			
			});
		});	
		$.each(columns, function(d, text){_colLabel.push(text.textContent);});
		
		
		///////////////////
		var n = 0;
		groupingGroupStatesLeft = [];	
		$(xml).find('files[id='+ fid +'] heatmap groupings output group').each(function(){
			var key_name = $(this).attr("name");
			groupingGroupStatesLeft.push([]);
			
			$(this).find('key').each(function(){				
				var key = $(this).text();	
				groupingGroupStatesLeft[n].push(_dictionaryFilesLeft[key][0]);
			});
			n = n + 1;
		});
		
		n = 0;
		groupingGroupStatesRight = [];
		$(xml).find('files[id='+ fid +'] heatmap groupings input group').each(function(){
			var key_name = $(this).attr("name");		
			groupingGroupStatesRight.push([]);
			
			$(this).find('key').each(function(){				
				var key = $(this).text();	
				groupingGroupStatesRight[n].push(_dictionaryFilesRight[key][0]);
			});
			n = n + 1;
		});
		
		
		////////////////////
		//SETUP Colorscales		
		var htmlSequentiel = $('#color_absolut');
		$(xml).find('colorscales_absolut colorscale').each(function(i) 
		{
			var tmp_name = $(this).attr("name");
			var tmp_colors = [];
			$(this).find('color').each(function(){	tmp_colors.push($(this).text());	});
			sequential[tmp_name] = {name: tmp_name, color: tmp_colors};
			sequential.push(tmp_name);
			if(first === true)	htmlSequentiel.append($('<option></option>').val(i).html(tmp_name))		
		});		
		
		var htmlDiverging = $('#color_relative');
		$(xml).find('colorscales_differences colorscale').each(function(i) 
		{
			var tmp_name = $(this).attr("name");
			var tmp_colors = [];
			$(this).find('color').each(function(){	tmp_colors.push($(this).text());	});
			tmp_colors.reverse();
			diverging[tmp_name] = {name: tmp_name, color: tmp_colors};
			diverging.push(tmp_name);
			if(first === true)	htmlDiverging.append($('<option></option>').val(i).html(tmp_name))
		});

		///////////////////////
		//Layout information
		$(xml).find('files[id='+ fid +'] map_left background_items').each(function(i) 	{	_mapL_fill_default = $(this).text();		});
		$(xml).find('files[id='+ fid +'] map_right background_items').each(function(i)	{	_mapR_fill_default = $(this).text();		});	
		
		$(xml).find('files[id='+ fid +'] map_left labels size').each(function(i) 		{	obj.SetTextSizeDefault('L', $(this).attr("default"));	obj.SetTextSizeHighlight('L', 	$(this).attr("highlight"));	});
		$(xml).find('files[id='+ fid +'] map_right labels size').each(function(i) 		{	obj.SetTextSizeDefault('R', $(this).attr("default"));	obj.SetTextSizeHighlight('R', 	$(this).attr("highlight"));	});	
		$(xml).find('files[id='+ fid +'] map_left dots size').each(function(i) 			{	obj.SetDotsSizeDefault('L', $(this).attr("default"));	obj.SetDotsSizeHighlight('L', 	$(this).attr("highlight"));	});
		$(xml).find('files[id='+ fid +'] map_right dots size').each(function(i) 		{	obj.SetDotsSizeDefault('R', $(this).attr("default"));	obj.SetDotsSizeHighlight('R', 	$(this).attr("highlight"));	});
			
		///////////////////////
		//UPDATE TITLE
		var element = document.getElementById("origin");	element.innerHTML = origin.text();	
		element = document.getElementById("destination");	element.innerHTML = destinition.text();	
		
		//////////////////////
		//ANIMATION DURATION
		states.animation_duration = +$(xml).find('animation duration').text();	
		
		states.num_objs = +$(xml).find('visualization number_of_objects').text();	
		if (typeof states.num_objs === 'undefined') 	states.num_objs = 20000;
			
		
		//////////////////////
		// States
		states.enable_visuallinks 			= $(xml).find('visualization elements visual_links').attr("enable") == "true" 			? true : false;
		states.enable_tooltip_visuallinks 	= $(xml).find('visualization elements visual_links tooltip').attr("enable") == "true" 	? true : false;
		states.enable_tooltip_map 			= $(xml).find('visualization elements map tooltip').attr("enable") == "true" 			? true : false;
		states.enable_tooltip_heatmap 		= $(xml).find('visualization elements heatmap tooltip').attr("enable") == "true" 		? true : false;
			
		states.elementsGUI = [];
		states.elementsGUI.push($(xml).find("visualization elements hud").attr("gui_key"));
		states.elementsGUI.push($(xml).find("visualization number_of_objects").attr("gui_key"));
		states.elementsGUI.push($(xml).find("visualization animation duration").attr("gui_key"));
		states.elementsGUI.push($(xml).find("visualization elements visual_links tooltip").attr("gui_key"));
		states.elementsGUI.push($(xml).find("visualization elements map tooltip").attr("gui_key"));
		states.elementsGUI.push($(xml).find("visualization elements heatmap tooltip").attr("gui_key"));
		
		states.dictionaryGUI=[];
		states.dictionaryGUI[$(xml).find("visualization elements hud").attr("gui_key")] = "ShowHUD";
		states.dictionaryGUI[$(xml).find("visualization number_of_objects").attr("gui_key")] = "NumberOfObjects";	
		states.dictionaryGUI[$(xml).find("visualization animation duration").attr("gui_key")] = "AnimationDuration";		
		states.dictionaryGUI[$(xml).find("visualization elements visual_links tooltip").attr("gui_key")] = "ToolTipVisualLink";
		states.dictionaryGUI[$(xml).find("visualization elements map tooltip").attr("gui_key")] = "ToolTipMap";
		states.dictionaryGUI[$(xml).find("visualization elements heatmap tooltip").attr("gui_key")] = "ToolTipHeatmap";	
		
		states.AddGUICallback();
		
		//Load Sortings
		//TODO FRAGEN WAS MAN DA RICHTIG TUN SOLLTE bzw. WIE SIE ES HABEN MCHTEN
		

		//UPDATE ATTRIBUTE OPTION
		states.attributes_file_path.splice = {}//, states.attributes_list = [];
		//for (var member in states.attributes_file_path.splice) delete states.attributes_file_path.splice[member];
		states.attributes_list = [];
			
		$("#attribute option").each(function() { $(this).remove(); });	
		$("#ts_attribute button").each(function() { $(this).remove(); });	
		var mySelect = $('#attribute');
		var mySelectTS = $('#ts_attribute');
		var attribute = $(xml).find('files[id='+fid+'] heatmap attributes attribute').each(function(val){ 
			var at = $(this).text()
			var fi = $(this).attr('file');		
			states.attributes_list.push(at);
			states.attributes_file_path[fi] = at;
			mySelect.append($('<option></option>').val(at).html(at));		
			if(mySelectTS && mySelectTS !== null)
				mySelectTS.append(
				$('<button></button>')
				.attr("class", "btnGUI")
				.attr("style", "width: 150px; height: 50px")
				.attr("onclick", "ChangeAttribute('"+at+"')")
				.val(at)
				.html(at)
			);		
			return at; 
		});		
		
		states.data_attribute = states.attributes_list[0];		
	}
}
  