LoadData = function(_inputcountries, _outputcountries, _dictionaryFilesLeft, _dictionaryFilesRight, _columnKey, _valueKey)
{
	this.inputcountries 		= _inputcountries;
	this.outputcountries 		= _outputcountries;
	this.dictionaryFilesLeft 	= _dictionaryFilesLeft; 
	this.dictionaryFilesRight 	= _dictionaryFilesRight;
	this.columnKey				= _columnKey;
	this.valueKey				= _valueKey;
}

LoadData.prototype.LoadDataFile = function(error, entry, callback, data, colLabel, keyRight, keyLeft)
{			
	var obj = this;
	
	
	entry.forEach(function(i){			
		if(obj.dictionaryFilesRight[i[keyRight]] && obj.dictionaryFilesLeft[i[keyLeft]]){						
			var vto = obj.dictionaryFilesLeft[i[keyLeft]][1];				
			var nto = obj.outputcountries[vto];
			
			var vfr = obj.dictionaryFilesRight[i[keyRight]][1];				
			var nfr = obj.inputcountries[vfr];
						
			if(obj.columnKey.length === 1)
			{
				var y = i[obj.columnKey[0]];					
				var v = +i[states.data_attribute];
								
				data.push({
							"From": nfr,	"To": nto,
							"FromKey": vfr,	"ToKey": vto,
							"Year": y,
							"Value": v
							});												
			}
			else
			{
				for(var n = 0; n < obj.columnKey.length; n++)
				{										
					var y = obj.columnKey[n], v = 0/0;
					var k = obj.valueKey[n];
					if(i[y]) v = +i[k];
											
					data.push({
							"From": nfr,	"To": nto,
							"FromKey": vfr,	"ToKey": vto,
							"Year": y,
							"Value": v,
							});			
				}
			}
		}
		else if((i[keyRight] === "ALL" || i[keyLeft] === "ALL")	&& states.auto_calcsum === false)
		{
			var vto = obj.inputcountries.length;
			var vfr = obj.outputcountries.length;
			var nto = "ALL";
			var nfr = "ALL";
			
			if(obj.dictionaryFilesRight[i[keyRight]])		
			{					
				vfr = obj.dictionaryFilesRight[i[keyRight]][1];				
				nfr = obj.inputcountries[vfr];
			}
			if(obj.dictionaryFilesLeft[i[keyLeft]]) 	
			{					
				vto = obj.dictionaryFilesLeft[i[keyLeft]][1];
				nto = obj.outputcountries[vto];
			}
			
			if(obj.columnKey.length === 1)
			{
				var y = i[obj.columnKey[0]];					
										
				data.push({
							"From": nfr,	"To": nto,
							"FromKey": vfr,	"ToKey": vto,
							"Year": y,
							"Value": +i[states.data_attribute]
							});		
			}
			else
			{
				colLabel.forEach(function(j)
				{					
					var y = j, v = 0/0;
					if(i[y]) v = +i[y];
					data.push({
								"From": nfr,		"To": nto,
								"FromKey": vfr,		"ToKey": vto,
								"Year": y,
								"Value": v,
							});
				});
			}
		}
	});	
			
	if(states.auto_calcsum === true)
	{
		var res_to = Enumerable.From(data)
						.GroupBy(
							"{ T: $.ToKey, Y: $.Year }",
							"{ Value: $.Value }",
							function (key, group) { return { To: key.T, Year: key.Y, Result: group.Sum("$.Value")};},
							"$.T*$.Y"
						)
						.ToArray();
		
		var res_from = Enumerable.From(data)
						.GroupBy(
							"{ F: $.FromKey, Y: $.Year }",
							"{ Value: $.Value }",
							function (key, group) { return { From: key.F, Year: key.Y, Result: group.Sum("$.Value")};},
							"$.F*$.Y"
						)
						.ToArray();
						
		res_to.forEach(function(d, i)
		{
			data.push(
			{
				"From": "ALL", 						"To": obj.outputcountries[d.To],
				"FromKey": obj.inputcountries.length, 	"ToKey": d.To,
				"Year": d.Year,
				"Value": d.Result
			});
		});
													
		res_from.forEach(function(d, i)
		{
			data.push(
			{
				"From": obj.inputcountries[d.From],    "To": "ALL",
				"FromKey": d.From, 					"ToKey": obj.outputcountries.length,
				"Year": d.Year,
				"Value": d.Result
			});
		});
	}
	
	callback(null);
}
	
LoadData.prototype.LoadDataEntries = function ( callback, 	data, path, colLabel, keyRight, keyLeft) 
{
	var obj = this;
	data.splice();
	var type = path.substring(path.length-3, path.length);
	if(type === 'csv')	d3.csv(path, function(error, entry) { return obj.LoadDataFile(error, entry, callback, data, colLabel, keyRight, keyLeft); });
	else				d3.tsv(path, function(error, entry) { return obj.LoadDataFile(error, entry, callback, data, colLabel, keyRight, keyLeft); });
};


LoadData.prototype.LoadDataCapitals = function ( callback, 	dataCapitals, filepath, filename2index) 
{
	//country-capitals.csv
	var obj = this;
		
	file_type = "csv";
	switch(file_type)
	{
		case 'csv': d3.csv("data/"+filepath, 
			function(err, capitals){	
				obj.loadDataCapitalsTupel(err, capitals, callback, dataCapitals, filepath, filename2index);	}); 
			break;
		case 'tsv': d3.tsv("data/"+filepath,
			function(err, capitals){	
				obj.loadDataCapitalsTupel(err, capitals, callback, dataCapitals, filepath, filename2index);	});
			break;
	}
};

LoadData.prototype.loadDataCapitalsTupel = function(err, capitals, callback, dataCapitals, filepath, filename2index) 
{			
	var obj = this;
	
	capitals.forEach(function(i)
	{		
		if(obj.dictionaryFilesLeft[i.CountryName] && obj.dictionaryFilesLeft[i.CountryName][filename2index[filepath]] >= 0)
		{
			var id = obj.dictionaryFilesLeft[i.CountryName][filename2index['country-capitals.csv']];
			dataCapitals.push(
			{
				"Country": obj.outputcountries[id],
				"Longitude": +i.CapitalLongitude,
				"Latitude": +i.CapitalLatitude
			});			
		}					
		
		if(obj.dictionaryFilesRight[i.CountryName] && obj.dictionaryFilesRight[i.CountryName][filename2index[filepath]] >= 0)
		{
			var id = obj.dictionaryFilesRight[i.CountryName][filename2index[filepath]];
			dataCapitals.push(
			{
				"Country": obj.inputcountries[id],
				"Longitude": +i.CapitalLongitude,
				"Latitude": +i.CapitalLatitude
			});	
		}
	});
	callback(null);	
}
