LoadMap = function(_dictionaryFiles, _filename2index, _countries, _groups)
{
	this.path = null;
	this.topo = null;
	this.nodex = [];
	this.nodey = [];
	
	var dictionaryFiles = _dictionaryFiles;
	var filename2index	= _filename2index;
	var countries		= _countries;
	var groups			= _groups;
	
	LoadMap.prototype.Load = function(callback, path2file, keyName)
	{	
		var obj = this;
		d3.json("data/"+path2file, function(error, world) 
		{
			obj.topo = topojson.feature(world, world.objects.countries).features;				
			callback(null);
		});	
	}

	function LoadTupel(err, capitals, callback, obj, keyName, longitude, latitude, dictionaryFiles, countries, path2file, filename2index, dictSettedLabels)
	{
		var projection = d3.geo.mercator()
			.translate([0,0])
			.scale(20);		
				
		obj.path = d3.geo.path().projection(projection);
		
		capitals.forEach(function(i)
		{	
			var key = i[keyName];		
			
			if(dictionaryFiles[key] 
			&& dictionaryFiles[key][filename2index[path2file]] >= 0)
			{
				var id = dictionaryFiles[key][filename2index[path2file]];				
				dictSettedLabels[id] = true;	
				obj.nodex[id] = (projection([+i[longitude], +i[latitude]])[0]);
				obj.nodey[id] = (projection([+i[longitude], +i[latitude]])[1]);		
			}
		});
				
		var n = 0; 
		countries.forEach(function(d,id){	
			if(dictSettedLabels[id] === false && $.inArray(id, groups) === -1)
			{
				obj.nodex[id] = (n%5) * 2;
				obj.nodey[id] = Math.floor(n/5)-10;		
				n = n+1;
			}
		});
		
		callback(null);	
	}
																	
	LoadMap.prototype.LoadLabel = function(callback, path2file, keyName)
	{	
		var longitude = 'CapitalLongitude';
		var latitude  = 'CapitalLatitude';
		
		var obj = this;		
		
		var dictSettedLabels = []
		countries.forEach(function(d,i) { dictSettedLabels[i] = false; });
		
		var type = path2file.substring(path2file.length-3, path2file.length);
		if(type === 'csv')	d3.csv("data/"+path2file, function(err, capitals){	return LoadTupel(err, capitals, callback, obj, keyName, longitude, latitude, dictionaryFiles, countries, path2file, filename2index, dictSettedLabels);	});	
		else				d3.tsv("data/"+path2file, function(err, capitals){	return LoadTupel(err, capitals, callback, obj, keyName, longitude, latitude, dictionaryFiles, countries, path2file, filename2index, dictSettedLabels);	});	
	}

}