LoadTree = function(_dictionaryFiles, _filename2index, _countries, _groups)
{
	this.path = null;
	this.topo = null;
	
	this.nodex = [];
	this.nodey = [];
	
	this.varNodex = [];
	this.varNodey = [];
	this.varName = [];
	
	var dictionaryFiles = _dictionaryFiles;
	var filename2index	= _filename2index;
	var countries		= _countries;
	var groups			= _groups;
	
	
	LoadTree.prototype.Load = function(callback, path2file, keyName)
	{	
		var obj = this;
		
		obj._nodex = [];
		obj._nodey = [];
		
		obj.varNodex = [];
		obj.varNodey = [];
		obj.varName = [];
		
		var fM = filename2index[path2file];
			
		var l = 0.2;
		var diameter = 5;
		var tree = d3.layout.tree()
			.size([360, diameter / 2 - 120])
			.separation(function(a, b) { return (a.parent == b.parent ? 1 : 2) / a.depth; });
		
		obj.path = d3.svg.diagonal()
						.projection(function(d) { return [-l*d.y, l*d.x ];});
			
		d3.json("data/"+path2file, function(error, root) 
		{						
			var nodes = tree.nodes(root);
			obj.topo = tree.links(nodes);
								
			nodes.forEach(function(n)
			{
				var key = n[keyName];
				if(key)
				{
					var id = dictionaryFiles[key][fM];
					obj.nodex[id] = -l * n.y;
					obj.nodey[id] =  l * n.x;
				}
				else
				{
					obj.varNodex.push((-l * n.y))
					obj.varNodey.push(( l * n.x))
					obj.varName.push(n.name);
				}
			});
			callback(null);
		});
	}
										
	LoadTree.prototype.LoadLabel = function(callback, path2file, keyName)
	{			
		var obj = this;	
			callback(null);	
	}
}