function definitions()
{
	mapRight 			= null, 		mapLeft = null;
	loaderLeft			= null, 		loaderRight = null; 
	visLinkRight 		= null, 		visLinkLeft = null;
	colormapSequential 	= null, 		colormapDiverging = null;
	_lassoRight 		= null,	 		_lassoLeft = null;
	_legend 			= null;
	_spinner 			= null;
	_heatmap	 		= null;
	_tooltip 			= null;
	_sortingObj 		= null;
	dataObj 			= null;
	//states				= new States();		
	configuration 		= new LoadConfigurationManager();
	
	_index2input = [];
	_index2output = [];
	_colLabel = [];				//FOR COLUMNS		
	
	configuration.SetToDefault();
}

function navR()
{
	mapRight.zoom.scale(mapRight.scale);
	mapRight.zoom.translate(mapRight.translate);
	moveR();
}
function navR_left(){	mapRight.translate[0] += 10;	navR(); 	}
function navR_right(){	mapRight.translate[0] -= 10;	navR();		}
function navR_top(){	mapRight.translate[1] += 10;	navR();		}
function navR_bottom(){	mapRight.translate[1] -= 10;	navR();		}
function navR_zoomIn(){	mapRight.scale += 5;			navR();		}
function navR_zoomOut(){mapRight.scale -= 5;			navR();		}
	
function navM()
{
	_heatmap.zoom.scale(_heatmap.scaleMiddle);
	_heatmap.zoom.translate(_heatmap.translateMiddle);
	moveM();
}
function navM_left(){	_heatmap.translateMiddle[0] += 10;	navM(); 	}
function navM_right(){	_heatmap.translateMiddle[0] -= 10;	navM();		}
function navM_top(){	_heatmap.translateMiddle[1] += 10;	navM();		}
function navM_bottom(){	_heatmap.translateMiddle[1] -= 10;	navM();		}
function navM_zoomIn(){	_heatmap.scaleMiddle += 0.1;			navM();		}
function navM_zoomOut(){_heatmap.scaleMiddle -= 0.1;			navM();		}

function navL()
{
	mapLeft.zoom.scale(mapLeft.scale);
	mapLeft.zoom.translate(mapLeft.translate);
	moveL();
}
function navL_left(){	mapLeft.translate[0] += 10;	navL();		}
function navL_right(){	mapLeft.translate[0] -= 10;	navL();		}
function navL_top(){	mapLeft.translate[1] += 10;	navL();		}
function navL_bottom(){	mapLeft.translate[1] -= 10;	navL();		}
function navL_zoomIn(){	mapLeft.scale += 5;			navL();		}
function navL_zoomOut(){mapLeft.scale -= 5;			navL();		}

function button_lasso()
{
	(states.crtl_pressed === true) ? states.crtl_pressed = false : states.crtl_pressed = true;
	(states.buttonlasso === true) ? states.buttonlasso = false : states.buttonlasso = true;
	
	if(states.crtl_pressed === true)
	{
		_lassoRight.Enable();
		_lassoLeft.Enable();			
		$("#but_lassoL").attr("class", "btnEnable");	
		$("#but_lassoR").attr("class", "btnEnable");	
	}
	else
	{
		_lassoRight.Disable();
		_lassoLeft.Disable();			
		$("#but_lassoR").attr("class", "btn");	
		$("#but_lassoL").attr("class", "btn");	
	}
}

function ChangeAttribute(value)
{
	states.displaystate = 'normal';
	$("#but_origin").attr("class", "btn");
	$("#but_all").attr("class", "btn");		
	$("#but_destinition").attr("class", "btn");
		
	console.log("value" + value);
	states.data_attribute  = value;	
	initialize(states.data_attribute);
}

function ChangeDataset(value)
{
	definitions();
	_index2input = [];
	_index2output = [];
	
	states.displaystate = 'normal';
	$("#but_origin").attr("class", "btn");
	$("#but_all").attr("class", "btn");		
	$("#but_destinition").attr("class", "btn");
	
	console.log("value" + value);
	
	_spinner = new LoadingSpinner();
	_spinner.start(document.getElementById("chart"));
	
	fid = value;
	xmlDoc=LoadConfiguration("data/config-AT-CEEPUS.xml");
}

function LoadConfiguration(filename)
{
	$(document).ready(function()
	{	
		$.ajax({
			type: "GET",
			url: filename,
			dataType: 'xml',
			cache: false,
			success: LoadConfig
		});
	});
}

function LoadConfig(xml)
{		
	configuration.Load(xml);
	
	var sequential = configuration.GetSequential();
	var diverging = configuration.GetDiverging();
	
	colormapSequential = new ColorMapping(sequential, sequential[0], _heatmap);
	colormapDiverging = new ColorMapping(diverging, diverging[0], _heatmap);	
	initialize(states.data_attribute);
}
  
function LoadDrawing(q, loader, type, dictionaryFiles, file1, key1, file2, key2, countries, groups)
{
	if(type === "Tree" || type=== "tree")	loader[0] = new LoadTree(dictionaryFiles, configuration.GetFilename2Index(), countries, groups);	
	else									loader[0] = new LoadMap(dictionaryFiles, configuration.GetFilename2Index(), countries, groups);			
	q.defer(function(callback) 	{		loader[0].Load(callback, file1, key1);		});				
	q.defer(function(callback)	{		loader[0].LoadLabel(callback, file2, key2);	});
}

function Load_Data(q, data, _dataCapitals)
{
	var loadData = new LoadData(configuration.GetCountries('R'), configuration.GetCountries('L'), configuration.GetDictionary('L'), configuration.GetDictionary('R'), configuration.GetColumnKeys(), configuration.GetValueKeys());
	q.defer(function(callback) {	loadData.LoadDataCapitals(callback, _dataCapitals, "country-capitals.csv", configuration.GetFilename2Index());													});		
	q.defer(function(callback) {	loadData.LoadDataEntries( callback, data, "data/"+configuration.GetDataPath(), _colLabel, configuration.GetDataKey('R'), configuration.GetDataKey('L')) 		});			
}
 
function initialize(attribute)
{
	var q = queue();
	
	var _data = [];
	var _dataCapitals = [];
	var loaderLeftRef = [loaderLeft];		LoadDrawing(q, loaderLeftRef,  configuration.GetDrawingType('L'),  configuration.GetDictionary('L'),  configuration.GetDrawingPath('L'), configuration.GetDrawingKey('L'), configuration.GetLabelPath('L'), configuration.GetLabelKey('L'),  configuration.GetCountries('L'), configuration.GetGroup('L'));	loaderLeft = loaderLeftRef[0];
	var loaderRightRef = [loaderRight];		LoadDrawing(q, loaderRightRef, configuration.GetDrawingType('R'), configuration.GetDictionary('R'),   configuration.GetDrawingPath('R'), configuration.GetDrawingKey('R'), configuration.GetLabelPath('R'), configuration.GetLabelKey('R'), configuration.GetCountries('R'), configuration.GetGroup('R'));	loaderRight = loaderRightRef[0];
	Load_Data(q, _data ,_dataCapitals)
	
	q.await(function(err, results)
	{			
		var actualIndicesHM = [];
	
		dataObj = new Data(_data);
		dataObj.calcDataStructures(_colLabel, configuration.GetCountries('R'), configuration.GetCountries('L'), _colLabel.length);
		dataObj.calcGrouping(_colLabel);
	
		var dataC = [];
		for(var i = 0; i < _data.length; i++)
		{			
			dataC.push(
				{
					"From": 	_data[i].From,
					"To": 		_data[i].To,
					"FromKey": 	_data[i].FromKey,
					"ToKey": 	_data[i].ToKey,
					"Year": 	_data[i].Year,
					"Value": 	(isNaN(_data[i].Value)) ? 0.0 : _data[i].Value,
				}
			);
		};
		
		_sortingObj = new Sorting();
		_sortingObj.Calculate(dataC, _dataCapitals, configuration.GetCountries('R'), configuration.GetCountries('L'), _colLabel);		
		actualIndicesHM = _sortingObj.GetSortingArray().slice();
				
		_index2input = [];	_index2output = [];		
		actualIndicesHM.forEach(function(d, k)
		{			
			var id = d;			
			var id2 	= id % configuration.GetCountries('L').length;
			var id1 	= (id-id2) / configuration.GetCountries('L').length;		
				
			if(id1 < configuration.GetCountries('R').length && id2 < configuration.GetCountries('L').length)
			{
				_index2input.push(id1);				
				_index2output.push(id2);
			}				
		});
		///////////////		
		
		_tooltip = new ToolTip(configuration.GetCountries('R'), configuration.GetCountries('L'), configuration.GetDictionary('R'), configuration.GetDictionary('L'));
		_tooltip.dataC = dataC;
		_tooltip.Calculate();
				
		var data2 = [];
		_data.forEach(function(d, i)
		{			
			data2[i] = {
				row:   actualIndicesHM.indexOf(d.FromKey * (configuration.GetCountries('L').length) + d.ToKey)+1,
				col:   _colLabel.indexOf(d.Year)+1,
				"From": 	d.From,
				"To": 		d.To,
				"FromKey": 	d.FromKey,
				"ToKey": 	d.ToKey,
				"Year": 	d.Year,
				"Value": 	(isNaN(d.Value)) ? 0.0 : d.Value
			};
		});
		_data = data2;
		dataObj.data = _data;
				
		dataObj.calcDifference(configuration.GetCountries('R'), configuration.GetCountries('L'), _colLabel.length);
	
		for(var i = 0; i < dataObj.data.length; i++)
		{
			var j = dataObj.data[i].row;
			var k = dataObj.data[i].col-1;
			
			if(typeof(dataObj.difference[j]) !== 'undefined')
			{	
				var v = dataObj.difference[j][k];
				dataObj.data[i].Difference = v
			}
		}
	
		_spinner.stop();
		_spinner = null;
		d3.selectAll('svg').remove();
		setup(states.data_attribute, actualIndicesHM);  
	});
}

function setup(attribute, actualIndicesHM)
{	
	if(_heatmap && _heatmap !== null && isNaN(_heatmap.scaleMiddle))	_heatmap.SetDefaultZoom();
	
	svg_overall = div2.append("svg")
		.attr("width", states.width)
		.attr("height", states.height);
    
	svgL = svg_overall.append("svg")		
		.attr("x",  0)
		.attr("width", states.widthL)
		.attr("height", states.height);
		
	svgL.append("svg:rect")
			.attr("x", 0)
			.attr("y", 0)
			.attr("width", states.widthL)
			.attr("height", states.height)	
			.attr("class", "map_background map_background_left")
			.on("dblclick", function(d,i) {
				resetL();
			});;			
	gL = svgL.append("g");
		
	svgM = svg_overall.append("svg")		
		.attr("x", states.widthL)				
		.attr("width", states.widthM)
		.attr("height", states.height)
		.call(zoomM).on("dblclick.zoom", null);				
		
	svgMHeatmap = svgM.append("svg")		
		.attr("x", states.widthML)
		.attr("y", 0)
		.attr("width", states.widthMM);
		
	svgMLabelsL = svgM.append("svg")
		.attr("x", 0)
		.attr("y", 0)
		.attr("width", states.widthML);
	
	svgMLabelsR = svgM.append("svg")
		.attr("x", states.widthML + states.widthMM)
		.attr("width", states.widthMR);
		
	svgMColumnT = svgM.append("svg")
		.attr("y", 0)
		.attr("width", states.widthM)
		.attr("height", states.height)
		
	svgMColumnT.append("rect")
		.attr("x", -500)
		.attr("width", 3000)
		.attr("height", 50)
		.attr("class", "heatmap_background");			
	
	svgR = svg_overall.append("svg")
		.attr("x",  states.widthL+states.widthM)
		.attr("width", states.widthR)
		.attr("height", states.height);
		
	svgR.append("svg:rect")
			.attr("x", 0)
			.attr("y", 0)
			.attr("width", states.widthR)
			.attr("height", states.height)	
			.attr("class", "map_background map_background_right")
			.on("dblclick", function(d,i) {	resetR();	});			
	gR = svgR.append("g");
	
	svgL.call(zoomL) // delete this line to disable free zooming
		.call(zoomL.event).on("dblclick.zoom", null);	
	svgR.call(zoomR) // delete this line to disable free zooming
		.call(zoomR.event).on("dblclick.zoom", null);
				
				
	d3.select("#fitl").style("left", states.widthL-55);	
	d3.select("#clearl").style("left", states.widthL-15);	
	d3.select("#fitm").style("left", states.widthL+states.widthM-55);	
	d3.select("#clearm").style("left", states.widthL+states.widthM-15);	
	d3.select("#fitr").style("left", states.width-55);	
	d3.select("#clearr").style("left", states.width-15);	
				
	//////////////////////
	//Legende and Color
	//////////////////////
	color_absolut(colormapSequential.color_type);
	color_relative(colormapDiverging.color_type);		
	_legend = new Legend();
	_legend.Create();
	///////////////////////// 
	
	if(configuration.GetDrawingType('L') === "tree") 	mapLeft = 	new Tree('L', loaderLeft.path, loaderLeft.topo, states.widthL, configuration.GetMapFillColor('L'), configuration.GetCountries('L'), configuration.GetDictionary('L'), configuration.GetDrawingFile('L'), zoomL, loaderLeft.nodex, loaderLeft.nodey, svgL, gL, loaderLeft.varName, loaderLeft.varNodex,	loaderLeft.varNodey, configuration.GetGroup('L'), configuration.GetGroupCountries('L'), _tooltip);	
	else												mapLeft = 	new Map( 'L', loaderLeft.path, loaderLeft.topo, states.widthL, configuration.GetMapFillColor('L'), configuration.GetCountries('L'), configuration.GetDictionary('L'), configuration.GetDrawingFile('L'), zoomL, loaderLeft.nodex, loaderLeft.nodey, svgL, gL, configuration.GetGroup('L'), configuration.GetGroupCountries('L'), _tooltip);	
	
	if(configuration.GetDrawingType('R') === "tree") 	mapRight = 	new Tree('R', loaderRight.path, loaderRight.topo, states.widthR, configuration.GetMapFillColor('R'), configuration.GetCountries('R'), configuration.GetDictionary('R'), configuration.GetDrawingFile('R'), zoomR, loaderRight.nodex, loaderRight.nodey, svgR, gR, loaderRight.varName, loaderRight.varNodex,	loaderRight.varNodey, configuration.GetGroup('R'), configuration.GetGroupCountries('R'), _tooltip);
	else												mapRight = 	new Map( 'R', loaderRight.path, loaderRight.topo, states.widthR, configuration.GetMapFillColor('R'), configuration.GetCountries('R'), configuration.GetDictionary('R'), configuration.GetDrawingFile('R'), zoomR, loaderRight.nodex, loaderRight.nodey, svgR, gR, configuration.GetGroup('R'), configuration.GetGroupCountries('R'), _tooltip);
	
	mapLeft.Create(_index2output, _index2input, configuration.GetDotsSizeDefault('L'), configuration.GetDotsSizeHighlight('L'), configuration.GetTextSizeDefault('L'), configuration.GetTextSizeHighlight('L'));				
	mapRight.Create(_index2input, _index2output, configuration.GetDotsSizeDefault('R'), configuration.GetDotsSizeHighlight('R'), configuration.GetTextSizeDefault('R'), configuration.GetTextSizeHighlight('R'));
		
	_heatmap = new HeatMap(zoomM, _index2output, _index2input, _colLabel, mapLeft, mapRight, _tooltip, dataObj, svgMLabelsL, svgMLabelsR, svgM);	
	if(typeof(actualIndicesHM) !== 'undefined') _heatmap.actualOrdering = actualIndicesHM;
	_heatmap.Create(true);
	
	//////////////////////
	//Legende and Color
	//////////////////////
	color_absolut(colormapSequential.color_type);
	color_relative(colormapDiverging.color_type);		
	///////////////////////// 
	
	if(states.enable_visuallinks === true)
	{
		visLinkLeft = new VisualLink(mapLeft, mapRight, _heatmap);
		visLinkLeft.Create(_index2output, _index2input, true);
		visLinkRight = new VisualLink(mapRight, mapLeft, _heatmap);
		visLinkRight.Create(_index2output, _index2input, true); 
	}
	
	callOrdering(0.0);

	_lassoRight = new Lasso(mapRight);	_lassoRight.Create();	
	_lassoLeft = new Lasso(mapLeft);		_lassoLeft.Create();

	/*var easter_egg = new Konami();
	easter_egg.code = function() { 								
		var l = _colLabel.length, s = Math.max(0, Math.floor((l-4)/2)-1), test = [];
		for(var i = 0; i < (21*l); i++) test[i] = 0.0;			
		test[1*l+1+s] = 1.0;	test[1*l+2+s] = 1.0;	test[1*l+3+s] = 1.0;	test[1*l+4+s] = 1.0;
		test[2*l+4+s] = 1.0;
		test[3*l+3+s] = 1.0;
		test[4*l+2+s] = 1.0;
		test[5*l+1+s] = 1.0;
		test[6*l+1+s] = 1.0;	test[6*l+2+s] = 1.0;	test[6*l+3+s] = 1.0;	test[6*l+4+s] = 1.0;			
		
		test[8*l+2+s] = 1.0;	test[8*l+3+s] = 1.0;
		test[9*l+1+s] = 1.0;	test[9*l+4+s] = 1.0;
		test[10*l+2+s] = 1.0;
		test[11*l+3+s] = 1.0;
		test[12*l+1+s] = 1.0; 	test[12*l+4+s] = 1.0;
		test[13*l+2+s] = 1.0;	test[13*l+3+s] = 1.0;
		
		test[15*l+2+s] = 1.0;	test[15*l+3+s] = 1.0;
		test[16*l+2+s] = 1.0;	test[16*l+3+s] = 1.0;
		test[17*l+2+s] = 1.0;	test[17*l+3+s] = 1.0;
		test[18*l+2+s] = 1.0;	test[18*l+3+s] = 1.0;
		test[19*l+2+s] = 1.0;	test[19*l+3+s] = 1.0;
		test[20*l+2+s] = 1.0;	test[20*l+3+s] = 1.0;
					
		svgM.selectAll(".cell").style("opacity", function(d,i){
			var x = _hccol.indexOf(d.col);	var y = actualIndicesHM.indexOf(d.row-1)															
			if(test[(y*l+x)] === 1.0)	return "1.0";												
			else						return "0.0";			
		});				
	}
	easter_egg.load();
	*/	
}

function CreateMap()
{
	if(type === "Tree" || type=== "tree")	map[0] = new Tree();	
	else									map[0] = new Map();		
}
	  
function fitL()			{	mapLeft.fit();			}
function resetL(d, i) 	{	mapLeft.reset(d,i);		}
function moveL2() 
{
	if(states.crtl_pressed === false ) moveL();
}
function moveL() 
{
	if(mapLeft)
	{
		mapLeft.move();		
		callOrdering(0, true, true, true, false);
	}
}

function fitR()			{	mapRight.fit();			}		
function resetR(d, i) 	{	mapRight.reset(d,i);	}
function moveR2() 
{
	if(states.crtl_pressed === false ) moveR();
}
function moveR() 
{	
	if(mapRight)
	{
		mapRight.move();		
		callOrdering(0, true, true, false, true);
	}
}

function fitHeatmap()	{	_heatmap.Fit();			callOrdering(0, true, false, true, true);	}
function showAll()		{	_heatmap.ShowAll();		callOrdering(0, true, false, true, true);	}
function moveM()
{	
	if(d3.event && d3.event.translate && d3.event.translate !== null)  	_heatmap.translateMiddle = d3.event.translate;
	if(d3.event && d3.event.scale && d3.event.scale !== null) 			_heatmap.scaleMiddle = d3.event.scale;  	
	callOrdering(0, true, false, true, true);
	_heatmap.Move();
}

function redraw() 
{	
	if(states.displaystate === 'normal')			
	{			
		//d3.selectAll('svg').remove();
		//setup(states.data_attribute);  	
		$("#but_origin").attr("class", "btn");
		$("#but_all").attr("class", "btn");		
		$("#but_destinition").attr("class", "btn");
		
		states.displaystate = 'normal';	
		updateVisualElements();	
	}
	else if(states.displaystate === 'origin')		
	{
		states.displaystate = 'normal';
		updateGroupingOrigin();
	}
	else if(states.displaystate === 'destinition')	
	{
		states.displaystate = 'normal';
		updateGroupingDestinition();
	}
	else if(states.displaystate === 'all')			
	{
		states.displaystate = 'normal';
		updateGroupingAll();
	}
}

function throttle() 
{
	window.clearTimeout(throttleTimer);
	throttleTimer = window.setTimeout(function(){ redraw();	}, 200);
}

function updateShowLines()
{
	states.showlines = !states.showlines;
	
	if(!states.showlines)	$("#but_lines").attr("class", "btn");	
	else					$("#but_lines").attr("class", "btnEnable");	
	callOrdering(states.animation_duration, false, false, true, true);
}

function linearinterpolation()
{	
	if(typeof(this.checked) === 'undefined')	ColorMapping.linearinterpolation_checked = !ColorMapping.linearinterpolation_checked;
	else										ColorMapping.linearinterpolation_checked = this.checked;		
	color_absolut(colormapSequential.color_type);
	color_relative(colormapDiverging.color_type);		
}

function color_absolut(value, dur)
{
	if(colormapSequential) colormapSequential.Create(value, dur);
}

function color_relative(value, dur)
{	
	if(colormapDiverging) colormapDiverging.Create(value, dur);
}

function updateDataDiff()
{
	states.absolut = !states.absolut;		
	
	if(states.absolut === false)	
	{
		$("#but_diff").attr("class", "btnEnable");					
		color_relative(colormapDiverging.color_type);
	}
	else	
	{
		$("#but_diff").attr("class", "btn");			
		color_absolut(colormapSequential.color_type);
	}
}
////////////// COLOR end //////////////

function updateGroupingOrigin()
{
	if(states.displaystate === 'origin')
	{
		$("#but_origin").attr("class", "btn");
		$("#but_all").attr("class", "btn");		
		$("#but_destinition").attr("class", "btn");
		
		states.displaystate = 'normal';	
		updateVisualElements();		
	}
	else
	{
		$("#but_origin").attr("class", "btnEnable");
		$("#but_all").attr("class", "btn");		
		$("#but_destinition").attr("class", "btn");
		
		states.displaystate = 'origin';	
		updateVisualElements();
	}
}
	
function updateGroupingDestinition()
{	
	if(states.displaystate === 'destinition')
	{
		/*
		$("#but_destinition").attr("class", "btn");		
		states.displaystate = 'normal';		
		_heatmap.SetDefaultZoom();
		
		d3.selectAll('svg').remove();
		setup(states.data_attribute);
		*/
		$("#but_origin").attr("class", "btn");
		$("#but_all").attr("class", "btn");		
		$("#but_destinition").attr("class", "btn");
		
		states.displaystate = 'normal';	
		updateVisualElements();	
	}
	else
	{
		$("#but_all").attr("class", "btn");
		$("#but_origin").attr("class", "btn");		
		$("#but_destinition").attr("class", "btnEnable");
		
		states.displaystate = 'destinition';		
		updateVisualElements();
	}
}

function updateGroupingAll()
{	
	if(states.displaystate === 'all')
	{
		$("#but_origin").attr("class", "btn");
		$("#but_all").attr("class", "btn");		
		$("#but_destinition").attr("class", "btn");
		
		states.displaystate = 'normal';	
		updateVisualElements();	
	}
	else
	{
		$("#but_all").attr("class", "btnEnable");
		$("#but_origin").attr("class", "btn");
		$("#but_destinition").attr("class", "btn");
				
		states.displaystate = 'all'		
		updateVisualElements();
	}
}

function updateVisualElements()
{
	_heatmap.Create(false);
		
	if(states.enable_visuallinks === true)
	{		
		visLinkLeft.Create(_index2output, _index2input, false);
		visLinkRight.Create(_index2output, _index2input, false);
	}
	
	mapLeft.active_country.forEach(function(d){		mapLeft.DisableHighlightLabel(d);	});
	mapRight.active_country.forEach(function(d){	mapRight.DisableHighlightLabel(d);	});
	
	if(states.absolut === false)	color_relative(colormapDiverging.color_type, -1);		
	else							color_absolut(colormapSequential.color_type, -1);		
	
	callOrdering(0);
}

function updateOrdering(sort_array, duration, update_heatmap, update_sorting, update_visuallinksL, update_visuallinksR)
{
	console.log("updateOrdering: "
	+ duration + " Heatmap: " + update_heatmap + " " + update_sorting + " VL: " + update_visuallinksL + " " + update_visuallinksR);
	
	var newsortedindex = null;
	var newsortedindexindexOf = [];
	var t = svg_overall;
	if(duration > 0) t = svg_overall.transition().duration(duration);
	
	var subpart = false;
	
	_heatmap.num_visible = states.num_objs;
	if((	mapRight && mapRight.active_country.length > 0) 
	|| (	mapLeft  && mapLeft.active_country.length  > 0)) // IF COUNTRY ACTIVE
	{			
		subpart = true;
		_heatmap.num_visible = 0;
		var deltedNotDeleted = new Array();		
		
		if(states.displaystate === 'origin')
		{			
			t.selectAll(".rowLabel2")				
				.style("opacity", function(d,i){ 				
					if($.inArray(sort_array[i], mapRight.active_country) === -1 )
					{						
						deltedNotDeleted[sort_array[i]] = true;							
						return "0.0"; 
					}
					else 					
					{						
						_heatmap.num_visible = _heatmap.num_visible + 1;
						deltedNotDeleted[sort_array[i]] = false;
						return "1.0";
					}
				});	
		}
		else if(states.displaystate === 'destinition')
		{
			//TODO
			t.selectAll(".rowLabel")				
				.style("opacity", function(d,i){ 				
					if($.inArray(sort_array[i], mapLeft.active_country) === -1 )
					{						
						deltedNotDeleted[sort_array[i]] = true;							
						return "0.0"; 
					}
					else 					
					{						
						_heatmap.num_visible = _heatmap.num_visible + 1;
						deltedNotDeleted[sort_array[i]] = false;
						return "1.0";
					}
				});	
		}		
		else
		{
			t.selectAll(".rowLabel2")				
				.style("opacity", function(d,i){ 									
					var id = sort_array[i];					
					var id2 = id % (configuration.GetCountries('L').length);			
					var id1 = (id-id2) / (configuration.GetCountries('L').length);	
					
					if(($.inArray(id1,  mapRight.active_country) === -1 && mapRight.active_country.length > 0) 
					|| ($.inArray(id2, 	mapLeft.active_country) === -1  && mapLeft.active_country.length > 0)) 										
					{
						deltedNotDeleted[sort_array[i]] = true;							
						return "0.0"; 
					}
					else 					
					{					
						_heatmap.num_visible = _heatmap.num_visible + 1;
						deltedNotDeleted[sort_array[i]] = false;
						return "1.0";
					}
				});	
		}
				
		t.selectAll(".cell").style("opacity", function(d,i){ 									
				if(deltedNotDeleted[d.row-1]) 	return "0.0"; 
				else 							return "1.0";
			});

		var num_visible2 = 0;
		var num_visible3 = 0;
		newsortedindex = new Array(deltedNotDeleted.length);
		
		if(states.displaystate === 'origin')
		{
			//TODO
			t.selectAll(".rowLabel2")				
				.style("opacity", function(d,i){ 
					var id = sort_array[i];
					if($.inArray(id, mapRight.active_country) === -1)
					{														
						newsortedindex[(num_visible3+_heatmap.num_visible)] = id;				
						num_visible3=num_visible3+1;
					}
					else 					
					{			
						newsortedindex[num_visible2] = id;				
						num_visible2=num_visible2+1;				
					}
					
					if(deltedNotDeleted[i]) 	return "0.0"; 
					else 						return "1.0";
				});			
		}
		else if(states.displaystate === 'destinition')
		{
			//TODO
			t.selectAll(".rowLabel")				
				.style("opacity", function(d,i){ 	
					var id = sort_array[i];
					if($.inArray(id, mapLeft.active_country) === -1) 
					{														
						newsortedindex[(num_visible3+_heatmap.num_visible)] = id;				
						num_visible3=num_visible3+1;
					}
					else 					
					{			
						newsortedindex[num_visible2] = id;				
						num_visible2=num_visible2+1;				
					}
					
					if(deltedNotDeleted[i]) 	return "0.0"; 
					else 						return "1.0";
				});
		}
		else
		{			
			t.selectAll(".rowLabel2")				
				.style("opacity", function(d,i){ 										
					var id = sort_array[i];
					var id2 = id % configuration.GetCountries('L').length;
					var id1 = (id-id2) / configuration.GetCountries('L').length;
					
					if(($.inArray(id1,  mapRight.active_country) === -1 && mapRight.active_country.length > 0) 
					|| ($.inArray(id2, 	mapLeft.active_country ) === -1 && mapLeft.active_country.length  > 0)) 
					{									
						newsortedindex[(num_visible3+_heatmap.num_visible)] = id;				
						num_visible3=num_visible3+1;
					}
					else 					
					{													
						newsortedindex[num_visible2] = id;				
						num_visible2=num_visible2+1;				
					}
					
					if(deltedNotDeleted[i]) 	return "0.0"; 
					else 						return "1.0";
				});
		}		
				
		newsortedindex.forEach(function(d,i){	newsortedindexindexOf[d] = i;});		
	}
	else
	{					
		newsortedindex = sort_array.slice();				
		newsortedindex.forEach(function(d,i){	newsortedindexindexOf[d] = i;	});				
	}
		
	//if(update_sorting || update_heatmap)	
	{		
		//_heatmap.UpdateSorting(newsortedindexindexOf, duration, subpart);	
		_heatmap.Update(newsortedindexindexOf, duration, subpart);
	}
	
	if(update_visuallinksL === true && mapLeft	&& mapLeft !== null)	mapLeft.label.Update()				
	if(update_visuallinksR === true && mapRight	&& mapRight !== null)	mapRight.label.Update()				
		
	if(states.enable_visuallinks === true && update_visuallinksR === true && visLinkRight)
	{		
		var active_groups = mapRight.GetActiveGroups();					
		
		if(active_groups.length > 0)
		{
			var groupstates_id2  = active_groups[0][0];
			var groupstates_id  = active_groups[0][1];
			var rightID = _index2input.slice();
			var leftID = _index2output.slice();
			
			//var newsortedindexCPY = newsortedindex.splice();
			var newsortedindexindexOfCPY = [];
			
			newsortedindex.forEach(function(id,i){	newsortedindexindexOfCPY[id] = i;});
			
			dictHelp = {};
			for(var i = 0; i < newsortedindexindexOf.length; i++)
			{
				if(states.displaystate === 'origin')
				{
					var id = 	newsortedindex[i];				
					if(id === groupstates_id2)		dictHelp[0] = newsortedindexindexOfCPY[id];
				}
				else
				{
					var id = 	newsortedindex[i];				
					var idL = 	id % mapLeft.countries.length;
					var idR =   (id-idL) / mapLeft.countries.length;
					
					if(idR === groupstates_id2)		dictHelp[idL] = newsortedindexindexOfCPY[id];
				}
			}
			
			for(var i = 0; i < newsortedindexindexOf.length; i++)
			{
				if(states.displaystate === 'origin')
				{
					var id = 	newsortedindex[i];				
					
					if($.inArray(id, mapRight.groupingGroupStates[groupstates_id]) !== -1)
					{										
						newsortedindexindexOfCPY[id] = dictHelp[0];					
					}
					else if(id === groupstates_id2)
					{
						newsortedindexindexOfCPY[id] += mapLeft.countries.length;
					}
					else
					{
						var new_i = i;//Math.max(mapLeft.countries.length,i);
						newsortedindexindexOfCPY[id] = new_i;					
					}
				}
				else
				{
					var id = 	newsortedindex[i];				
					var idL = 	id % mapLeft.countries.length;
					var idR =   (id-idL) / mapLeft.countries.length;
					
					if($.inArray(idR, mapRight.groupingGroupStates[groupstates_id]) !== -1)
					{										
						newsortedindexindexOfCPY[id] = dictHelp[idL];					
					}
					else if(idR === groupstates_id2)
					{
						newsortedindexindexOfCPY[id] += mapLeft.countries.length;
					}
					else
					{
						var new_i = i;//Math.max(mapLeft.countries.length,i);
						newsortedindexindexOfCPY[id] = new_i;					
					}
				}
			}		
			visLinkRight.Redraw(duration, newsortedindexindexOfCPY, rightID, leftID);	
		}
		else	visLinkRight.Redraw(duration, newsortedindexindexOf, _heatmap.rowLabelTo, _heatmap.rowLabelFrom);	
	}
	
	if(states.enable_visuallinks === true && update_visuallinksL === true && visLinkLeft)		
	{
		var active_groups = mapLeft.GetActiveGroups();			
		if(active_groups.length > 0)
		{
			var groupstates_id  = active_groups[0][1];		
			var rightID = _index2input.slice();
			var leftID = _index2output.slice();
			
			var newsortedindexindexOfCPY = [];			
			
			for(var i = 0; i < newsortedindex.length; i++)
			{
				var id = 	newsortedindex[i];				
				var idL = 	id % mapLeft.countries.length;
				var idR =   (id-idL) / mapLeft.countries.length;
				
				if($.inArray(idL, mapRight.groupingGroupStates[groupstates_id]) !== -1)
				{																				
					newsortedindexindexOfCPY[id] = idR;					
				}
				else
				{
					var new_i = Math.max(mapRight.countries.length,i);
					newsortedindexindexOfCPY[id] = new_i;					
				}				
			}
				
			visLinkLeft.Redraw(duration, newsortedindexindexOfCPY, rightID, leftID);	
		}
		else	visLinkLeft.Redraw(duration, newsortedindexindexOf, _heatmap.rowLabelTo, _heatmap.rowLabelFrom);		
	}
	
	_heatmap.actualOrdering = newsortedindex.slice();
}

function callOrdering(time, update_heatmap, update_sorting, update_visuallinksL, update_visuallinksR)
{			
	update_heatmap = 		typeof update_heatmap !== 'undefined' 		? update_heatmap : true;
	update_sorting = 		typeof update_sorting !== 'undefined' 		? update_sorting : true;
	update_visuallinksL = 	typeof update_visuallinksL !== 'undefined' 	? update_visuallinksL : true;
	update_visuallinksR = 	typeof update_visuallinksR !== 'undefined' 	? update_visuallinksR : true;	
	
	if(states.displaystate !== 'all')
	{
		updateOrdering(_sortingObj.GetSortingArray(), time, update_heatmap, update_sorting, update_visuallinksL, update_visuallinksR);			
	}	
	else
	{		
		var t = svg_overall;
		if(time > 0) t = svg_overall.transition().duration(time);
			
		if(update_sorting || update_heatmap)	
		{
			var newsortedindexindexOf = [0];
			//_heatmap.UpdateSorting(newsortedindexindexOf, time, false);
			_heatmap.Update(newsortedindexindexOf, time, false);
		}
			
		if(states.enable_visuallinks === true && update_visuallinksR === true)	visLinkRight.Redraw(time, [], _index2input, _index2output);
		if(states.enable_visuallinks === true && update_visuallinksL === true)	visLinkLeft.Redraw( time, [], _index2input, _index2output);		
	}
}

function order(value)
{
	_sortingObj.SetSorting(value);
	callOrdering(states.animation_duration);
}

function updateWindow()
{
	if(_spinner === null && false)
	{
		states.width = w.innerWidth-10;
		states.widthM = 400;//Math.max(states.width*4/10, 400);    
		states.widthL = Math.max(0,(states.width-states.widthM)/2);	
		states.widthR = Math.max(0,states.width - states.widthL - states.widthM);	
		
		states.widthMM = 200;
		var tmp = (states.widthM-states.widthMM)/2;
		states.widthML = Math.max(100,Math.floor(tmp));
		states.widthMR = states.widthM - states.widthMM - states.widthML;	
		//console.log("tmp: " + tmp + " width: " + states.widthML + " " + states.widthMR + " " + states.widthMM);
		
		var tmp = Math.max(0, states.widthL-50)	
		
	//////////

		svg_overall.attr("width", states.width);
		
		svgL.attr("width", states.widthL);
		svgL.attr("width", states.widthL);
			
		svgM.attr("x", states.widthL)				
			.attr("width", states.widthM);				
			
		svgMHeatmap.attr("x", states.widthML)
					.attr("width", states.widthMM);
			
		svgMLabelsL.attr("width", states.widthML);
		
		svgMLabelsR.attr("x", states.widthML + states.widthMM)
					.attr("width", states.widthMR);
			
		svgMColumnT.attr("width", states.widthM)
					.attr("height", states.height)
			
		svgR.attr("x",  states.widthL+states.widthM)
			.attr("width", states.widthR)
			.attr("height", states.height);
		
		svgL.selectAll(".map_background")
			.attr("width", states.widthL)
			.attr("height", states.height);	
		svgR.selectAll(".map_background")
			.attr("width", states.widthR)
			.attr("height", states.height);
		
	//////////	

		d3.selectAll("#navll").style("left", (states.widthL-55) + "px");	
		d3.selectAll("#navlr").style("left", (states.widthL-15) + "px");	
		d3.selectAll("#navlt").style("left", (states.widthL-35) + "px");	
		d3.selectAll("#navlb").style("left", (states.widthL-35) + "px");	
		d3.selectAll("#navlp").style("left", (states.widthL-55) + "px");	
		d3.selectAll("#navlm").style("left", (states.widthL-15) + "px");	
		d3.selectAll("#but_lassoL").style("left", (states.widthL-55) + "px");

		d3.selectAll("#navml").style("left", (states.widthL+states.widthM-55) + "px");	
		d3.selectAll("#navmr").style("left", (states.widthL+states.widthM-15) + "px");	
		d3.selectAll("#navmt").style("left", (states.widthL+states.widthM-35) + "px");	
		d3.selectAll("#navmb").style("left", (states.widthL+states.widthM-35) + "px");	
		d3.selectAll("#navmp").style("left", (states.widthL+states.widthM-55) + "px");	
		d3.selectAll("#navmm").style("left", (states.widthL+states.widthM-15) + "px");	
		
		d3.selectAll("#navrl").style("left", (states.width-55) + "px");	
		d3.selectAll("#navrr").style("left", (states.width-15) + "px");	
		d3.selectAll("#navrt").style("left", (states.width-35) + "px");	
		d3.selectAll("#navrb").style("left", (states.width-35) + "px");	
		d3.selectAll("#navrp").style("left", (states.width-55) + "px");	
		d3.selectAll("#navrm").style("left", (states.width-15) + "px");	
		d3.selectAll("#but_lassoR").style("left", (states.width-55) + "px");	
		
		d3.selectAll("#origin").style("width", states.widthL + "px");
		d3.selectAll("#destination").style("width", states.widthR + "px")
									.style("left", (states.widthL + states.widthM) + "px");
		
		d3.selectAll("#fitl").style("left", (states.widthL-55) + "px");	
		d3.selectAll("#clearl").style("left", (states.widthL-30) + "px");	
		d3.selectAll("#fitm").style("left", (states.widthL+states.widthM-75) + "px");	
		d3.selectAll("#clearm").style("left", (states.widthL+states.widthM-50) + "px");	
		d3.selectAll("#fitr").style("left", (states.width-55) + "px");	
		d3.selectAll("#clearr").style("left", (states.width-30) + "px");		
		
		d3.select("#toolbar").style("left", (states.widthL-100)+"px");	
	}
}