Map = function(side, path, topo, width, fill_default, countries, dictionaryFiles, map_file, zoom, nodex, nodey, svg, g, groupingNames, groupingGroupStates, tooltip)
{
	this.side					= side;
	this.path 					= path;
	this.topo					= topo;
	this.selected_country		= false;
	this.active_country			= [];
	this.dictionaryFiles		= dictionaryFiles;
	this.map_file 				= map_file;
	this.nodex 					= nodex;
	this.nodey 					= nodey;
	this.width					= width;
	this.countries 				= countries;
	
	this.groupingNames			= groupingNames;
	this.groupingGroupStates 	= groupingGroupStates;
	
	this.fill_default			= fill_default;
			
	this.zoom					= zoom;
	this.zoomed					= false;	
	this.translate				= [0,0];		
	this.scale					= 1;
	this.translate_default 		= [0,0];
	this.scale_default 			= 1;
	
	this.selectedMap = -1;
	
	this.g = g;
	this.svg = svg;
	
	this.tooltip = tooltip;
}

Map.prototype = new Drawing();
Map.prototype.constructor = Map;

Map.prototype.Load = function(path2file)
{
	var projection = d3.geo.mercator()
		.translate([0,0])
		.scale(20);
		
	this.path = d3.geo.path().projection(projection);	
	
	d3.json("data/"+path2file, function(error, world) 
	{
		this.topo = topojson.feature(world, world.objects.countries).features;				
		callback(null);
	});	
}

function clickcancel() {
    var event = d3.dispatch('click', 'dblclick');
    function cc(selection) {
        var down,
            tolerance = 5,
            last,
            wait = null;
        // euclidean distance
        function dist(a, b) {
            return Math.sqrt(Math.pow(a[0] - b[0], 2), Math.pow(a[1] - b[1], 2));
        }
        selection.on('mousedown', function() {
            down = d3.mouse(document.body);
            last = +new Date();
        });
        selection.on('mouseup', function() {
            if (dist(down, d3.mouse(document.body)) > tolerance) {
                return;
            } else {
                if (wait) {
                    window.clearTimeout(wait);
                    wait = null;
                    event.dblclick(d3.event);
                } else {
                    wait = window.setTimeout((function(e) {
                        return function() {
                            event.click(e);
                            wait = null;
                        };
                    })(d3.event), 300);
                }
            }
        });
    };
    return d3.rebind(cc, event, 'on');
}

Map.prototype.Create = function(index2output, index2input, dots_size_default, dots_size_highlight, text_size_default, text_size_highlight)
{	
	var obj = this;		
		
	var dictionaryFiles = obj.dictionaryFiles;
	var side = obj.side;
	var map_file = obj.map_file;
	
	var singleclick = false;
	var singled = null;
	var singlei = -1;
	var doubleclick = false;
	var doubled = null;

	var cc = clickcancel();

	obj.g.selectAll(".country")
			.data(obj.topo)
		.enter()
			.append("path")		
			.attr("d", obj.path)
			.attr("width", obj.width)
			.attr("height", states.height)	
			.attr("id", function(d,i) { return d.id; })
			.attr("title", function(d,i) { return d.properties.name; })      
			.attr("class", function(d,i) { 					
				if(obj.dictionaryFiles[d.properties.name] && obj.dictionaryFiles[d.properties.name][map_file] >= 0) return "subunit-boundary country"+ side + "" + obj.dictionaryFiles[d.properties.name][map_file];
				else																								return "subunit-boundary";
			})
			.style("fill", obj.fill_default)		
			.on("mousemove", function(d,i) {				
				//var mouse = d3.mouse(obj.svg.node()).map( function(d) { return parseInt(d); } );			
			
				//Deactivate all Country Boundaries.
				var res = obj.GetCountries();
				res.forEach(function(d)
				{
					if(obj.active_country.length === res.length || $.inArray(d, obj.active_country) === -1)
					{						
						d3.selectAll(".country"+side+""+d).classed("subunit-boundary-highlight", false);
					}
				});
				
				obj.selectedMap = -1;
			
				if(obj.dictionaryFiles[d.properties.name] && obj.dictionaryFiles[d.properties.name][obj.map_file] >= 0)
				{
					var id = obj.dictionaryFiles[d.properties.name][obj.map_file];
						
					d3.select(this.parentNode.appendChild(this)).classed("subunit-boundary-highlight", true);
					d3.select(".label"+obj.side+""+ id).classed("label-highlight", true);
					
					obj.selectedMap = id;
					
					obj.SetToolTip(obj, id, obj.countries[id]);
				
					if(obj.side === "R")
					{
						var selected_countries_index = [];
						d3.selectAll(".rowLabel2").classed("text-highlight", function(r,i){ 
								if(r === d.properties.name) 
									selected_countries_index.push(i); 
								return (r === d.properties.name);
							});
						d3.selectAll(".rowLabel" ).classed("text-highlight", function(r,i){ 
								for(var j = 0; j < selected_countries_index.length; j++)					
									if(i === selected_countries_index[j]) 
										return true;					
								return false;
							});
					}
					else
					{
						var selected_countries_index = [];					
						d3.selectAll(".rowLabel").classed("text-highlight", function(r,i){ 
								if(r == d.properties.name) 
									selected_countries_index.push(i); 
								return (r == d.properties.name);
							});
						d3.selectAll(".rowLabel2" ).classed("text-highlight", function(r,i){ 
								for(var j = 0; j < selected_countries_index.length; j++)					
									if(i == selected_countries_index[j]) 
										return true;					
								return false;
							});
					}
				
					if(states.enable_visuallinks === true && !states.showlines)
					{	
						if(obj.side === 'L')	if(typeof(visLinkLeft) !== 'undefined')		visLinkLeft.ShowLinksForCounry(id, index2output, "L", index2input);
						else					if(typeof(visLinkRight) !== 'undefined')	visLinkRight.ShowLinksForCounry(id, index2output, "R", index2input);
					}
				}
				
				_heatmap.HighlightLabels(obj.side, id);
					
			})
			.on("mouseout",  function(d,i)
			{
				var res = obj.GetCountries();
				res.forEach(function(d)
				{
					if(obj.active_country.length === res.length || $.inArray(d, obj.active_country) === -1)
					{						
						d3.selectAll(".country"+side+""+d).classed("subunit-boundary-highlight", false);
						d3.selectAll(".label"+side+""+d).classed("label-highlight", false);
					}
				});
			
				if(obj.dictionaryFiles[d.properties.name] && obj.dictionaryFiles[d.properties.name][obj.map_file] >= 0)
				{
					var nameid = obj.dictionaryFiles[d.properties.name][obj.map_file];
					if($.inArray(nameid, obj.active_country) === -1 || obj.selected_country === false )					
						d3.select(this).classed("subunit-boundary-highlight", false);
								
					d3.select("#tooltip").classed("hidden", true);						
				}
				else	d3.select(this).classed("subunit-boundary-highlight", false);
								
				if(states.enable_visuallinks === true && !states.showlines)
				{						
					visLinkRight.HideAll();
					visLinkLeft.HideAll();													
				}
					
			})
		.on("dblclick",  function(d,i) { 
		
			if(obj.dictionaryFiles[d.properties.name] && obj.dictionaryFiles[d.properties.name][obj.map_file] >= 0)
			{
				doubled = obj.countries[obj.dictionaryFiles[d.properties.name][obj.map_file]];
			}
			if(doubleclick === true)	doubleclick = false;
			else 						doubleclick = true;
			
			if(doubleclick === false)	return obj.doubleClicked(obj,doubled);
		})
		.on("click", function(d,i) { 
		
			if(singleclick === true)	singleclick = false;
			else 						singleclick = true;
			
			singled = d;
			singlei = i;
			
			if(singleclick === false
			&& doubleclick === false)	return obj.clicked(obj,singled,singlei);
		})
		.call(cc);
	
	cc.on('click', function(d,i) {
			if(singleclick === true)	singleclick = false;
			else 						singleclick = true;
			
			if(singleclick === false
			&& doubleclick === false)	return obj.clicked(obj,singled,singlei);
	});
	cc.on('dblclick', function() {
		if(doubleclick === true)	doubleclick = false;
		else 						doubleclick = true;
		
		if(doubleclick === false)	return obj.doubleClicked(obj,doubled);
	});

	
	this.Initialize(dots_size_default, dots_size_highlight, text_size_default, text_size_highlight);
}

Map.prototype.CalcZoomLevel = function()
{
	var obj = this;
	var x1 = 999.9, y1 = 999.9, x2 = -999.9, y2 = -999.9;
					
	this.topo.forEach(function(i){				
		if(obj.dictionaryFiles[i.properties.name] && $.inArray(obj.dictionaryFiles[i.properties.name][obj.map_file], obj.active_country) !== -1	)
		{						
			var bounds = obj.path.bounds(i);
			x1 = Math.min(x1, bounds[0][0]);	x2 = Math.max(x2, bounds[1][0]);
			y1 = Math.min(y1, bounds[0][1]);	y2 = Math.max(y2, bounds[1][1]);
		}
	});

	var dx = x2-x1,	dy = y2-y1,	x = (x1+x2) / 2,	y = (y1+y2) / 2;		
		
	this.scale = 		(.9 / Math.max(dx / this.width, dy / states.height));
	this.translate = ([this.width / 2 - this.scale * x, states.height / 2 - this.scale * y]);		
	
	if((obj.scale < 50 || obj.scale > 120))// || isNaN(this.scale) || isNaN(this.translate[0]) || isNaN(this.translate[1])))	
	{		
		if(obj.active_country.length === 1)
		{
			x = obj.nodex[obj.active_country[0]];
			y = obj.nodey[obj.active_country[0]];
			dx = 10;
			dy = 10;

			obj.scale = (50.0);
			obj.translate = ([	obj.width 		/ 2 - obj.scale * x,
								states.height 	/ 2 - obj.scale * y]);				
		}
		else if(obj.active_country.length > 1 && obj.scale < 25.0)
		{
			x1 = 99999.9;		y1 = 999999.9;
			x2 = -99999.9;	y2 = -99999.9;
			
			var res = obj.GetCountries();
			res.forEach(function(d, i)
			{
				x = obj.nodex[d];
				y = obj.nodey[d];
				
				x1 = Math.min(x1, x);	x2 = Math.max(x2, x);
				y1 = Math.min(y1, y);	y2 = Math.max(y2, y);				
			});
			
			dx = x2-x1;
			dy = y2-y1;
			x = (x1+x2) / 2;
			y = (y1+y2) / 2;	
			
			obj.scale = (.9 / Math.max(dx /  obj.width, dy / states.height));
			obj.translate = ([obj.width / 2 - obj.scale * x, states.height / 2 - obj.scale * y]);	
		}
	}
}

Map.prototype.ZoomInOut = function(d, t, index2output)
{
	var obj = this;
	obj.topo.forEach(function(i){
		if( obj.dictionaryFiles[i.properties.name] && obj.dictionaryFiles[i.properties.name][obj.map_file] == index2output[d.row-1] )
		{		
			var idname = obj.dictionaryFiles[i.properties.name][obj.map_file];
			
			obj.CalcZoomLevel();
			obj.zoom.scale(obj.scale);
			obj.zoom.translate(obj.translate);
			
			obj.g.selectAll(".country"+obj.side +""+ idname).classed("subunit-boundary-highlight", true);
			
			if(states.animation_duration > 0)	obj.g.transition().duration(states.animation_duration).attr("transform", "translate(" + obj.translate + ")scale(" + obj.scale + ")");	
			else								obj.g.attr("transform", "translate(" + obj.translate + ")scale(" + obj.scale + ")");	
				
			var s1 = obj.svg;
			if(states.animation_duration > 0) s1 = obj.svg.transition().duration(states.animation_duration);
			obj.label.UpdateLabelSelection(s1, idname);
		}
	});
}