/**
 * Class which calculates and mange the sortings
 */
 
 /**
 * Constructor
 */
function Sorting()
{	
	/**
	 * Attributes.
	 */
	var sorting = 'avgValue';

	/////////////////////////////////////////////////////////
	// SORTINGS: Saves sorted ids. The id is a combination from leftside and rightside
	/////////////////////////////////////////////////////////	
	var orignTotalMax = [];
	var destinitionTotalMax = [];
	var groupOrignTotalMax = [];
	var groupDestinitionTotalMax = [];
				
	var maxValue = [];				
	var avgValue = [];
	var destinitionMaxValue = [];
	var destinitionAvgValue = [];
	var originAvgValue = [];
	var originMaxValue = [];

	var maxDiff = [];
	var avgDiff = [];
	var destinitionAvgDiff = []
	var destinitionMaxDiff = [];
	var originAvgDiff = [];
	var originMaxDiff = [];

	var maxRelDiff = [];
	var avgRelDiff = [];
	var destinitionAvgRelDiff = [];
	var destinitionMaxRelDiff = [];
	var originAvgRelDiff = [];
	var originMaxRelDiff = [];

	var originN2S = [];
	var destinitionN2S = [];
	var groupDestinitionN2S = [];
	var groupOriginN2S = [];
	var originW2E = [];
	var destinitionW2E = [];
	var groupDestinitionW2E = [];
	var groupOriginW2E = [];
	/////////////////////////////////////////////////////////
		
	/**
	 * Setter Method to set the sorting type
	 */
	Sorting.prototype.SetSorting = function(value)
	{
		sorting = value;
	}
		
	/**
	 * Method, that calcualtes all provided orderings.
	 */
	Sorting.prototype.Calculate = function(dataC, dataCapitals, inputcountries, outputcountries, colLabel)
	{	
		var obj = this;

		/////////////////////////////
		// Datastructure for Sortings
		/////////////////////////////
		
		var minYear = Enumerable.From(colLabel)
					.OrderBy(function(value){ return value;})
					.ToArray()[0];
		
		var dataDifferences = Enumerable.From(dataC).Join(Enumerable.From(dataC), 
			"$.From+$.To+$.Year", 
			"$.From+$.To+($.Year-1)", 
			"outer,inner=>{'From': outer.From, 'To': outer.To, 'FromKey': outer.FromKey, 'ToKey': outer.ToKey, 'Year': inner.Year, 'Value': (inner.Value - outer.Value)}")				
			.Concat(
			Enumerable
				.From(dataC)					
				.Where(function(item){ return item.Year == minYear; })
				.Select(function(value){return { 'From':value.From, 'To':value.To, 'FromKey':value.FromKey, 'ToKey':value.ToKey, 'Year':minYear, 'Value': 0.0}; }) 
			)
			.ToArray();
		
		var dataRelDifferences = Enumerable.From(dataC).Join(Enumerable.From(dataC), 
			"$.From+$.To+$.Year", 
			"$.From+$.To+($.Year-1)", 
			"outer,inner=>{'From': outer.From, 'To': outer.To, 'FromKey': outer.FromKey, 'ToKey': outer.ToKey, 'Year': inner.Year, 'Value': ((outer.Value === 0) ? ((inner.Value === 0) ? 0.0 : sign(inner.Value)) :  ((inner.Value - outer.Value)/outer.Value))}")				
			.Concat(
			Enumerable
				.From(dataC)					
				.Where(function(item){ return item.Year == minYear; })
				.Select(function(value){return { 'From':value.From, 'To':value.To, 'FromKey': value.FromKey, 'ToKey': value.ToKey, 'Year':minYear, 'Value': 0.0}; }) 
			)
			.ToArray();
		
		////////////////////////////////////
		////////////////////////////////////
		// Sort: Average & Max
		////////////////////////////////////
		
		// Sort by max value of (Origin:Destinition) pair over all years. 
		maxValue = Enumerable.From(dataC)
					.Where("$.FromKey<" + inputcountries.length + " && $.ToKey<" + outputcountries.length)
					.GroupBy(
						"{ F: $.FromKey, T: $.ToKey }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F, To: key.T, Result: group.Max("$.Value")};},
						"$.F * " + (outputcountries.length) + "+ $.T"
						)
					.OrderByDescending("$.Result")	
					.Select(function(value, index){ return value.From * outputcountries.length + value.To;})											
					.ToArray();						
		
		// Sort by average value of (Origin:Destinition) pair over all years.
		avgValue = Enumerable.From(dataC)
					.Where("$.FromKey<" + inputcountries.length + " && $.ToKey<" + outputcountries.length)
					.GroupBy(
						"{ F: $.FromKey, T: $.ToKey }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F, To: key.T, Result: group.Sum("$.Value")/group.source.length};},
						"$.F * " + (outputcountries.length) + "+ $.T"
					)
					.OrderByDescending("$.Result")	
					.Select(function(value, index){return value.From * outputcountries.length + value.To;})								
					.ToArray();	
					
		// Sort by maximum value of (Outputcountries:ALL) pair over all years.
		originMaxValue = Enumerable.From(dataC)
					.Where("$.From==='ALL' && $.ToKey<" + outputcountries.length)
					.GroupBy(
						"{ T: $.ToKey }",
						"{ Value: $.Value }",
						function (key, group) {	return { To: key.T, Result: group.Max("$.Value")};},
						"$.T"
					)
					.OrderByDescending("$.Result")	
					.Select(function(value, index){return value.To;})
					.ToArray();	

		// Sort by average value of (Outputcountries:ALL) pair over all years.
		originAvgValue = Enumerable.From(dataC)
					.Where("$.From==='ALL' && $.ToKey<" + outputcountries.length)
					.GroupBy(
						"{ T: $.ToKey }",
						"{ Value: $.Value }",
						function (key, group) { return { To: key.T, Result: group.Sum("$.Value")/group.source.length};},
						"$.T"
					)
					.OrderByDescending("$.Result")	
					.Select(function(value, index){return value.To;})							
					.ToArray();	

		// Sort by maximum value of (ALL:Inputcountries) pair over all years.
		destinitionMaxValue = Enumerable.From(dataC)
					.Where("$.FromKey<" + inputcountries.length + " && $.To==='ALL'")
					.GroupBy(
						"{ F: $.FromKey }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F, Result: group.Max("$.Value")};},
						"$.F"
						)
					.OrderByDescending("$.Result")	
					.Select(function(value, index){ return value.From;})								
					.ToArray();	
					
		// Sort by average value of (ALL:Inputcountries) pair over all years.
		destinitionAvgValue = Enumerable.From(dataC)
					.Where("$.FromKey<" + inputcountries.length + " && $.To==='ALL'")
					.GroupBy(
						"{ F: $.FromKey }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F, Result: group.Sum("$.Value")/group.source.length};},
						"$.F"
					)
					.OrderByDescending("$.Result")	
					.Select(function(value, index){ return value.From;})
					.ToArray();					

		////////////////////////////////////////////////					
		////////////////////////////////////////////////					
		// Sort: Difference - Average & Max
		////////////////////////////////////////////////					
		
		maxDiff = Enumerable.From(dataDifferences)
					.Where("$.FromKey<" + inputcountries.length + " && $.ToKey<" + outputcountries.length)
					.GroupBy(
						"{ F: $.FromKey, T: $.ToKey }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F, To: key.T, Result: group.Max("$.Value")};},
						"$.F * " + (outputcountries.length) + "+ $.T"
						)
					.OrderByDescending("$.Result")	
					.Select(function(value, index){ return value.From * (outputcountries.length) + value.To;})											
					.ToArray();	
		
		avgDiff = Enumerable.From(dataDifferences)
					.Where("$.FromKey<" + inputcountries.length + " && $.ToKey<" + outputcountries.length)
					.GroupBy(
						"{ F: $.FromKey, T: $.ToKey }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F, To: key.T, Result: group.Sum("$.Value")/group.source.length};},
						"$.F * " + (outputcountries.length) + "+ $.T")
					.OrderByDescending("$.Result")	
					.Select(function(value, index){ return value.From * (outputcountries.length) + value.To;})								
					.ToArray();		

		originMaxDiff = Enumerable.From(dataDifferences)
					.Where("$.From==='ALL' && $.ToKey<" + outputcountries.length)
					.GroupBy(
						"{ T: $.ToKey }",
						"{ Value: $.Value }",
						function (key, group) {	return { To: key.T, Result: group.Max("$.Value")};},
						"$.T")
					.OrderByDescending("$.Result")	
					.Select(function(value, index){return value.To;})
					.ToArray();	

		originAvgDiff = Enumerable.From(dataDifferences)
					.Where("$.From==='ALL' && $.ToKey<" + outputcountries.length)
					.GroupBy(
						"{ T: $.ToKey }",
						"{ Value: $.Value }",
						function (key, group) { return { To: key.T, Result: group.Sum("$.Value")/group.source.length};},
						"$.T")
					.OrderByDescending("$.Result")	
					.Select(function(value, index){return value.To;})					
					.ToArray();	
					
		destinitionMaxDiff = Enumerable.From(dataDifferences)
					.Where("$.FromKey<" + inputcountries.length + " && $.To==='ALL'")
					.GroupBy(
						"{ F: $.FromKey }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F, Result: group.Max("$.Value")};},
						"$.F"
						)
					.OrderByDescending("$.Result")	
					.Select(function(value, index){ return value.From;})							
					.ToArray();	
		
		// Sort by average differences value of (ALL:Inputcountries) pair over all years.
		destinitionAvgDiff = Enumerable.From(dataDifferences)
					.Where("$.FromKey<" + inputcountries.length + " && $.To==='ALL'")
					.GroupBy(
						"{ F: $.FromKey }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F, Result: group.Sum("$.Value")/group.source.length};},
						"$.F"
					)
					.OrderByDescending("$.Result")	
					.Select(function(value, index){ return value.From;})							
					.ToArray();		
				
		////////////////////////////////////////////////
		////////////////////////////////////////////					
		// Sort: Relative Difference - Average & Max
		////////////////////////////////////////////////					
		
		maxRelDiff = Enumerable.From(dataRelDifferences)
					.Where("$.FromKey<" + inputcountries.length + " && $.ToKey<" + outputcountries.length)
					.GroupBy(
						"{ F: $.FromKey, T: $.ToKey }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F, To: key.T, Result: group.Max("$.Value")};},
						"$.F * " + (outputcountries.length) + "+ $.T")
					.OrderByDescending("$.Result")	
					.Select(function(value, index){ return value.From * (outputcountries.length) + value.To;})											
					.ToArray();	
		
		avgRelDiff = Enumerable.From(dataRelDifferences)
					.Where("$.FromKey<" + inputcountries.length + " && $.ToKey<" + outputcountries.length)
					.GroupBy(
						"{ F: $.FromKey, T: $.ToKey }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F, To: key.T, Result: (group.source.length > 0) ? group.Sum("$.Value")/group.source.length : 0.0}},
						"$.F * " + (outputcountries.length) + "+ $.T")
					.OrderByDescending("$.Result")	
					.Select(function(value, index){ return value.From * (outputcountries.length) + value.To;})								
					.ToArray();		

					
		originMaxRelDiff = Enumerable.From(dataRelDifferences)
					.Where("$.From==='ALL' && $.ToKey<" + outputcountries.length)
					.GroupBy(
						"{ T: $.ToKey }",
						"{ Value: $.Value }",
						function (key, group) {	return { To: key.T, Result: group.Max("$.Value")};},
						"$.T")
					.OrderByDescending("$.Result")	
					.Select(function(value, index){return value.To;})
					.ToArray();	

		originAvgRelDiff = Enumerable.From(dataRelDifferences)
					.Where("$.From==='ALL' && $.ToKey<" + outputcountries.length)
					.GroupBy(
						"{ T: $.ToKey }",
						"{ Value: $.Value }",
						function (key, group) { return { To: key.T, Result: group.Sum("$.Value")/group.source.length};},
						"$.T")
					.OrderByDescending("$.Result")	
					.Select(function(value, index){return value.To;})					
					.ToArray();	
					
					
		destinitionMaxRelDiff = Enumerable.From(dataRelDifferences)
					.Where("$.FromKey<" + inputcountries.length + " && $.To==='ALL'")
					.GroupBy(
						"{ F: $.FromKey }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F, Result: group.Max("$.Value")};},
						"$.F"
						)
					.OrderByDescending("$.Result")	
					.Select(function(value, index){ return value.From;})							
					.ToArray();	
		
		destinitionAvgRelDiff = Enumerable.From(dataRelDifferences)
					.Where("$.FromKey<" + inputcountries.length + " && $.To==='ALL'")
					.GroupBy(
						"{ F: $.FromKey }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F, Result: group.Sum("$.Value")/group.source.length};},
						"$.F"
					)
					.OrderByDescending("$.Result")	
					.Select(function(value, index){ return value.From;})							
					.ToArray();												
				
		////////////////////////////////////////////////					
		////////////////////////////////////////////////
		// Sort: North->South
		////////////////////////////////////////////////						
		inputcountries.forEach(function(d, i)
		{
			var c = "" + d;
			var r = Enumerable.From(dataCapitals)
								.Where("$.Country == \"" + c +"\"")
								.Select(function(value, index) { return value.Latitude; })
								.ToArray();

			if(r.length !== 1 && typeof(r[0]) === 'undefined')
				dataCapitals.push(
				{
					"Country": d,
					"Longitude": -181.0,
					"Latitude":  -181.0
				});
		});
	
		outputcountries.forEach(function(d, i)
		{
			var r = Enumerable.From(dataCapitals)
								.Where("$.Country == \"" + d +"\"")
								.Select(function(value, index) { return value.Latitude ; })
								.ToArray();
								
			if(r.length !== 1 && typeof(r[0]) === 'undefined')
				dataCapitals.push(
				{
					"Country": d,
					"Longitude": 181.0,
					"Latitude":  181.0
				});
		});
		
		//Sort: North 2 South
		//Desitnition -> Origin			
		destinitionN2S = [];			
		destinitionN2S =  Enumerable.From(dataCapitals)							
			.Join(Enumerable.From(dataC)
				.Where("$.FromKey<" + inputcountries.length + " && $.ToKey<" + outputcountries.length)
				.GroupBy("{ F: $.From, T: $.To }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F, To: key.T};},
						"$.F + $.T"), 
				"$.Country", 
				"$.From", 
				function (outer, inner) { return {From: inner.From, To: inner.To, Year: inner.Year, Value: inner.Value, LatitdudeOrigin: outer.Latitude};})
			.Join(Enumerable.From(dataCapitals), 
				"$.To", 
				"$.Country", 					
				function (outer, inner) { return {From: outer.From, To: outer.To, Year: outer.Year, Value: outer.Value, LatitdudeOrigin: outer.LatitdudeOrigin, LatitudeDestinition: inner.Latitude};})
			.OrderByDescending("$.LatitdudeOrigin")	
			.ThenByDescending("$.LatitudeDestinition")							
			.Select(function(value, index){return inputcountries.indexOf(value.From) * (outputcountries.length) + outputcountries.indexOf(value.To);})															
			.ToArray();	
		
		//Origin -> Destinition
		originN2S = [];
		originN2S =  Enumerable.From(dataCapitals)			
			.Join(Enumerable.From(dataC)
				.Where("$.FromKey<" + inputcountries.length + " && $.ToKey<" + outputcountries.length)
				.GroupBy("{ F: $.From, T: $.To }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F, To: key.T};},
						"$.F + $.T"),
				"$.Country", 
				"$.From", 
				function (outer, inner) { return {From: inner.From, To: inner.To, Year: inner.Year, Value: inner.Value, LatitdudeOrigin: outer.Latitude};})
			.Join(Enumerable.From(dataCapitals), 
				"$.To", 
				"$.Country", 					
				function (outer, inner) { return {From: outer.From, To: outer.To, Year: outer.Year, Value: outer.Value, LatitdudeOrigin: outer.LatitdudeOrigin, LatitudeDestinition: inner.Latitude};})
			.OrderByDescending("$.LatitudeDestinition")	
			.ThenByDescending("$.LatitdudeOrigin")							
			.Select(function(value, index){return inputcountries.indexOf(value.From) * (outputcountries.length) + outputcountries.indexOf(value.To);})				
			.ToArray();	
						
		//Destinition
		groupDestinitionN2S = [];			
		groupDestinitionN2S =  Enumerable.From(dataCapitals)							
			.Join(Enumerable.From(dataC)
				.Where("$.FromKey<" + inputcountries.length + " && $.ToKey<" + outputcountries.length)
				.GroupBy("{ F: $.From }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F};},
						"$.F"), 
				"$.Country", 
				"$.From", 
				function (outer, inner) { return {From: inner.From, Year: inner.Year, Value: inner.Value, LatitdudeOrigin: outer.Latitude};})
			.OrderByDescending("$.LatitdudeOrigin")					
			.Select(function(value, index){return inputcountries.indexOf(value.From)})															
			.ToArray();	
			
		//Origin
		groupOriginN2S = [];
		groupOriginN2S =  Enumerable.From(dataCapitals)			
			.Join(Enumerable.From(dataC)
				.Where("$.FromKey<" + inputcountries.length + " && $.ToKey<" + outputcountries.length)
				.GroupBy("{ T: $.To }",
						"{ Value: $.Value }",
						function (key, group) { return { To: key.T};},
						"$.T"),
				"$.Country", 
				"$.To", 
				function (outer, inner) { return {To: inner.To, Year: inner.Year, Value: inner.Value, LatitudeDestinition: outer.Latitude};})				
			.OrderByDescending("$.LatitudeDestinition")	
			.Select(function(value, index){return outputcountries.indexOf(value.To);})				
			.ToArray();				
		
		////////////////////////////////////////////////
		////////////////////////////////////////////////
		// West->East
		////////////////////////////////////////////////
		
		//Sort: West 2 East
		//Destinition -> Origin
		destinitionW2E = [];			
		destinitionW2E =  Enumerable.From(dataCapitals)			
			.Join(Enumerable.From(dataC)
				.Where("$.FromKey<" + inputcountries.length + " && $.ToKey<" + outputcountries.length)
				.GroupBy("{ F: $.From, T: $.To }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F, To: key.T};},
						"$.F + $.T"),
				"$.Country", 
				"$.From", 
				function (outer, inner) { return {From: inner.From, To: inner.To, Year: inner.Year, Value: inner.Value, LongitudeOrigin: outer.Longitude};})
			.Join(Enumerable.From(dataCapitals), 
				"$.To", 
				"$.Country", 					
				function (outer, inner) { return {From: outer.From, To: outer.To, Year: outer.Year, Value: outer.Value, LongitudeOrigin: outer.LongitudeOrigin, LongitudeDestinition: inner.Longitude};})
			.OrderBy("$.LongitudeOrigin")	
			.ThenBy("$.LongitudeDestinition")							
			.Select(function(value, index){return inputcountries.indexOf(value.From) * (outputcountries.length) + outputcountries.indexOf(value.To);})				
			.ToArray();
			
		//Origin -> Destinition
		originW2E = [];
		originW2E =  Enumerable.From(dataCapitals)			
			.Join(Enumerable.From(dataC)
				.Where("$.FromKey<" + inputcountries.length + " && $.ToKey<" + outputcountries.length)
				.GroupBy("{ F: $.From, T: $.To }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F, To: key.T};},
						"$.F + $.T"),
				"$.Country", 
				"$.From", 
				function (outer, inner) { return {From: inner.From, To: inner.To, Year: inner.Year, Value: inner.Value, LongitudeOrigin: outer.Longitude};})
			.Join(Enumerable.From(dataCapitals), 
				"$.To", 
				"$.Country", 					
				function (outer, inner) { return {From: outer.From, To: outer.To, Year: outer.Year, Value: outer.Value, LongitudeOrigin: outer.LongitudeOrigin, LongitudeDestinition: inner.Longitude};})
			.OrderBy("$.LongitudeDestinition")	
			.ThenBy("$.LongitudeOrigin")							
			.Select(function(value, index){return inputcountries.indexOf(value.From) * (outputcountries.length) + outputcountries.indexOf(value.To);})				
			.ToArray();	
		
		//Destinition
		groupDestinitionW2E = [];			
		groupDestinitionW2E =  Enumerable.From(dataCapitals)							
			.Join(Enumerable.From(dataC)
				.Where("$.FromKey<" + inputcountries.length + " && $.ToKey<" + outputcountries.length)
				.GroupBy("{ F: $.From }",
						"{ Value: $.Value }",
						function (key, group) { return { From: key.F};},
						"$.F"), 
				"$.Country", 
				"$.From", 
				function (outer, inner) { return {From: inner.From, Year: inner.Year, Value: inner.Value, LongitudeOrigin: outer.Longitude};})
			.OrderBy("$.LongitudeOrigin")					
			.Select(function(value, index){return inputcountries.indexOf(value.From)})															
			.ToArray();	
			
		//Origin
		groupOriginW2E = [];
		groupOriginW2E =  Enumerable.From(dataCapitals)			
			.Join(Enumerable.From(dataC)
				.Where("$.FromKey<" + inputcountries.length + " && $.ToKey<" + outputcountries.length)
				.GroupBy("{ T: $.To }",
						"{ Value: $.Value }",
						function (key, group) { return { To: key.T};},
						"$.T"),
				"$.Country", 
				"$.To", 
				function (outer, inner) { return {To: inner.To, Year: inner.Year, Value: inner.Value, LongitudeDestinition: outer.Longitude};})				
			.OrderBy("$.LongitudeDestinition")	
			.Select(function(value, index){return outputcountries.indexOf(value.To);})				
			.ToArray();				

		////////////////////////////////////////////
		////////////////////////////////////////////
		// Sort: Total Max
		////////////////////////////////////////////	

		// Sort: Origin Total Maximimum							
		orignTotalMax = 
			Enumerable.From(dataC)
				.Where("$.FromKey<" + inputcountries.length + " && $.ToKey<" + outputcountries.length)
				.Join(
					Enumerable.From(dataC)
						.Where("$.FromKey<" + inputcountries.length + " && $.To==='ALL'")
						.GroupBy(							
							"{ F: $.From}",			//Keys
							"{ Value: $.Value }", 	//Collect
							function (key, group) { return { From: key.F, ResultFrom: group.Max("$.Value")};},
							"$.F"					//Keys Comparefunction
							),
					"$.From", 
					"$.From",
					function (outer, inner) { return {From: outer.From, FromKey: outer.FromKey, To: outer.To, ToKey: outer.ToKey, Year: outer.Year, Value: outer.Value, ResultFrom: inner.ResultFrom };}
				).Join(
					Enumerable.From(dataC).GroupBy(
							"{ F: $.From, T: $.To}",		//Keys
							"{ Value: $.Value }", 			//Collect
							function (key, group) { return { From: key.F, To: key.T, ResultTo: group.Max("$.Value")};},
							"$.F + $.T"						//Keys Comparefunction
							),
					"$.From+$.To", 
					"$.From+$.To",
					function (outer, inner) { return {From: outer.From, FromKey: outer.FromKey, To: outer.To, ToKey: outer.ToKey, Year: outer.Year, Value: outer.Value, ResultFrom: outer.ResultFrom, ResultTo: inner.ResultTo };}
				)
			.OrderByDescending("$.ResultFrom")	
			.ThenBy("$.FromKey")	 //without this sorting, objects with equal ResultFrom are not sorted correct (they are mixed: e.g., Turkey, Turkey, Portugal, Turkey,...)
			.ThenByDescending("$.ResultTo")			
			//.ThenByDescending("$.To")	
			.Select(function(value, index){ return value.FromKey * outputcountries.length + value.ToKey;})											
			.Distinct(function(x){return x;})
			.ToArray();	
						
		// Sort: Destination Total Maximimum
		destinitionTotalMax = 
			Enumerable.From(dataC)
				.Where("$.FromKey<" + inputcountries.length + " && $.ToKey<" + outputcountries.length)
				.Join(
					Enumerable.From(dataC)
						.Where("$.From==='ALL' && $.ToKey<" + outputcountries.length)
						.GroupBy(
							"{ T: $.To}",			//Keys
							"{ Value: $.Value }", 	//Collect
							function (key, group) { return { To: key.T, ResultTo: group.Max("$.Value")};},
							"$.T"					//Keys Comparefunction
							),
					"$.To", 
					"$.To",
					function (outer, inner) { return {From: outer.From, FromKey: outer.FromKey, To: outer.To, ToKey: outer.ToKey, Year: outer.Year, Value: outer.Value, ResultTo: inner.ResultTo };}
				).Join(
					Enumerable.From(dataC).GroupBy(
							"{ F: $.From, T: $.To}",		//Keys
							"{ Value: $.Value }", 			//Collect
							function (key, group) { return { From: key.F, To: key.T, ResultFrom: group.Max("$.Value")};},
							"$.F + $.T"						//Keys Comparefunction
							),
					"$.From+$.To", 
					"$.From+$.To",
					function (outer, inner) { return {From: outer.From, FromKey: outer.FromKey, To: outer.To, ToKey: outer.ToKey, Year: outer.Year, Value: outer.Value, ResultTo: outer.ResultTo, ResultFrom: inner.ResultFrom };}
				)
			.OrderByDescending("$.ResultTo")	
			.ThenBy("$.ToKey")	//without this sorting, objects with equal ResultFrom are not sorted correct (they are mixed: e.g., Turkey, Turkey, Portugal, Turkey,...)
			.ThenByDescending("$.ResultFrom")	
			.Select(function(value, index){ return value.FromKey * outputcountries.length + value.ToKey;})											
			.Distinct(function(x){return x;})
			.ToArray();	
			
		groupDestinitionTotalMax = Enumerable.From(dataC)
			.Where("$.FromKey<" + inputcountries.length + " && $.To==='ALL'")
			.GroupBy(
				"{ F: $.From}",			//Keys
				"{ Value: $.Value }", 	//Collect
				function (key, group) { return { From: key.F, ResultFrom: group.Max("$.Value")};},
				"$.F"					//Keys Comparefunction
			)
			.OrderByDescending("$.ResultFrom")
			.Select(function(value, index){return inputcountries.indexOf(value.From)})																			
			.ToArray();	
		
		groupOrignTotalMax = Enumerable.From(dataC)
			.Where("$.From==='ALL' && $.ToKey<" + outputcountries.length)
			.GroupBy(
				"{ T: $.To}",			//Keys
				"{ Value: $.Value }", 	//Collect
				function (key, group) { return { To: key.T, ResultTo: group.Max("$.Value")};},
				"$.T"					//Keys Comparefunction
			)
			.OrderByDescending("$.ResultTo")
			.Select(function(value, index){return outputcountries.indexOf(value.To)})																			
			.ToArray();	
		
		if (sorting == "tmp" || sorting=="originN2S")		actualIndicesHM = originN2S.slice();
		else if (sorting=="destinitionN2S")					actualIndicesHM = destinitionN2S.slice();
		else if (sorting=="originW2E")						actualIndicesHM = originW2E.slice();
		else if (sorting=="destinitionW2E")					actualIndicesHM = destinitionW2E.slice();
		else if (sorting=="avgValue")						actualIndicesHM = avgValue.slice();
		else if (sorting=="maxValue")						actualIndicesHM = maxValue.slice();
		else if (sorting=="avgDiff")						actualIndicesHM = avgDiff.slice();
		else if (sorting=="maxDiff")						actualIndicesHM = maxDiff.slice();
		else if (sorting=="avgRelDiff")						actualIndicesHM = avgRelDiff.slice();
		else if (sorting=="maxRelDiff")						actualIndicesHM = maxRelDiff.slice();
		else if (sorting=="orignTotalMax")					actualIndicesHM = orignTotalMax.slice();
		else if (sorting=="destinitionTotalMax")			actualIndicesHM = destinitionTotalMax.slice();		
	}

	/**
	 * Method, whichs returns the desired ordering.
	 */
	Sorting.prototype.GetSortingArray = function()
	{
		var obj = this;
		if(states.displaystate === 'normal')
		{
			if (sorting==="tmp")						return actualIndicesHM;
			else if (sorting==="originN2S")				return originN2S;
			else if (sorting==="destinitionN2S")		return destinitionN2S;
			else if (sorting==="originW2E")				return originW2E;
			else if (sorting==="destinitionW2E")		return destinitionW2E;
			else if (sorting==="avgValue")				return avgValue;
			else if (sorting==="maxValue")				return maxValue;
			else if (sorting==="avgDiff")				return avgDiff;
			else if (sorting==="maxDiff")				return maxDiff;
			else if (sorting==="avgRelDiff")			return avgRelDiff;
			else if (sorting==="maxRelDiff")			return maxRelDiff;
			else if (sorting==="orignTotalMax")			return orignTotalMax;
			else if (sorting==="destinitionTotalMax")	return destinitionTotalMax;
		}
		else if(states.displaystate === 'origin')
		{
			if (sorting == "tmp" || sorting=="originN2S")		return groupDestinitionN2S;
			else if (sorting=="destinitionN2S")					return groupDestinitionN2S;
			else if (sorting=="originW2E")						return groupDestinitionW2E;
			else if (sorting=="destinitionW2E")					return groupDestinitionW2E;
			else if (sorting=="avgValue")						return destinitionAvgValue;
			else if (sorting=="maxValue")						return destinitionMaxValue;
			else if (sorting=="avgDiff")						return destinitionAvgDiff;
			else if (sorting=="maxDiff")						return destinitionMaxDiff;
			else if (sorting=="avgRelDiff")						return destinitionAvgRelDiff;
			else if (sorting=="maxRelDiff")						return destinitionMaxRelDiff;
			else if (sorting=="orignTotalMax")					return groupDestinitionTotalMax;
			else if (sorting=="destinitionTotalMax")			return groupDestinitionTotalMax;
		}
		else if(states.displaystate === 'destinition')
		{
			if (sorting == "tmp" || sorting=="originN2S")		return groupOriginN2S;
			else if (sorting=="destinitionN2S")					return groupOriginN2S;
			else if (sorting=="originW2E")						return groupOriginW2E;
			else if (sorting=="destinitionW2E")					return groupOriginW2E;
			else if (sorting=="avgValue")						return originAvgValue;
			else if (sorting=="maxValue")						return originMaxValue;
			else if (sorting=="avgDiff")						return originAvgDiff;
			else if (sorting=="maxDiff")						return originMaxDiff;
			else if (sorting=="avgRelDiff")						return originAvgRelDiff;
			else if (sorting=="maxRelDiff")						return originMaxRelDiff;
			else if (sorting=="orignTotalMax")					return groupOrignTotalMax;
			else if (sorting=="destinitionTotalMax")			return groupOrignTotalMax;
		}
	}	
}