ToolTip = function (inputcountries, outputcountries, dictionaryFilesRight, dictionaryFilesLeft)
{	
	this.inputcountries 		= inputcountries;
	this.outputcountries		= outputcountries;
	this.dictionaryFilesRight	= dictionaryFilesRight;
	this.dictionaryFilesLeft	= dictionaryFilesLeft;
}

ToolTip.prototype.dataC					= null;
ToolTip.prototype.tooltipsRight			= [];
ToolTip.prototype.tooltipsLeft			= [];
ToolTip.prototype.tooltipsLeftRight		= [];
ToolTip.prototype.tooltipsTop3LeftRight	= [];
ToolTip.prototype.tooltipsTop3Right 	= [];
ToolTip.prototype.tooltipsTop3Left 		= [];
	
ToolTip.prototype.GetToolTip = function(side)
{
	if(side === 'R')	return 	this.tooltipsRight;
	else				return 	this.tooltipsLeft;
}

ToolTip.prototype.GetToolTipTop3 = function(side)
{
	if(side === 'R')	return 	this.tooltipsTop3Right;
	else				return 	this.tooltipsTop3Left;
}

ToolTip.prototype.Calculate = function()	
{	
	var obj = this;

	//Sum
	obj.inputcountries.forEach(function(d, i){		obj.tooltipsRight[i] 	= obj.CalcTooltipSum(1, i);	});		
	obj.outputcountries.forEach(function(d, i){ 	obj.tooltipsLeft[i] 	= obj.CalcTooltipSum(2, i);	});	
	obj.inputcountries.forEach(function(d, id_right)
	{		
		obj.tooltipsLeftRight[id_right] = [];
		obj.outputcountries.forEach(function(e, id_left)
		{			
			obj.tooltipsLeftRight[id_right][id_left] =  obj.CalcTooltipSum(0, id_right, id_left);		
		});
	});		
		
	obj.inputcountries.forEach(function(d, i){		obj.tooltipsTop3Right[i] = obj.CalcTooltipMaxEntriesCountry(1, i);	});		
	obj.outputcountries.forEach(function(d, i){		obj.tooltipsTop3Left[i]  = obj.CalcTooltipMaxEntriesCountry(2, i);	});		
	
	obj.inputcountries.forEach(function(d, id_right)
	{		
		obj.tooltipsTop3LeftRight[id_right] = [];		
		obj.outputcountries.forEach(function(e, id_left)
		{ 	
			obj.tooltipsTop3LeftRight[id_right][id_left] =  obj.CalcTooltipMaxEntriesVisualLinks(id_right, id_left);		
		});
	});			
}

ToolTip.prototype.CalcTooltipSum = function(type, from, to)
{
	var obj = this;
	if(states.auto_calcsum === true || type === 0)	
		return Enumerable.From(obj.dataC)				
				.Where(	(type === 0) ? "$.FromKey === "+ from + " && $.ToKey === " + to : 
						(type === 1) ? "$.FromKey === "+ from :     "$.ToKey === " + from)
				.GroupBy(	(type === 0) ? "{ F: $.From, T: $.To }" :
							(type === 1) ? "{ F: $.From }" : "{ T: $.To }" ,
							"{ Value: $.Value }",
							function (key, group) { return { From: key.F, To: key.T, Result: group.Sum("$.Value")};},
							"$.F + $.T"
					)				
				.Select(function(value, index){ return value.Result;})
				.ToArray()[0];	
	else
		return Enumerable.From(obj.dataC)				
				.Where(		(type === 1) ? "$.FromKey === "+ from +" && $.To === ALL"
										 : "$.ToKey === " + from + " && $.From === ALL")
				.GroupBy(	(type === 1) ? "{ F: $.From }" : "{ T: $.To }" ,
							"{ Value: $.Value }",
							function (key, group) { return { From: key.F, To: key.T, Result: group.Sum("$.Value")};},
							"$.F + $.T")				
				.Select(function(value, index){ return value.Result;})
				.ToArray()[0];
	
}

ToolTip.prototype.CalcTooltipMaxEntriesCountry = function(type, from)
{
	var obj = this;
	var res = Enumerable.From(obj.dataC)
				.Where(		(type === 1) ? "$.ToKey<"+ obj.outputcountries.length +" && $.FromKey === "+ from :  "$.FromKey<"+ obj.inputcountries.length +" && $.ToKey === " + from)
				.GroupBy(	"{ F: $.From, T: $.To }" ,
							"{ Value: $.Value }",
							function (key, group) { return { From: key.F, To: key.T, Result: group.Sum("$.Value")};},
							"$.F + $.T"
					)				
				.OrderByDescending("$.Result")	
				.Select(function(value, index){ return {From: value.From, To: value.To, Result: value.Result};})
				.ToArray();		
	var result = [];
	for(var i = 0; i < 3; i++)
	{			
		if(res.length >= 3)
		{
			if(type === 1)	result[i] = { Country: res[i].To, Result: res[i].Result };
			else			result[i] = { Country: res[i].From, Result: res[i].Result };
		}
		else
		{
			if(type === 1)	result[i] = { Country: "", Result: 0 };
			else			result[i] = { Country: "", Result: 0 };
		}
	}
	return result;
}

ToolTip.prototype.CalcTooltipMaxEntriesVisualLinks = function(from, to)
{
	var obj = this;
	var res = Enumerable.From(obj.dataC)
				.Where(		"$.FromKey<" + obj.inputcountries.length + " && $.ToKey<" + obj.outputcountries.length + " && $.FromKey === "+ from + " && $.ToKey === " + to)
				.OrderByDescending("$.Value")	
				.Select(function(value, index){ return {Year: value.Year, Result: value.Value};})
				.ToArray();		
	var result = [];
	for(var i = 0; i < 3; i++)
	{
		if(res.length > i)	result[i] = { Name: res[i].Year, Result: res[i].Result };		
		else				result[i] = { Name: 0, Result: 0 };		
	}
	return result;
}
