Tree = function(side, path, topo, width, fill_default, countries, dictionaryFiles, map_file, zoom, nodex, nodey, svg, g,
	addLabelName, addLabelX, addLabelY, groupingNames, groupingGroupStates, tooltip
)
{
	this.side					= side;	
	
	this.path 					= path;
	this.topo					= topo;
	
	this.active_country			= [];
	this.dictionaryFiles		= dictionaryFiles;
	this.map_file 				= map_file;
	this.nodex 					= nodex;
	this.nodey 					= nodey;
	this.width					= width;
	this.countries 				= countries;
	
	this.groupingNames 	= groupingNames;
	this.groupingGroupStates 	= groupingGroupStates;
	
	this.fill_default			= fill_default;
			
	this.zoom					= zoom;
	this.zoomed					= false;	
	this.translate				= [0,0];		
	this.scale					= 1;
	this.translate_default 		= [0,0];
	this.scale_default 			= 1;
	
	this.g = g;
	this.svg = svg;
	
	this.addLabelName = addLabelName;
	this.addLabelX = addLabelX;
	this.addLabelY = addLabelY;
	
	this.tooltip = tooltip;
}

Tree.prototype = new Drawing();
Tree.prototype.constructor = Tree;

Tree.prototype.Load = function(path2file)
{
	
}

Tree.prototype.Create = function(index2output, index2other, dots_size_default, dots_size_highlight, text_size_default, text_size_highlight)
{
	var obj = this;
	
	console.log("");
	console.log("");
	console.log("TREE");
	
	if(obj.topo !== null && obj.topo.length > 0)
	{
		obj.g.selectAll(".link")		
				.data(obj.topo)
			.enter().append("path")
				.attr("class", "country link")
				.style("fill", "none")
				.style("stroke", "#ccc")
				.style("stroke-width", "0.5px")
				.attr("d", obj.path);
	}
	if(obj.addLabelName && obj.addLabelName.length > 0)
	{
		obj.svg.selectAll(".addRowLabelTextg")
			.data(obj.addLabelName)		
		.enter()
			.append("text")
			.attr("x", function(d, i) { return obj.translate[0] + obj.scale *  obj.addLabelX[i];} )
			.attr("y", function(d, i) { return obj.translate[1] + obj.scale * (obj.addLabelY[i]-0.3);} )
			.attr("class","text addLabel"+obj.side)		  
			.style("text-anchor", "middle")
			.style("font-size", 0.4 * 20.0 +"pt")
			.text(function(d) { return d;});
	}
	this.Initialize(dots_size_default, dots_size_highlight, text_size_default, text_size_highlight);
	
	console.log("obj.translate_default: " + obj.translate_default + " " + obj.scale_default);
}

Tree.prototype.CalcZoomLevel = function()
{
	var obj = this;
	var x1 = 999.9, y1 = 999.9, x2 = -999.9, y2 = -999.9;					
	var dx = x2-x1,	dy = y2-y1,	x = (x1+x2) / 2,	y = (y1+y2) / 2;			
			
	if(obj.active_country.length === 1)
	{
		x = obj.nodex[obj.active_country[0]];
		y = obj.nodey[obj.active_country[0]];
		dx = 10;
		dy = 10;
	
		obj.scale = (50.0);
		obj.translate = ([	obj.width 		/ 2 - obj.scale * x,
							states.height 	/ 2 - obj.scale * y]);				
							
		console.log("obj.active_country[0]: " + obj.active_country[0]);
		console.log("x: " + x + " " + y);
		
		console.log("obj.width: " + obj.width + " " + states.width);
		console.log("translate: " + obj.translate);
	}
	else if(obj.active_country.length > 1)
	{
		x1 = 99999.9;		y1 = 999999.9;
		x2 = -99999.9;	y2 = -99999.9;
		
		obj.active_country.forEach(function(d, i)
		{
			x = obj.nodex[d];
			y = obj.nodey[d];
		
			x1 = Math.min(x1, x);	x2 = Math.max(x2, x);
			y1 = Math.min(y1, y);	y2 = Math.max(y2, y);
		});
		
		dx = x2-x1;
		dy = y2-y1;
		x = (x1+x2) / 2;
		y = (y1+y2) / 2;	
		
		obj.scale = (.9 / Math.max(dx /  obj.width, dy / states.height));
		obj.translate = ([obj.width / 2 - obj.scale * x, states.height / 2 - obj.scale * y]);	
	}
	
	if(isNaN(obj.scale))		obj.scale = obj.scale_default;
	if(isNaN(obj.translate[0])) obj.translate[0] = obj.translate_default[0];
	if(isNaN(obj.translate[1])) obj.translate[1] = obj.translate_default[1];

	console.log("obj.scale: " + obj.scale + " " + obj.translate);
	console.log("default: " + obj.scale_default + " " + obj.translate_default);
	
}

Tree.prototype.ZoomInOut = function(d, t, rowLabelFrom)
{
	
}

Tree.prototype.UpdatePositionAddLabel = function(t)
{
	var obj = this;
	if(t)
	{
		if(obj.addLabelName && obj.addLabelName.length > 0)
		{
			t.selectAll(".addLabel"+obj.side)
				.attr("x", function(d, i) { return obj.translate[0] + obj.scale *  obj.addLabelX[i];} )
				.attr("y", function(d, i) { return obj.translate[1] + obj.scale * (obj.addLabelY[i]-0.3);} );
		}
	}
	else
	{
		if(obj.addLabelName && obj.addLabelName.length > 0)
		{
			obj.svg.selectAll(".addLabel"+obj.side)
				.attr("x", function(d, i) { return obj.translate[0] + obj.scale *  obj.addLabelX[i];} )
				.attr("y", function(d, i) { return obj.translate[1] + obj.scale * (obj.addLabelY[i]-0.3);} );
		}
	}
}

Tree.prototype.move = function() 
{		
	var obj = this;
	if(d3.event && d3.event.translate && d3.event.translate !== null) 	obj.translate = d3.event.translate;
	if(d3.event && d3.event.scale && d3.event.scale !== null) 			obj.scale = d3.event.scale;
		
	console.log("move: " + obj.translate + " " + obj.scale);
		
	obj.g.attr("transform", "translate(" + obj.translate + ")scale(" + obj.scale + ")");
	if(obj.label) obj.label.UpdateLabelSelection(obj.svg);
	
	obj.UpdatePositionAddLabel();
}

Tree.prototype.fit = function()
{
	console.log("fit");
	var obj = this;
	if(obj.active_country.length <= 0) return;
	
	obj.CalcZoomLevel();	
	obj.zoomed = true;		
	obj.zoom.scale(obj.scale);
	obj.zoom.translate(obj.translate);
	
	console.log("translate: " + obj.translate + " " + obj.scale);
		
	obj.ZoomMap(states.animation_duration);		
	
	if(obj.side === 'L') 	callOrdering(states.animation_duration, false, false, false, true);
	else					callOrdering(states.animation_duration, false, false, true, false);
	
	obj.UpdatePositionAddLabel(obj.svg.transition().duration(states.animation_duration));
	
	return;
}

Tree.prototype.reset = function(d, i) 
{
	var obj = this;
	
	console.log("reset");
	obj.selected_country = false;
	
	obj.active_country.splice(0); 
	obj.countries.forEach(function(d){	if($.inArray(obj.dictionaryFiles[d][0], obj.groupingNames) === -1)	obj.active_country.push(obj.dictionaryFiles[d][0]);		});
	
	obj.zoomed = false;
	obj.translate[0] = obj.translate_default[0];
	obj.translate[1] = obj.translate_default[1];
	obj.scale= obj.scale_default;
	obj.zoom.scale(obj.scale);
	obj.zoom.translate(obj.translate);
	
	if(states.animation_duration > 0)	
		obj.g.transition()
			.duration(states.animation_duration)
			.style("opacity", "1.0")
			.attr("transform", "translate(" + obj.translate + ")scale(" + obj.scale + ")");
	else 
		obj.g.style("opacity", "1.0")
			.attr("transform", "translate(" + obj.translate + ")scale(" + obj.scale + ")");

	var t = svg_overall;
	if(states.animation_duration > 0)	t = svg_overall.transition().duration(states.animation_duration);
	t.selectAll(".rowLabel2").style("opacity", "1.0");		
	t.selectAll(".rowLabel").style("opacity", "1.0");												
	t.selectAll(".cell").style("opacity", "1.0");	
		
	if(obj.label) obj.label.UpdateLabelDefault(t);	
	
	callOrdering(states.animation_duration);
}